/* BaseTreeView.c generated by valac 0.44.3, the Vala compiler
 * generated from BaseTreeView.vala, do not modify */

/* BaseTreeView.vala
 *
 * Copyright (C) 2009 - 2019 Jerry Casiano
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.
 *
 * If not, see <http://www.gnu.org/licenses/gpl-3.0.txt>.
*/

#include <glib.h>
#include <gdk/gdk.h>
#include <glib-object.h>
#include <float.h>
#include <math.h>
#include <string.h>
#include <gtk/gtk.h>

#define TYPE_PENDING_EVENT (pending_event_get_type ())
typedef struct _PendingEvent PendingEvent;

#define FONT_MANAGER_TYPE_BASE_TREE_VIEW (font_manager_base_tree_view_get_type ())
#define FONT_MANAGER_BASE_TREE_VIEW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), FONT_MANAGER_TYPE_BASE_TREE_VIEW, FontManagerBaseTreeView))
#define FONT_MANAGER_BASE_TREE_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), FONT_MANAGER_TYPE_BASE_TREE_VIEW, FontManagerBaseTreeViewClass))
#define FONT_MANAGER_IS_BASE_TREE_VIEW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), FONT_MANAGER_TYPE_BASE_TREE_VIEW))
#define FONT_MANAGER_IS_BASE_TREE_VIEW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), FONT_MANAGER_TYPE_BASE_TREE_VIEW))
#define FONT_MANAGER_BASE_TREE_VIEW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), FONT_MANAGER_TYPE_BASE_TREE_VIEW, FontManagerBaseTreeViewClass))

typedef struct _FontManagerBaseTreeView FontManagerBaseTreeView;
typedef struct _FontManagerBaseTreeViewClass FontManagerBaseTreeViewClass;
typedef struct _FontManagerBaseTreeViewPrivate FontManagerBaseTreeViewPrivate;
enum  {
	FONT_MANAGER_BASE_TREE_VIEW_0_PROPERTY,
	FONT_MANAGER_BASE_TREE_VIEW_NUM_PROPERTIES
};
static GParamSpec* font_manager_base_tree_view_properties[FONT_MANAGER_BASE_TREE_VIEW_NUM_PROPERTIES];
typedef struct _Block5Data Block5Data;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define __vala_GtkTreePath_free0(var) ((var == NULL) ? NULL : (var = (_vala_GtkTreePath_free (var), NULL)))

struct _PendingEvent {
	gdouble x;
	gdouble y;
	gboolean active;
};

struct _FontManagerBaseTreeView {
	GtkTreeView parent_instance;
	FontManagerBaseTreeViewPrivate * priv;
};

struct _FontManagerBaseTreeViewClass {
	GtkTreeViewClass parent_class;
	gboolean (*show_context_menu) (FontManagerBaseTreeView* self, GdkEventButton* event);
};

struct _FontManagerBaseTreeViewPrivate {
	PendingEvent pending_event;
};

struct _Block5Data {
	int _ref_count_;
	FontManagerBaseTreeView* self;
	gboolean pending;
};

extern guint mask;
guint mask = (guint) (GDK_CONTROL_MASK | GDK_SHIFT_MASK);
static gint FontManagerBaseTreeView_private_offset;
static gpointer font_manager_base_tree_view_parent_class = NULL;

GType pending_event_get_type (void) G_GNUC_CONST;
PendingEvent* pending_event_dup (const PendingEvent* self);
void pending_event_free (PendingEvent* self);
void pending_event_update (PendingEvent *self,
                           gdouble x,
                           gdouble y,
                           gboolean active);
GType font_manager_base_tree_view_get_type (void) G_GNUC_CONST;
gboolean font_manager_base_tree_view_show_context_menu (FontManagerBaseTreeView* self,
                                                        GdkEventButton* event);
static gboolean font_manager_base_tree_view_real_show_context_menu (FontManagerBaseTreeView* self,
                                                             GdkEventButton* event);
static gboolean font_manager_base_tree_view_real_button_press_event (GtkWidget* base,
                                                              GdkEventButton* event);
static Block5Data* block5_data_ref (Block5Data* _data5_);
static void block5_data_unref (void * _userdata_);
static void _vala_GtkTreePath_free (GtkTreePath* self);
static gboolean __lambda30_ (Block5Data* _data5_,
                      GtkTreeSelection* s,
                      GtkTreeModel* m,
                      GtkTreePath* p,
                      gboolean b);
static gboolean ___lambda30__gtk_tree_selection_func (GtkTreeSelection* selection,
                                               GtkTreeModel* model,
                                               GtkTreePath* path,
                                               gboolean path_currently_selected,
                                               gpointer self);
static gboolean font_manager_base_tree_view_real_button_release_event (GtkWidget* base,
                                                                GdkEventButton* event);
static gboolean ___lambda31_ (FontManagerBaseTreeView* self,
                       GtkTreeSelection* s,
                       GtkTreeModel* m,
                       GtkTreePath* p,
                       gboolean b);
static gboolean ____lambda31__gtk_tree_selection_func (GtkTreeSelection* selection,
                                                GtkTreeModel* model,
                                                GtkTreePath* path,
                                                gboolean path_currently_selected,
                                                gpointer self);
FontManagerBaseTreeView* font_manager_base_tree_view_new (void);
FontManagerBaseTreeView* font_manager_base_tree_view_construct (GType object_type);
static GObject * font_manager_base_tree_view_constructor (GType type,
                                                   guint n_construct_properties,
                                                   GObjectConstructParam * construct_properties);
static void font_manager_base_tree_view_finalize (GObject * obj);

void
pending_event_update (PendingEvent *self,
                      gdouble x,
                      gdouble y,
                      gboolean active)
{
#line 30 "../src/font-manager/BaseTreeView.vala"
	(*self).x = x;
#line 31 "../src/font-manager/BaseTreeView.vala"
	(*self).y = y;
#line 32 "../src/font-manager/BaseTreeView.vala"
	(*self).active = active;
#line 33 "../src/font-manager/BaseTreeView.vala"
	return;
#line 146 "BaseTreeView.c"
}

PendingEvent*
pending_event_dup (const PendingEvent* self)
{
	PendingEvent* dup;
#line 23 "../src/font-manager/BaseTreeView.vala"
	dup = g_new0 (PendingEvent, 1);
#line 23 "../src/font-manager/BaseTreeView.vala"
	memcpy (dup, self, sizeof (PendingEvent));
#line 23 "../src/font-manager/BaseTreeView.vala"
	return dup;
#line 159 "BaseTreeView.c"
}

void
pending_event_free (PendingEvent* self)
{
#line 23 "../src/font-manager/BaseTreeView.vala"
	g_free (self);
#line 167 "BaseTreeView.c"
}

GType
pending_event_get_type (void)
{
	static volatile gsize pending_event_type_id__volatile = 0;
	if (g_once_init_enter (&pending_event_type_id__volatile)) {
		GType pending_event_type_id;
		pending_event_type_id = g_boxed_type_register_static ("PendingEvent", (GBoxedCopyFunc) pending_event_dup, (GBoxedFreeFunc) pending_event_free);
		g_once_init_leave (&pending_event_type_id__volatile, pending_event_type_id);
	}
	return pending_event_type_id__volatile;
}

static inline gpointer
font_manager_base_tree_view_get_instance_private (FontManagerBaseTreeView* self)
{
	return G_STRUCT_MEMBER_P (self, FontManagerBaseTreeView_private_offset);
}

/**
         * show_context_menu:
         *
         * Called on right click events.
         *
         * Returns:     %TRUE to stop other handlers from being invoked for the event.
         *              %FALSE to propagate the event further.
         */
static gboolean
font_manager_base_tree_view_real_show_context_menu (FontManagerBaseTreeView* self,
                                                    GdkEventButton* event)
{
	gboolean result = FALSE;
#line 61 "../src/font-manager/BaseTreeView.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 62 "../src/font-manager/BaseTreeView.vala"
	result = GTK_WIDGET_CLASS (font_manager_base_tree_view_parent_class)->button_press_event ((GtkWidget*) G_TYPE_CHECK_INSTANCE_CAST (self, gtk_tree_view_get_type (), GtkTreeView), event);
#line 62 "../src/font-manager/BaseTreeView.vala"
	return result;
#line 207 "BaseTreeView.c"
}

gboolean
font_manager_base_tree_view_show_context_menu (FontManagerBaseTreeView* self,
                                               GdkEventButton* event)
{
#line 61 "../src/font-manager/BaseTreeView.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 61 "../src/font-manager/BaseTreeView.vala"
	return FONT_MANAGER_BASE_TREE_VIEW_GET_CLASS (self)->show_context_menu (self, event);
#line 218 "BaseTreeView.c"
}

/**
         * {@inheritDoc}
         */
static Block5Data*
block5_data_ref (Block5Data* _data5_)
{
#line 68 "../src/font-manager/BaseTreeView.vala"
	g_atomic_int_inc (&_data5_->_ref_count_);
#line 68 "../src/font-manager/BaseTreeView.vala"
	return _data5_;
#line 231 "BaseTreeView.c"
}

static void
block5_data_unref (void * _userdata_)
{
	Block5Data* _data5_;
	_data5_ = (Block5Data*) _userdata_;
#line 68 "../src/font-manager/BaseTreeView.vala"
	if (g_atomic_int_dec_and_test (&_data5_->_ref_count_)) {
#line 241 "BaseTreeView.c"
		FontManagerBaseTreeView* self;
#line 68 "../src/font-manager/BaseTreeView.vala"
		self = _data5_->self;
#line 68 "../src/font-manager/BaseTreeView.vala"
		_g_object_unref0 (self);
#line 68 "../src/font-manager/BaseTreeView.vala"
		g_slice_free (Block5Data, _data5_);
#line 249 "BaseTreeView.c"
	}
}

static void
_vala_GtkTreePath_free (GtkTreePath* self)
{
#line 72 "../src/font-manager/BaseTreeView.vala"
	g_boxed_free (gtk_tree_path_get_type (), self);
#line 258 "BaseTreeView.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 75 "../src/font-manager/BaseTreeView.vala"
	return self ? g_object_ref (self) : NULL;
#line 266 "BaseTreeView.c"
}

static gboolean
__lambda30_ (Block5Data* _data5_,
             GtkTreeSelection* s,
             GtkTreeModel* m,
             GtkTreePath* p,
             gboolean b)
{
	FontManagerBaseTreeView* self;
	gboolean result = FALSE;
#line 78 "../src/font-manager/BaseTreeView.vala"
	self = _data5_->self;
#line 78 "../src/font-manager/BaseTreeView.vala"
	g_return_val_if_fail (s != NULL, FALSE);
#line 78 "../src/font-manager/BaseTreeView.vala"
	g_return_val_if_fail (m != NULL, FALSE);
#line 78 "../src/font-manager/BaseTreeView.vala"
	g_return_val_if_fail (p != NULL, FALSE);
#line 78 "../src/font-manager/BaseTreeView.vala"
	result = !_data5_->pending;
#line 78 "../src/font-manager/BaseTreeView.vala"
	return result;
#line 290 "BaseTreeView.c"
}

static gboolean
___lambda30__gtk_tree_selection_func (GtkTreeSelection* selection,
                                      GtkTreeModel* model,
                                      GtkTreePath* path,
                                      gboolean path_currently_selected,
                                      gpointer self)
{
	gboolean result;
	result = __lambda30_ (self, selection, model, path, path_currently_selected);
#line 78 "../src/font-manager/BaseTreeView.vala"
	return result;
#line 304 "BaseTreeView.c"
}

static gboolean
font_manager_base_tree_view_real_button_press_event (GtkWidget* base,
                                                     GdkEventButton* event)
{
	FontManagerBaseTreeView * self;
	gboolean result = FALSE;
	Block5Data* _data5_;
	gboolean _tmp0_ = FALSE;
	GtkTreePath* path = NULL;
	GtkTreePath* _tmp2_ = NULL;
	GtkTreePath* _tmp3_;
	GtkTreeSelection* selection = NULL;
	GtkTreeSelection* _tmp4_;
	GtkTreeSelection* _tmp5_;
	gboolean _tmp6_ = FALSE;
	GtkTreeSelection* _tmp7_;
	GtkTreePath* _tmp8_;
	GtkTreeSelection* _tmp10_;
#line 68 "../src/font-manager/BaseTreeView.vala"
	self = (FontManagerBaseTreeView*) base;
#line 68 "../src/font-manager/BaseTreeView.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 68 "../src/font-manager/BaseTreeView.vala"
	_data5_ = g_slice_new0 (Block5Data);
#line 68 "../src/font-manager/BaseTreeView.vala"
	_data5_->_ref_count_ = 1;
#line 68 "../src/font-manager/BaseTreeView.vala"
	_data5_->self = g_object_ref (self);
#line 69 "../src/font-manager/BaseTreeView.vala"
	if (gdk_event_triggers_context_menu ((GdkEvent*) event)) {
#line 337 "BaseTreeView.c"
		GdkEventType _tmp1_;
#line 69 "../src/font-manager/BaseTreeView.vala"
		_tmp1_ = event->type;
#line 69 "../src/font-manager/BaseTreeView.vala"
		_tmp0_ = _tmp1_ == GDK_BUTTON_PRESS;
#line 343 "BaseTreeView.c"
	} else {
#line 69 "../src/font-manager/BaseTreeView.vala"
		_tmp0_ = FALSE;
#line 347 "BaseTreeView.c"
	}
#line 69 "../src/font-manager/BaseTreeView.vala"
	if (_tmp0_) {
#line 70 "../src/font-manager/BaseTreeView.vala"
		result = font_manager_base_tree_view_show_context_menu (self, event);
#line 70 "../src/font-manager/BaseTreeView.vala"
		block5_data_unref (_data5_);
#line 70 "../src/font-manager/BaseTreeView.vala"
		_data5_ = NULL;
#line 70 "../src/font-manager/BaseTreeView.vala"
		return result;
#line 359 "BaseTreeView.c"
	}
#line 72 "../src/font-manager/BaseTreeView.vala"
	gtk_tree_view_get_path_at_pos ((GtkTreeView*) self, (gint) event->x, (gint) event->y, &_tmp2_, NULL, NULL, NULL);
#line 72 "../src/font-manager/BaseTreeView.vala"
	__vala_GtkTreePath_free0 (path);
#line 72 "../src/font-manager/BaseTreeView.vala"
	path = _tmp2_;
#line 73 "../src/font-manager/BaseTreeView.vala"
	_tmp3_ = path;
#line 73 "../src/font-manager/BaseTreeView.vala"
	if (_tmp3_ == NULL) {
#line 74 "../src/font-manager/BaseTreeView.vala"
		result = TRUE;
#line 74 "../src/font-manager/BaseTreeView.vala"
		__vala_GtkTreePath_free0 (path);
#line 74 "../src/font-manager/BaseTreeView.vala"
		block5_data_unref (_data5_);
#line 74 "../src/font-manager/BaseTreeView.vala"
		_data5_ = NULL;
#line 74 "../src/font-manager/BaseTreeView.vala"
		return result;
#line 381 "BaseTreeView.c"
	}
#line 75 "../src/font-manager/BaseTreeView.vala"
	_tmp4_ = gtk_tree_view_get_selection ((GtkTreeView*) self);
#line 75 "../src/font-manager/BaseTreeView.vala"
	_tmp5_ = _g_object_ref0 (_tmp4_);
#line 75 "../src/font-manager/BaseTreeView.vala"
	selection = _tmp5_;
#line 76 "../src/font-manager/BaseTreeView.vala"
	_tmp7_ = selection;
#line 76 "../src/font-manager/BaseTreeView.vala"
	_tmp8_ = path;
#line 76 "../src/font-manager/BaseTreeView.vala"
	if (gtk_tree_selection_path_is_selected (_tmp7_, _tmp8_)) {
#line 395 "BaseTreeView.c"
		GdkModifierType _tmp9_;
#line 76 "../src/font-manager/BaseTreeView.vala"
		_tmp9_ = event->state;
#line 76 "../src/font-manager/BaseTreeView.vala"
		_tmp6_ = (_tmp9_ & mask) == 0;
#line 401 "BaseTreeView.c"
	} else {
#line 76 "../src/font-manager/BaseTreeView.vala"
		_tmp6_ = FALSE;
#line 405 "BaseTreeView.c"
	}
#line 76 "../src/font-manager/BaseTreeView.vala"
	_data5_->pending = _tmp6_;
#line 77 "../src/font-manager/BaseTreeView.vala"
	pending_event_update (&self->priv->pending_event, event->x, event->y, _data5_->pending);
#line 78 "../src/font-manager/BaseTreeView.vala"
	_tmp10_ = selection;
#line 78 "../src/font-manager/BaseTreeView.vala"
	gtk_tree_selection_set_select_function (_tmp10_, ___lambda30__gtk_tree_selection_func, block5_data_ref (_data5_), block5_data_unref);
#line 79 "../src/font-manager/BaseTreeView.vala"
	result = GTK_WIDGET_CLASS (font_manager_base_tree_view_parent_class)->button_press_event ((GtkWidget*) G_TYPE_CHECK_INSTANCE_CAST (self, gtk_tree_view_get_type (), GtkTreeView), event);
#line 79 "../src/font-manager/BaseTreeView.vala"
	_g_object_unref0 (selection);
#line 79 "../src/font-manager/BaseTreeView.vala"
	__vala_GtkTreePath_free0 (path);
#line 79 "../src/font-manager/BaseTreeView.vala"
	block5_data_unref (_data5_);
#line 79 "../src/font-manager/BaseTreeView.vala"
	_data5_ = NULL;
#line 79 "../src/font-manager/BaseTreeView.vala"
	return result;
#line 427 "BaseTreeView.c"
}

/**
         * {@inheritDoc}
         */
static gboolean
___lambda31_ (FontManagerBaseTreeView* self,
              GtkTreeSelection* s,
              GtkTreeModel* m,
              GtkTreePath* p,
              gboolean b)
{
	gboolean result = FALSE;
#line 88 "../src/font-manager/BaseTreeView.vala"
	g_return_val_if_fail (s != NULL, FALSE);
#line 88 "../src/font-manager/BaseTreeView.vala"
	g_return_val_if_fail (m != NULL, FALSE);
#line 88 "../src/font-manager/BaseTreeView.vala"
	g_return_val_if_fail (p != NULL, FALSE);
#line 88 "../src/font-manager/BaseTreeView.vala"
	result = TRUE;
#line 88 "../src/font-manager/BaseTreeView.vala"
	return result;
#line 451 "BaseTreeView.c"
}

static gboolean
____lambda31__gtk_tree_selection_func (GtkTreeSelection* selection,
                                       GtkTreeModel* model,
                                       GtkTreePath* path,
                                       gboolean path_currently_selected,
                                       gpointer self)
{
	gboolean result;
	result = ___lambda31_ ((FontManagerBaseTreeView*) self, selection, model, path, path_currently_selected);
#line 88 "../src/font-manager/BaseTreeView.vala"
	return result;
#line 465 "BaseTreeView.c"
}

static gboolean
font_manager_base_tree_view_real_button_release_event (GtkWidget* base,
                                                       GdkEventButton* event)
{
	FontManagerBaseTreeView * self;
	gboolean result = FALSE;
	PendingEvent _tmp0_;
#line 85 "../src/font-manager/BaseTreeView.vala"
	self = (FontManagerBaseTreeView*) base;
#line 85 "../src/font-manager/BaseTreeView.vala"
	g_return_val_if_fail (event != NULL, FALSE);
#line 86 "../src/font-manager/BaseTreeView.vala"
	_tmp0_ = self->priv->pending_event;
#line 86 "../src/font-manager/BaseTreeView.vala"
	if (_tmp0_.active) {
#line 483 "BaseTreeView.c"
		GtkTreeSelection* selection = NULL;
		GtkTreeSelection* _tmp1_;
		GtkTreeSelection* _tmp2_;
		GtkTreeSelection* _tmp3_;
		gboolean _tmp4_ = FALSE;
		PendingEvent _tmp5_;
		GtkTreePath* path = NULL;
		GtkTreePath* _tmp7_ = NULL;
		gboolean _tmp8_;
#line 87 "../src/font-manager/BaseTreeView.vala"
		_tmp1_ = gtk_tree_view_get_selection ((GtkTreeView*) self);
#line 87 "../src/font-manager/BaseTreeView.vala"
		_tmp2_ = _g_object_ref0 (_tmp1_);
#line 87 "../src/font-manager/BaseTreeView.vala"
		selection = _tmp2_;
#line 88 "../src/font-manager/BaseTreeView.vala"
		_tmp3_ = selection;
#line 88 "../src/font-manager/BaseTreeView.vala"
		gtk_tree_selection_set_select_function (_tmp3_, ____lambda31__gtk_tree_selection_func, g_object_ref (self), g_object_unref);
#line 89 "../src/font-manager/BaseTreeView.vala"
		self->priv->pending_event.active = FALSE;
#line 90 "../src/font-manager/BaseTreeView.vala"
		_tmp5_ = self->priv->pending_event;
#line 90 "../src/font-manager/BaseTreeView.vala"
		if (_tmp5_.x != event->x) {
#line 90 "../src/font-manager/BaseTreeView.vala"
			_tmp4_ = TRUE;
#line 511 "BaseTreeView.c"
		} else {
			PendingEvent _tmp6_;
#line 90 "../src/font-manager/BaseTreeView.vala"
			_tmp6_ = self->priv->pending_event;
#line 90 "../src/font-manager/BaseTreeView.vala"
			_tmp4_ = _tmp6_.y != event->y;
#line 518 "BaseTreeView.c"
		}
#line 90 "../src/font-manager/BaseTreeView.vala"
		if (_tmp4_) {
#line 91 "../src/font-manager/BaseTreeView.vala"
			result = TRUE;
#line 91 "../src/font-manager/BaseTreeView.vala"
			_g_object_unref0 (selection);
#line 91 "../src/font-manager/BaseTreeView.vala"
			return result;
#line 528 "BaseTreeView.c"
		}
#line 93 "../src/font-manager/BaseTreeView.vala"
		_tmp8_ = gtk_tree_view_get_path_at_pos ((GtkTreeView*) self, (gint) event->x, (gint) event->y, &_tmp7_, NULL, NULL, NULL);
#line 93 "../src/font-manager/BaseTreeView.vala"
		__vala_GtkTreePath_free0 (path);
#line 93 "../src/font-manager/BaseTreeView.vala"
		path = _tmp7_;
#line 93 "../src/font-manager/BaseTreeView.vala"
		if (_tmp8_) {
#line 538 "BaseTreeView.c"
			GtkTreePath* _tmp9_;
#line 94 "../src/font-manager/BaseTreeView.vala"
			_tmp9_ = path;
#line 94 "../src/font-manager/BaseTreeView.vala"
			gtk_tree_view_set_cursor ((GtkTreeView*) self, _tmp9_, NULL, FALSE);
#line 544 "BaseTreeView.c"
		}
#line 86 "../src/font-manager/BaseTreeView.vala"
		__vala_GtkTreePath_free0 (path);
#line 86 "../src/font-manager/BaseTreeView.vala"
		_g_object_unref0 (selection);
#line 550 "BaseTreeView.c"
	}
#line 96 "../src/font-manager/BaseTreeView.vala"
	result = GTK_WIDGET_CLASS (font_manager_base_tree_view_parent_class)->button_release_event ((GtkWidget*) G_TYPE_CHECK_INSTANCE_CAST (self, gtk_tree_view_get_type (), GtkTreeView), event);
#line 96 "../src/font-manager/BaseTreeView.vala"
	return result;
#line 556 "BaseTreeView.c"
}

FontManagerBaseTreeView*
font_manager_base_tree_view_construct (GType object_type)
{
	FontManagerBaseTreeView * self = NULL;
#line 45 "../src/font-manager/BaseTreeView.vala"
	self = (FontManagerBaseTreeView*) g_object_new (object_type, NULL);
#line 45 "../src/font-manager/BaseTreeView.vala"
	return self;
#line 567 "BaseTreeView.c"
}

FontManagerBaseTreeView*
font_manager_base_tree_view_new (void)
{
#line 45 "../src/font-manager/BaseTreeView.vala"
	return font_manager_base_tree_view_construct (FONT_MANAGER_TYPE_BASE_TREE_VIEW);
#line 575 "BaseTreeView.c"
}

static GObject *
font_manager_base_tree_view_constructor (GType type,
                                         guint n_construct_properties,
                                         GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	FontManagerBaseTreeView * self;
#line 49 "../src/font-manager/BaseTreeView.vala"
	parent_class = G_OBJECT_CLASS (font_manager_base_tree_view_parent_class);
#line 49 "../src/font-manager/BaseTreeView.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 49 "../src/font-manager/BaseTreeView.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, FONT_MANAGER_TYPE_BASE_TREE_VIEW, FontManagerBaseTreeView);
#line 50 "../src/font-manager/BaseTreeView.vala"
	memset (&self->priv->pending_event, 0, sizeof (PendingEvent));
#line 49 "../src/font-manager/BaseTreeView.vala"
	return obj;
#line 596 "BaseTreeView.c"
}

static void
font_manager_base_tree_view_class_init (FontManagerBaseTreeViewClass * klass,
                                        gpointer klass_data)
{
#line 45 "../src/font-manager/BaseTreeView.vala"
	font_manager_base_tree_view_parent_class = g_type_class_peek_parent (klass);
#line 45 "../src/font-manager/BaseTreeView.vala"
	g_type_class_adjust_private_offset (klass, &FontManagerBaseTreeView_private_offset);
#line 45 "../src/font-manager/BaseTreeView.vala"
	((FontManagerBaseTreeViewClass *) klass)->show_context_menu = (gboolean (*) (FontManagerBaseTreeView*, GdkEventButton*)) font_manager_base_tree_view_real_show_context_menu;
#line 45 "../src/font-manager/BaseTreeView.vala"
	((GtkWidgetClass *) klass)->button_press_event = (gboolean (*) (GtkWidget*, GdkEventButton*)) font_manager_base_tree_view_real_button_press_event;
#line 45 "../src/font-manager/BaseTreeView.vala"
	((GtkWidgetClass *) klass)->button_release_event = (gboolean (*) (GtkWidget*, GdkEventButton*)) font_manager_base_tree_view_real_button_release_event;
#line 45 "../src/font-manager/BaseTreeView.vala"
	G_OBJECT_CLASS (klass)->constructor = font_manager_base_tree_view_constructor;
#line 45 "../src/font-manager/BaseTreeView.vala"
	G_OBJECT_CLASS (klass)->finalize = font_manager_base_tree_view_finalize;
#line 617 "BaseTreeView.c"
}

static void
font_manager_base_tree_view_instance_init (FontManagerBaseTreeView * self,
                                           gpointer klass)
{
#line 45 "../src/font-manager/BaseTreeView.vala"
	self->priv = font_manager_base_tree_view_get_instance_private (self);
#line 626 "BaseTreeView.c"
}

static void
font_manager_base_tree_view_finalize (GObject * obj)
{
	FontManagerBaseTreeView * self;
#line 45 "../src/font-manager/BaseTreeView.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, FONT_MANAGER_TYPE_BASE_TREE_VIEW, FontManagerBaseTreeView);
#line 45 "../src/font-manager/BaseTreeView.vala"
	G_OBJECT_CLASS (font_manager_base_tree_view_parent_class)->finalize (obj);
#line 637 "BaseTreeView.c"
}

/**
     * BaseTreeView:
     *
     * #GtkTreeView which supports multiple selection drag and drop
     */
GType
font_manager_base_tree_view_get_type (void)
{
	static volatile gsize font_manager_base_tree_view_type_id__volatile = 0;
	if (g_once_init_enter (&font_manager_base_tree_view_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (FontManagerBaseTreeViewClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) font_manager_base_tree_view_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (FontManagerBaseTreeView), 0, (GInstanceInitFunc) font_manager_base_tree_view_instance_init, NULL };
		GType font_manager_base_tree_view_type_id;
		font_manager_base_tree_view_type_id = g_type_register_static (gtk_tree_view_get_type (), "FontManagerBaseTreeView", &g_define_type_info, 0);
		FontManagerBaseTreeView_private_offset = g_type_add_instance_private (font_manager_base_tree_view_type_id, sizeof (FontManagerBaseTreeViewPrivate));
		g_once_init_leave (&font_manager_base_tree_view_type_id__volatile, font_manager_base_tree_view_type_id);
	}
	return font_manager_base_tree_view_type_id__volatile;
}

