/* FontConfig.c generated by valac 0.44.3, the Vala compiler
 * generated from FontConfig.vala, do not modify */

/* FontConfig.vala
 *
 * Copyright (C) 2009 - 2019 Jerry Casiano
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.
 *
 * If not, see <http://www.gnu.org/licenses/gpl-3.0.txt>.
*/

#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <glib/gi18n-lib.h>
#include "string-hashset.h"
#include "font-manager-source.h"
#include "font-manager-fontconfig.h"
#include "utils.h"
#include "font-manager-properties.h"
#include "font-manager-font.h"
#include "font-manager-xml-writer.h"
#include "font-manager-json-proxy.h"
#include "font-manager-selections.h"
#include <libxml/tree.h>
#include <libxml/parser.h>
#include "font-manager-database.h"
#include <sqlite3.h>
#include <gio/gio.h>

typedef enum  {
	FONT_MANAGER_WIDTH_ULTRACONDENSED = 50,
	FONT_MANAGER_WIDTH_EXTRACONDENSED = 63,
	FONT_MANAGER_WIDTH_CONDENSED = 75,
	FONT_MANAGER_WIDTH_SEMICONDENSED = 87,
	FONT_MANAGER_WIDTH_NORMAL = 100,
	FONT_MANAGER_WIDTH_SEMIEXPANDED = 113,
	FONT_MANAGER_WIDTH_EXPANDED = 125,
	FONT_MANAGER_WIDTH_EXTRAEXPANDED = 150,
	FONT_MANAGER_WIDTH_ULTRAEXPANDED = 200
} FontManagerWidth;

#define FONT_MANAGER_TYPE_WIDTH (font_manager_width_get_type ())
typedef enum  {
	FONT_MANAGER_SLANT_ROMAN = 0,
	FONT_MANAGER_SLANT_ITALIC = 100,
	FONT_MANAGER_SLANT_OBLIQUE = 110
} FontManagerSlant;

#define FONT_MANAGER_TYPE_SLANT (font_manager_slant_get_type ())
typedef enum  {
	FONT_MANAGER_WEIGHT_THIN = 0,
	FONT_MANAGER_WEIGHT_EXTRALIGHT = 40,
	FONT_MANAGER_WEIGHT_ULTRALIGHT = 40,
	FONT_MANAGER_WEIGHT_LIGHT = 50,
	FONT_MANAGER_WEIGHT_BOOK = 75,
	FONT_MANAGER_WEIGHT_REGULAR = 80,
	FONT_MANAGER_WEIGHT_NORMAL = 80,
	FONT_MANAGER_WEIGHT_MEDIUM = 100,
	FONT_MANAGER_WEIGHT_DEMIBOLD = 180,
	FONT_MANAGER_WEIGHT_SEMIBOLD = 180,
	FONT_MANAGER_WEIGHT_BOLD = 200,
	FONT_MANAGER_WEIGHT_EXTRABOLD = 205,
	FONT_MANAGER_WEIGHT_BLACK = 210,
	FONT_MANAGER_WEIGHT_HEAVY = 210,
	FONT_MANAGER_WEIGHT_EXTRABLACK = 215,
	FONT_MANAGER_WEIGHT_ULTRABLACK = 215
} FontManagerWeight;

#define FONT_MANAGER_TYPE_WEIGHT (font_manager_weight_get_type ())
typedef enum  {
	FONT_MANAGER_SPACING_PROPORTIONAL = 0,
	FONT_MANAGER_SPACING_DUAL = 90,
	FONT_MANAGER_SPACING_MONO = 100,
	FONT_MANAGER_SPACING_CHARCELL = 110
} FontManagerSpacing;

#define FONT_MANAGER_TYPE_SPACING (font_manager_spacing_get_type ())
typedef enum  {
	FONT_MANAGER_HINT_STYLE_NONE,
	FONT_MANAGER_HINT_STYLE_SLIGHT,
	FONT_MANAGER_HINT_STYLE_MEDIUM,
	FONT_MANAGER_HINT_STYLE_FULL
} FontManagerHintStyle;

#define FONT_MANAGER_TYPE_HINT_STYLE (font_manager_hint_style_get_type ())
typedef enum  {
	FONT_MANAGER_LCD_FILTER_NONE,
	FONT_MANAGER_LCD_FILTER_DEFAULT,
	FONT_MANAGER_LCD_FILTER_LIGHT,
	FONT_MANAGER_LCD_FILTER_LEGACY
} FontManagerLCDFilter;

#define FONT_MANAGER_TYPE_LCD_FILTER (font_manager_lcd_filter_get_type ())
typedef enum  {
	FONT_MANAGER_SUBPIXEL_ORDER_UNKNOWN,
	FONT_MANAGER_SUBPIXEL_ORDER_RGB,
	FONT_MANAGER_SUBPIXEL_ORDER_BGR,
	FONT_MANAGER_SUBPIXEL_ORDER_VRGB,
	FONT_MANAGER_SUBPIXEL_ORDER_VBGR,
	FONT_MANAGER_SUBPIXEL_ORDER_NONE
} FontManagerSubpixelOrder;

#define FONT_MANAGER_TYPE_SUBPIXEL_ORDER (font_manager_subpixel_order_get_type ())
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

#define FONT_MANAGER_TYPE_DEFAULT_PROPERTIES (font_manager_default_properties_get_type ())
#define FONT_MANAGER_DEFAULT_PROPERTIES(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), FONT_MANAGER_TYPE_DEFAULT_PROPERTIES, FontManagerDefaultProperties))
#define FONT_MANAGER_DEFAULT_PROPERTIES_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), FONT_MANAGER_TYPE_DEFAULT_PROPERTIES, FontManagerDefaultPropertiesClass))
#define FONT_MANAGER_IS_DEFAULT_PROPERTIES(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), FONT_MANAGER_TYPE_DEFAULT_PROPERTIES))
#define FONT_MANAGER_IS_DEFAULT_PROPERTIES_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), FONT_MANAGER_TYPE_DEFAULT_PROPERTIES))
#define FONT_MANAGER_DEFAULT_PROPERTIES_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), FONT_MANAGER_TYPE_DEFAULT_PROPERTIES, FontManagerDefaultPropertiesClass))

typedef struct _FontManagerDefaultProperties FontManagerDefaultProperties;
typedef struct _FontManagerDefaultPropertiesClass FontManagerDefaultPropertiesClass;
typedef struct _FontManagerDefaultPropertiesPrivate FontManagerDefaultPropertiesPrivate;
enum  {
	FONT_MANAGER_DEFAULT_PROPERTIES_0_PROPERTY,
	FONT_MANAGER_DEFAULT_PROPERTIES_NUM_PROPERTIES
};
static GParamSpec* font_manager_default_properties_properties[FONT_MANAGER_DEFAULT_PROPERTIES_NUM_PROPERTIES];

#define FONT_MANAGER_TYPE_DISPLAY_PROPERTIES (font_manager_display_properties_get_type ())
#define FONT_MANAGER_DISPLAY_PROPERTIES(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), FONT_MANAGER_TYPE_DISPLAY_PROPERTIES, FontManagerDisplayProperties))
#define FONT_MANAGER_DISPLAY_PROPERTIES_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), FONT_MANAGER_TYPE_DISPLAY_PROPERTIES, FontManagerDisplayPropertiesClass))
#define FONT_MANAGER_IS_DISPLAY_PROPERTIES(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), FONT_MANAGER_TYPE_DISPLAY_PROPERTIES))
#define FONT_MANAGER_IS_DISPLAY_PROPERTIES_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), FONT_MANAGER_TYPE_DISPLAY_PROPERTIES))
#define FONT_MANAGER_DISPLAY_PROPERTIES_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), FONT_MANAGER_TYPE_DISPLAY_PROPERTIES, FontManagerDisplayPropertiesClass))

typedef struct _FontManagerDisplayProperties FontManagerDisplayProperties;
typedef struct _FontManagerDisplayPropertiesClass FontManagerDisplayPropertiesClass;
typedef struct _FontManagerDisplayPropertiesPrivate FontManagerDisplayPropertiesPrivate;
enum  {
	FONT_MANAGER_DISPLAY_PROPERTIES_0_PROPERTY,
	FONT_MANAGER_DISPLAY_PROPERTIES_NUM_PROPERTIES
};
static GParamSpec* font_manager_display_properties_properties[FONT_MANAGER_DISPLAY_PROPERTIES_NUM_PROPERTIES];

#define FONT_MANAGER_TYPE_FONT_PROPERTIES (font_manager_font_properties_get_type ())
#define FONT_MANAGER_FONT_PROPERTIES(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), FONT_MANAGER_TYPE_FONT_PROPERTIES, FontManagerFontProperties))
#define FONT_MANAGER_FONT_PROPERTIES_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), FONT_MANAGER_TYPE_FONT_PROPERTIES, FontManagerFontPropertiesClass))
#define FONT_MANAGER_IS_FONT_PROPERTIES(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), FONT_MANAGER_TYPE_FONT_PROPERTIES))
#define FONT_MANAGER_IS_FONT_PROPERTIES_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), FONT_MANAGER_TYPE_FONT_PROPERTIES))
#define FONT_MANAGER_FONT_PROPERTIES_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), FONT_MANAGER_TYPE_FONT_PROPERTIES, FontManagerFontPropertiesClass))

typedef struct _FontManagerFontProperties FontManagerFontProperties;
typedef struct _FontManagerFontPropertiesClass FontManagerFontPropertiesClass;
typedef struct _FontManagerFontPropertiesPrivate FontManagerFontPropertiesPrivate;
enum  {
	FONT_MANAGER_FONT_PROPERTIES_0_PROPERTY,
	FONT_MANAGER_FONT_PROPERTIES_FAMILY_PROPERTY,
	FONT_MANAGER_FONT_PROPERTIES_FONT_PROPERTY,
	FONT_MANAGER_FONT_PROPERTIES_NUM_PROPERTIES
};
static GParamSpec* font_manager_font_properties_properties[FONT_MANAGER_FONT_PROPERTIES_NUM_PROPERTIES];
enum  {
	FONT_MANAGER_FONT_PROPERTIES_CHANGED_SIGNAL,
	FONT_MANAGER_FONT_PROPERTIES_NUM_SIGNALS
};
static guint font_manager_font_properties_signals[FONT_MANAGER_FONT_PROPERTIES_NUM_SIGNALS] = {0};

#define FONT_MANAGER_TYPE_ACCEPT (font_manager_accept_get_type ())
#define FONT_MANAGER_ACCEPT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), FONT_MANAGER_TYPE_ACCEPT, FontManagerAccept))
#define FONT_MANAGER_ACCEPT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), FONT_MANAGER_TYPE_ACCEPT, FontManagerAcceptClass))
#define FONT_MANAGER_IS_ACCEPT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), FONT_MANAGER_TYPE_ACCEPT))
#define FONT_MANAGER_IS_ACCEPT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), FONT_MANAGER_TYPE_ACCEPT))
#define FONT_MANAGER_ACCEPT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), FONT_MANAGER_TYPE_ACCEPT, FontManagerAcceptClass))

typedef struct _FontManagerAccept FontManagerAccept;
typedef struct _FontManagerAcceptClass FontManagerAcceptClass;
typedef struct _FontManagerAcceptPrivate FontManagerAcceptPrivate;
enum  {
	FONT_MANAGER_ACCEPT_0_PROPERTY,
	FONT_MANAGER_ACCEPT_NUM_PROPERTIES
};
static GParamSpec* font_manager_accept_properties[FONT_MANAGER_ACCEPT_NUM_PROPERTIES];

#define FONT_MANAGER_TYPE_DIRECTORIES (font_manager_directories_get_type ())
#define FONT_MANAGER_DIRECTORIES(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), FONT_MANAGER_TYPE_DIRECTORIES, FontManagerDirectories))
#define FONT_MANAGER_DIRECTORIES_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), FONT_MANAGER_TYPE_DIRECTORIES, FontManagerDirectoriesClass))
#define FONT_MANAGER_IS_DIRECTORIES(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), FONT_MANAGER_TYPE_DIRECTORIES))
#define FONT_MANAGER_IS_DIRECTORIES_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), FONT_MANAGER_TYPE_DIRECTORIES))
#define FONT_MANAGER_DIRECTORIES_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), FONT_MANAGER_TYPE_DIRECTORIES, FontManagerDirectoriesClass))

typedef struct _FontManagerDirectories FontManagerDirectories;
typedef struct _FontManagerDirectoriesClass FontManagerDirectoriesClass;
typedef struct _FontManagerDirectoriesPrivate FontManagerDirectoriesPrivate;
enum  {
	FONT_MANAGER_DIRECTORIES_0_PROPERTY,
	FONT_MANAGER_DIRECTORIES_NUM_PROPERTIES
};
static GParamSpec* font_manager_directories_properties[FONT_MANAGER_DIRECTORIES_NUM_PROPERTIES];

#define FONT_MANAGER_TYPE_REJECT (font_manager_reject_get_type ())
#define FONT_MANAGER_REJECT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), FONT_MANAGER_TYPE_REJECT, FontManagerReject))
#define FONT_MANAGER_REJECT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), FONT_MANAGER_TYPE_REJECT, FontManagerRejectClass))
#define FONT_MANAGER_IS_REJECT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), FONT_MANAGER_TYPE_REJECT))
#define FONT_MANAGER_IS_REJECT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), FONT_MANAGER_TYPE_REJECT))
#define FONT_MANAGER_REJECT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), FONT_MANAGER_TYPE_REJECT, FontManagerRejectClass))

typedef struct _FontManagerReject FontManagerReject;
typedef struct _FontManagerRejectClass FontManagerRejectClass;
typedef struct _FontManagerRejectPrivate FontManagerRejectPrivate;
enum  {
	FONT_MANAGER_REJECT_0_PROPERTY,
	FONT_MANAGER_REJECT_NUM_PROPERTIES
};
static GParamSpec* font_manager_reject_properties[FONT_MANAGER_REJECT_NUM_PROPERTIES];
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

#define FONT_MANAGER_TYPE_SOURCES (font_manager_sources_get_type ())
#define FONT_MANAGER_SOURCES(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), FONT_MANAGER_TYPE_SOURCES, FontManagerSources))
#define FONT_MANAGER_SOURCES_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), FONT_MANAGER_TYPE_SOURCES, FontManagerSourcesClass))
#define FONT_MANAGER_IS_SOURCES(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), FONT_MANAGER_TYPE_SOURCES))
#define FONT_MANAGER_IS_SOURCES_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), FONT_MANAGER_TYPE_SOURCES))
#define FONT_MANAGER_SOURCES_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), FONT_MANAGER_TYPE_SOURCES, FontManagerSourcesClass))

typedef struct _FontManagerSources FontManagerSources;
typedef struct _FontManagerSourcesClass FontManagerSourcesClass;
typedef struct _FontManagerSourcesPrivate FontManagerSourcesPrivate;

#define FONT_MANAGER_SOURCES_TYPE_FILE_MONITORS (font_manager_sources_file_monitors_get_type ())
#define FONT_MANAGER_SOURCES_FILE_MONITORS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), FONT_MANAGER_SOURCES_TYPE_FILE_MONITORS, FontManagerSourcesFileMonitors))
#define FONT_MANAGER_SOURCES_FILE_MONITORS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), FONT_MANAGER_SOURCES_TYPE_FILE_MONITORS, FontManagerSourcesFileMonitorsClass))
#define FONT_MANAGER_SOURCES_IS_FILE_MONITORS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), FONT_MANAGER_SOURCES_TYPE_FILE_MONITORS))
#define FONT_MANAGER_SOURCES_IS_FILE_MONITORS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), FONT_MANAGER_SOURCES_TYPE_FILE_MONITORS))
#define FONT_MANAGER_SOURCES_FILE_MONITORS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), FONT_MANAGER_SOURCES_TYPE_FILE_MONITORS, FontManagerSourcesFileMonitorsClass))

typedef struct _FontManagerSourcesFileMonitors FontManagerSourcesFileMonitors;
typedef struct _FontManagerSourcesFileMonitorsClass FontManagerSourcesFileMonitorsClass;
enum  {
	FONT_MANAGER_SOURCES_0_PROPERTY,
	FONT_MANAGER_SOURCES_ACTIVE_PROPERTY,
	FONT_MANAGER_SOURCES_NUM_PROPERTIES
};
static GParamSpec* font_manager_sources_properties[FONT_MANAGER_SOURCES_NUM_PROPERTIES];
#define _g_hash_table_unref0(var) ((var == NULL) ? NULL : (var = (g_hash_table_unref (var), NULL)))
typedef struct _Block3Data Block3Data;
typedef struct _FontManagerSourcesPurgeEntriesData FontManagerSourcesPurgeEntriesData;
typedef struct _FontManagerSourcesFileMonitorsPrivate FontManagerSourcesFileMonitorsPrivate;
enum  {
	FONT_MANAGER_SOURCES_FILE_MONITORS_0_PROPERTY,
	FONT_MANAGER_SOURCES_FILE_MONITORS_SIZE_PROPERTY,
	FONT_MANAGER_SOURCES_FILE_MONITORS_NUM_PROPERTIES
};
static GParamSpec* font_manager_sources_file_monitors_properties[FONT_MANAGER_SOURCES_FILE_MONITORS_NUM_PROPERTIES];
enum  {
	FONT_MANAGER_SOURCES_FILE_MONITORS_CHANGED_SIGNAL,
	FONT_MANAGER_SOURCES_FILE_MONITORS_NUM_SIGNALS
};
static guint font_manager_sources_file_monitors_signals[FONT_MANAGER_SOURCES_FILE_MONITORS_NUM_SIGNALS] = {0};
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _FontManagerDefaultProperties {
	FontManagerProperties parent_instance;
	FontManagerDefaultPropertiesPrivate * priv;
};

struct _FontManagerDefaultPropertiesClass {
	FontManagerPropertiesClass parent_class;
};

struct _FontManagerDisplayProperties {
	FontManagerProperties parent_instance;
	FontManagerDisplayPropertiesPrivate * priv;
};

struct _FontManagerDisplayPropertiesClass {
	FontManagerPropertiesClass parent_class;
};

struct _FontManagerFontProperties {
	FontManagerDefaultProperties parent_instance;
	FontManagerFontPropertiesPrivate * priv;
};

struct _FontManagerFontPropertiesClass {
	FontManagerDefaultPropertiesClass parent_class;
};

struct _FontManagerFontPropertiesPrivate {
	gchar* _family;
	FontManagerFont* _font;
};

struct _FontManagerAccept {
	FontManagerSelections parent_instance;
	FontManagerAcceptPrivate * priv;
};

struct _FontManagerAcceptClass {
	FontManagerSelectionsClass parent_class;
};

struct _FontManagerDirectories {
	FontManagerSelections parent_instance;
	FontManagerDirectoriesPrivate * priv;
};

struct _FontManagerDirectoriesClass {
	FontManagerSelectionsClass parent_class;
};

struct _FontManagerReject {
	FontManagerSelections parent_instance;
	FontManagerRejectPrivate * priv;
};

struct _FontManagerRejectClass {
	FontManagerSelectionsClass parent_class;
};

struct _FontManagerSources {
	FontManagerDirectories parent_instance;
	FontManagerSourcesPrivate * priv;
};

struct _FontManagerSourcesClass {
	FontManagerDirectoriesClass parent_class;
};

struct _FontManagerSourcesPrivate {
	FontManagerDirectories* _active;
	FontManagerSourcesFileMonitors* monitors;
	GHashTable* sources;
};

struct _Block3Data {
	int _ref_count_;
	FontManagerSources* self;
	FontManagerSource* source;
};

struct _FontManagerSourcesPurgeEntriesData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	GAsyncReadyCallback _callback_;
	gboolean _task_complete_;
	FontManagerSources* self;
	gchar* path;
	FontManagerDatabaseType* types;
	FontManagerDatabaseType* _tmp0_;
	gint types_length1;
	gint _types_size_;
	FontManagerDatabase* db;
	FontManagerDatabase* _tmp1_;
	FontManagerDatabaseType* _tmp2_;
	gint _tmp2__length1;
	FontManagerDatabaseType* type_collection;
	gint type_collection_length1;
	gint _type_collection_size_;
	gint type_it;
	FontManagerDatabaseType type;
	gchar* name;
	FontManagerDatabaseType _tmp3_;
	const gchar* _tmp4_;
	gchar* _tmp5_;
	FontManagerDatabase* _tmp6_;
	const gchar* _tmp7_;
	gchar* _tmp8_;
	gchar* _tmp9_;
	FontManagerDatabase* _tmp10_;
	sqlite3_stmt* _tmp11_;
	FontManagerDatabaseType* _tmp12_;
	gint _tmp12__length1;
	FontManagerDatabaseType* _vala1_type_collection;
	gint _vala1_type_collection_length1;
	gint __vala1_type_collection_size_;
	gint _vala1_type_it;
	FontManagerDatabaseType _vala1_type;
	FontManagerDatabase* _tmp13_;
	FontManagerDatabaseType _tmp14_;
	FontManagerDatabase* _tmp15_;
	FontManagerDatabase* _tmp16_;
	FontManagerDatabase* _tmp17_;
	FontManagerDatabase* _tmp18_;
	sqlite3_stmt* _tmp19_;
	GError* e;
	GError* _tmp20_;
	GError* _tmp21_;
	const gchar* _tmp22_;
	GError* _inner_error0_;
};

struct _FontManagerSourcesFileMonitors {
	GObject parent_instance;
	FontManagerSourcesFileMonitorsPrivate * priv;
};

struct _FontManagerSourcesFileMonitorsClass {
	GObjectClass parent_class;
};

struct _FontManagerSourcesFileMonitorsPrivate {
	GVolumeMonitor* volume_monitor;
	GHashTable* monitors;
};

static gpointer font_manager_default_properties_parent_class = NULL;
static gpointer font_manager_display_properties_parent_class = NULL;
static gint FontManagerFontProperties_private_offset;
static gpointer font_manager_font_properties_parent_class = NULL;
static gpointer font_manager_accept_parent_class = NULL;
static gpointer font_manager_directories_parent_class = NULL;
static gpointer font_manager_reject_parent_class = NULL;
static gint FontManagerSources_private_offset;
static gpointer font_manager_sources_parent_class = NULL;
static gint FontManagerSourcesFileMonitors_private_offset;
static gpointer font_manager_sources_file_monitors_parent_class = NULL;

GType font_manager_width_get_type (void) G_GNUC_CONST;
gchar* font_manager_width_to_string (FontManagerWidth self);
GType font_manager_slant_get_type (void) G_GNUC_CONST;
gchar* font_manager_slant_to_string (FontManagerSlant self);
GType font_manager_weight_get_type (void) G_GNUC_CONST;
gboolean font_manager_weight_defined (FontManagerWeight self);
gchar* font_manager_weight_to_string (FontManagerWeight self);
GType font_manager_spacing_get_type (void) G_GNUC_CONST;
gchar* font_manager_spacing_to_string (FontManagerSpacing self);
GType font_manager_hint_style_get_type (void) G_GNUC_CONST;
gchar* font_manager_hint_style_to_string (FontManagerHintStyle self);
GType font_manager_lcd_filter_get_type (void) G_GNUC_CONST;
gchar* font_manager_lcd_filter_to_string (FontManagerLCDFilter self);
GType font_manager_subpixel_order_get_type (void) G_GNUC_CONST;
gchar* font_manager_subpixel_order_to_string (FontManagerSubpixelOrder self);
gboolean font_manager_load_user_font_resources (StringHashset* files,
                                                GList* sources);
GType font_manager_default_properties_get_type (void) G_GNUC_CONST;
FontManagerDefaultProperties* font_manager_default_properties_new (void);
FontManagerDefaultProperties* font_manager_default_properties_construct (GType object_type);
GType font_manager_display_properties_get_type (void) G_GNUC_CONST;
FontManagerDisplayProperties* font_manager_display_properties_new (void);
FontManagerDisplayProperties* font_manager_display_properties_construct (GType object_type);
GType font_manager_font_properties_get_type (void) G_GNUC_CONST;
FontManagerFontProperties* font_manager_font_properties_new (void);
FontManagerFontProperties* font_manager_font_properties_construct (GType object_type);
static void __lambda22_ (FontManagerFontProperties* self,
                  GObject* source,
                  GParamSpec* pspec);
static void ___lambda22__g_object_notify (GObject* _sender,
                                   GParamSpec* pspec,
                                   gpointer self);
static void __lambda23_ (FontManagerFontProperties* self,
                  GObject* s,
                  GParamSpec* p);
gboolean font_manager_is_valid_source (FontManagerJsonProxy* object);
FontManagerFont* font_manager_font_properties_get_font (FontManagerFontProperties* self);
void font_manager_font_properties_set_family (FontManagerFontProperties* self,
                                              const gchar* value);
static void ___lambda23__g_object_notify (GObject* _sender,
                                   GParamSpec* pspec,
                                   gpointer self);
static gboolean font_manager_font_properties_real_load (FontManagerProperties* base);
const gchar* font_manager_font_properties_get_family (FontManagerFontProperties* self);
static void font_manager_font_properties_real_add_match_criteria (FontManagerProperties* base,
                                                           FontManagerXmlWriter* writer);
void font_manager_font_properties_set_font (FontManagerFontProperties* self,
                                            FontManagerFont* value);
static void font_manager_font_properties_finalize (GObject * obj);
static void _vala_font_manager_font_properties_get_property (GObject * object,
                                                      guint property_id,
                                                      GValue * value,
                                                      GParamSpec * pspec);
static void _vala_font_manager_font_properties_set_property (GObject * object,
                                                      guint property_id,
                                                      const GValue * value,
                                                      GParamSpec * pspec);
GType font_manager_accept_get_type (void) G_GNUC_CONST;
FontManagerAccept* font_manager_accept_new (void);
FontManagerAccept* font_manager_accept_construct (GType object_type);
GType font_manager_directories_get_type (void) G_GNUC_CONST;
FontManagerDirectories* font_manager_directories_new (void);
FontManagerDirectories* font_manager_directories_construct (GType object_type);
static xmlNode* font_manager_directories_real_get_selections (FontManagerSelections* base,
                                                       xmlDoc* doc);
static void font_manager_directories_real_write_selections (FontManagerSelections* base,
                                                     FontManagerXmlWriter* writer);
static void _g_free0_ (gpointer var);
static inline void _g_list_free__g_free0_ (GList* self);
GType font_manager_reject_get_type (void) G_GNUC_CONST;
FontManagerReject* font_manager_reject_new (void);
FontManagerReject* font_manager_reject_construct (GType object_type);
static void __lambda24_ (FontManagerReject* self);
static gboolean __lambda25_ (FontManagerReject* self);
static gboolean ___lambda25__gsource_func (gpointer self);
static void ___lambda24__font_manager_selections_changed (FontManagerSelections* _sender,
                                                   gpointer self);
StringHashset* font_manager_reject_get_rejected_files (FontManagerReject* self);
GType font_manager_sources_get_type (void) G_GNUC_CONST;
GType font_manager_sources_file_monitors_get_type (void) G_GNUC_CONST;
FontManagerSources* font_manager_sources_new (void);
FontManagerSources* font_manager_sources_construct (GType object_type);
static void font_manager_sources_set_active (FontManagerSources* self,
                                      FontManagerDirectories* value);
FontManagerSourcesFileMonitors* font_manager_sources_file_monitors_new (void);
FontManagerSourcesFileMonitors* font_manager_sources_file_monitors_construct (GType object_type);
static void _g_object_unref0_ (gpointer var);
static void __lambda30_ (FontManagerSources* self,
                  GFile* f,
                  GFile* of,
                  GFileMonitorEvent ev);
void font_manager_sources_update (FontManagerSources* self);
static void ___lambda30__font_manager_sources_file_monitors_changed (FontManagerSourcesFileMonitors* _sender,
                                                              GFile* file,
                                                              GFile* other_file,
                                                              GFileMonitorEvent event_type,
                                                              gpointer self);
GList* font_manager_sources_list_objects (FontManagerSources* self);
FontManagerDirectories* font_manager_sources_get_active (FontManagerSources* self);
gboolean font_manager_sources_add_from_path (FontManagerSources* self,
                                             const gchar* dirpath);
gboolean font_manager_sources_add (FontManagerSources* self,
                                   FontManagerSource* source);
static Block3Data* block3_data_ref (Block3Data* _data3_);
static void block3_data_unref (void * _userdata_);
static void __lambda31_ (Block3Data* _data3_);
static void font_manager_sources_source_activated (FontManagerSources* self,
                                            FontManagerSource* source);
static void ___lambda31__g_object_notify (GObject* _sender,
                                   GParamSpec* pspec,
                                   gpointer self);
gboolean font_manager_sources_file_monitors_add (FontManagerSourcesFileMonitors* self,
                                                 const gchar* path);
static void font_manager_sources_purge_entries_data_free (gpointer _data);
static void font_manager_sources_purge_entries_async_ready_wrapper (GObject *source_object,
                                                             GAsyncResult *res,
                                                             void *user_data);
void font_manager_sources_purge_entries (FontManagerSources* self,
                                         const gchar* path,
                                         GAsyncReadyCallback _callback_,
                                         gpointer _user_data_);
void font_manager_sources_purge_entries_finish (FontManagerSources* self,
                                                GAsyncResult* _res_);
static gboolean font_manager_sources_purge_entries_co (FontManagerSourcesPurgeEntriesData* _data_);
static gboolean _font_manager_sources_purge_entries_co_gsource_func (gpointer self);
gboolean font_manager_sources_remove (FontManagerSources* self,
                                      FontManagerSource* source);
gboolean font_manager_sources_file_monitors_remove (FontManagerSourcesFileMonitors* self,
                                                    const gchar* path);
static void __lambda32_ (FontManagerSources* self,
                  GObject* obj,
                  GAsyncResult* res);
static void ___lambda32__gasync_ready_callback (GObject* source_object,
                                         GAsyncResult* res,
                                         gpointer self);
gboolean font_manager_sources_load (FontManagerSources* self);
static void font_manager_sources_file_monitors_notify_on_mount_event (FontManagerSourcesFileMonitors* self,
                                                               GMount* mount);
guint font_manager_sources_file_monitors_get_size (FontManagerSourcesFileMonitors* self);
static void ___lambda26_ (FontManagerSourcesFileMonitors* self,
                   GFile* f,
                   GFile* of,
                   GFileMonitorEvent ev);
static void ____lambda26__g_file_monitor_changed (GFileMonitor* _sender,
                                           GFile* file,
                                           GFile* other_file,
                                           GFileMonitorEvent event_type,
                                           gpointer self);
static void g_cclosure_user_marshal_VOID__OBJECT_OBJECT_ENUM (GClosure * closure,
                                                       GValue * return_value,
                                                       guint n_param_values,
                                                       const GValue * param_values,
                                                       gpointer invocation_hint,
                                                       gpointer marshal_data);
static GObject * font_manager_sources_file_monitors_constructor (GType type,
                                                          guint n_construct_properties,
                                                          GObjectConstructParam * construct_properties);
static void _font_manager_sources_file_monitors___lambda27_ (FontManagerSourcesFileMonitors* self,
                                                      GMount* m);
static void __font_manager_sources_file_monitors___lambda27__g_volume_monitor_mount_added (GVolumeMonitor* _sender,
                                                                                    GMount* mount,
                                                                                    gpointer self);
static void _font_manager_sources_file_monitors___lambda28_ (FontManagerSourcesFileMonitors* self,
                                                      GMount* m);
static void __font_manager_sources_file_monitors___lambda28__g_volume_monitor_mount_changed (GVolumeMonitor* _sender,
                                                                                      GMount* mount,
                                                                                      gpointer self);
static void _font_manager_sources_file_monitors___lambda29_ (FontManagerSourcesFileMonitors* self,
                                                      GMount* m);
static void __font_manager_sources_file_monitors___lambda29__g_volume_monitor_mount_removed (GVolumeMonitor* _sender,
                                                                                      GMount* mount,
                                                                                      gpointer self);
static void font_manager_sources_file_monitors_finalize (GObject * obj);
static void _vala_font_manager_sources_file_monitors_get_property (GObject * object,
                                                            guint property_id,
                                                            GValue * value,
                                                            GParamSpec * pspec);
static void font_manager_sources_finalize (GObject * obj);
static void _vala_font_manager_sources_get_property (GObject * object,
                                              guint property_id,
                                              GValue * value,
                                              GParamSpec * pspec);
static void _vala_font_manager_sources_set_property (GObject * object,
                                              guint property_id,
                                              const GValue * value,
                                              GParamSpec * pspec);

gchar*
font_manager_width_to_string (FontManagerWidth self)
{
	gchar* result = NULL;
#line 36 "../lib/vala/FontConfig.vala"
	switch (self) {
#line 36 "../lib/vala/FontConfig.vala"
		case FONT_MANAGER_WIDTH_ULTRACONDENSED:
#line 626 "FontConfig.c"
		{
			gchar* _tmp0_;
#line 38 "../lib/vala/FontConfig.vala"
			_tmp0_ = g_strdup (_ ("Ultra-Condensed"));
#line 38 "../lib/vala/FontConfig.vala"
			result = _tmp0_;
#line 38 "../lib/vala/FontConfig.vala"
			return result;
#line 635 "FontConfig.c"
		}
#line 36 "../lib/vala/FontConfig.vala"
		case FONT_MANAGER_WIDTH_EXTRACONDENSED:
#line 639 "FontConfig.c"
		{
			gchar* _tmp1_;
#line 40 "../lib/vala/FontConfig.vala"
			_tmp1_ = g_strdup (_ ("Extra-Condensed"));
#line 40 "../lib/vala/FontConfig.vala"
			result = _tmp1_;
#line 40 "../lib/vala/FontConfig.vala"
			return result;
#line 648 "FontConfig.c"
		}
#line 36 "../lib/vala/FontConfig.vala"
		case FONT_MANAGER_WIDTH_CONDENSED:
#line 652 "FontConfig.c"
		{
			gchar* _tmp2_;
#line 42 "../lib/vala/FontConfig.vala"
			_tmp2_ = g_strdup (_ ("Condensed"));
#line 42 "../lib/vala/FontConfig.vala"
			result = _tmp2_;
#line 42 "../lib/vala/FontConfig.vala"
			return result;
#line 661 "FontConfig.c"
		}
#line 36 "../lib/vala/FontConfig.vala"
		case FONT_MANAGER_WIDTH_SEMICONDENSED:
#line 665 "FontConfig.c"
		{
			gchar* _tmp3_;
#line 44 "../lib/vala/FontConfig.vala"
			_tmp3_ = g_strdup (_ ("Semi-Condensed"));
#line 44 "../lib/vala/FontConfig.vala"
			result = _tmp3_;
#line 44 "../lib/vala/FontConfig.vala"
			return result;
#line 674 "FontConfig.c"
		}
#line 36 "../lib/vala/FontConfig.vala"
		case FONT_MANAGER_WIDTH_SEMIEXPANDED:
#line 678 "FontConfig.c"
		{
			gchar* _tmp4_;
#line 46 "../lib/vala/FontConfig.vala"
			_tmp4_ = g_strdup (_ ("Semi-Expanded"));
#line 46 "../lib/vala/FontConfig.vala"
			result = _tmp4_;
#line 46 "../lib/vala/FontConfig.vala"
			return result;
#line 687 "FontConfig.c"
		}
#line 36 "../lib/vala/FontConfig.vala"
		case FONT_MANAGER_WIDTH_EXPANDED:
#line 691 "FontConfig.c"
		{
			gchar* _tmp5_;
#line 48 "../lib/vala/FontConfig.vala"
			_tmp5_ = g_strdup (_ ("Expanded"));
#line 48 "../lib/vala/FontConfig.vala"
			result = _tmp5_;
#line 48 "../lib/vala/FontConfig.vala"
			return result;
#line 700 "FontConfig.c"
		}
#line 36 "../lib/vala/FontConfig.vala"
		case FONT_MANAGER_WIDTH_EXTRAEXPANDED:
#line 704 "FontConfig.c"
		{
			gchar* _tmp6_;
#line 50 "../lib/vala/FontConfig.vala"
			_tmp6_ = g_strdup (_ ("Extra-Expanded"));
#line 50 "../lib/vala/FontConfig.vala"
			result = _tmp6_;
#line 50 "../lib/vala/FontConfig.vala"
			return result;
#line 713 "FontConfig.c"
		}
#line 36 "../lib/vala/FontConfig.vala"
		case FONT_MANAGER_WIDTH_ULTRAEXPANDED:
#line 717 "FontConfig.c"
		{
			gchar* _tmp7_;
#line 52 "../lib/vala/FontConfig.vala"
			_tmp7_ = g_strdup (_ ("Ultra-Expanded"));
#line 52 "../lib/vala/FontConfig.vala"
			result = _tmp7_;
#line 52 "../lib/vala/FontConfig.vala"
			return result;
#line 726 "FontConfig.c"
		}
		default:
		{
#line 54 "../lib/vala/FontConfig.vala"
			result = NULL;
#line 54 "../lib/vala/FontConfig.vala"
			return result;
#line 734 "FontConfig.c"
		}
	}
}

GType
font_manager_width_get_type (void)
{
	static volatile gsize font_manager_width_type_id__volatile = 0;
	if (g_once_init_enter (&font_manager_width_type_id__volatile)) {
		static const GEnumValue values[] = {{FONT_MANAGER_WIDTH_ULTRACONDENSED, "FONT_MANAGER_WIDTH_ULTRACONDENSED", "ultracondensed"}, {FONT_MANAGER_WIDTH_EXTRACONDENSED, "FONT_MANAGER_WIDTH_EXTRACONDENSED", "extracondensed"}, {FONT_MANAGER_WIDTH_CONDENSED, "FONT_MANAGER_WIDTH_CONDENSED", "condensed"}, {FONT_MANAGER_WIDTH_SEMICONDENSED, "FONT_MANAGER_WIDTH_SEMICONDENSED", "semicondensed"}, {FONT_MANAGER_WIDTH_NORMAL, "FONT_MANAGER_WIDTH_NORMAL", "normal"}, {FONT_MANAGER_WIDTH_SEMIEXPANDED, "FONT_MANAGER_WIDTH_SEMIEXPANDED", "semiexpanded"}, {FONT_MANAGER_WIDTH_EXPANDED, "FONT_MANAGER_WIDTH_EXPANDED", "expanded"}, {FONT_MANAGER_WIDTH_EXTRAEXPANDED, "FONT_MANAGER_WIDTH_EXTRAEXPANDED", "extraexpanded"}, {FONT_MANAGER_WIDTH_ULTRAEXPANDED, "FONT_MANAGER_WIDTH_ULTRAEXPANDED", "ultraexpanded"}, {0, NULL, NULL}};
		GType font_manager_width_type_id;
		font_manager_width_type_id = g_enum_register_static ("FontManagerWidth", values);
		g_once_init_leave (&font_manager_width_type_id__volatile, font_manager_width_type_id);
	}
	return font_manager_width_type_id__volatile;
}

gchar*
font_manager_slant_to_string (FontManagerSlant self)
{
	gchar* result = NULL;
#line 67 "../lib/vala/FontConfig.vala"
	switch (self) {
#line 67 "../lib/vala/FontConfig.vala"
		case FONT_MANAGER_SLANT_ITALIC:
#line 760 "FontConfig.c"
		{
			gchar* _tmp0_;
#line 69 "../lib/vala/FontConfig.vala"
			_tmp0_ = g_strdup (_ ("Italic"));
#line 69 "../lib/vala/FontConfig.vala"
			result = _tmp0_;
#line 69 "../lib/vala/FontConfig.vala"
			return result;
#line 769 "FontConfig.c"
		}
#line 67 "../lib/vala/FontConfig.vala"
		case FONT_MANAGER_SLANT_OBLIQUE:
#line 773 "FontConfig.c"
		{
			gchar* _tmp1_;
#line 71 "../lib/vala/FontConfig.vala"
			_tmp1_ = g_strdup (_ ("Oblique"));
#line 71 "../lib/vala/FontConfig.vala"
			result = _tmp1_;
#line 71 "../lib/vala/FontConfig.vala"
			return result;
#line 782 "FontConfig.c"
		}
		default:
		{
#line 73 "../lib/vala/FontConfig.vala"
			result = NULL;
#line 73 "../lib/vala/FontConfig.vala"
			return result;
#line 790 "FontConfig.c"
		}
	}
}

GType
font_manager_slant_get_type (void)
{
	static volatile gsize font_manager_slant_type_id__volatile = 0;
	if (g_once_init_enter (&font_manager_slant_type_id__volatile)) {
		static const GEnumValue values[] = {{FONT_MANAGER_SLANT_ROMAN, "FONT_MANAGER_SLANT_ROMAN", "roman"}, {FONT_MANAGER_SLANT_ITALIC, "FONT_MANAGER_SLANT_ITALIC", "italic"}, {FONT_MANAGER_SLANT_OBLIQUE, "FONT_MANAGER_SLANT_OBLIQUE", "oblique"}, {0, NULL, NULL}};
		GType font_manager_slant_type_id;
		font_manager_slant_type_id = g_enum_register_static ("FontManagerSlant", values);
		g_once_init_leave (&font_manager_slant_type_id__volatile, font_manager_slant_type_id);
	}
	return font_manager_slant_type_id__volatile;
}

gboolean
font_manager_weight_defined (FontManagerWeight self)
{
	gboolean result = FALSE;
	gboolean res = FALSE;
#line 100 "../lib/vala/FontConfig.vala"
	switch (self) {
#line 100 "../lib/vala/FontConfig.vala"
		case FONT_MANAGER_WEIGHT_THIN:
#line 100 "../lib/vala/FontConfig.vala"
		case FONT_MANAGER_WEIGHT_ULTRALIGHT:
#line 100 "../lib/vala/FontConfig.vala"
		case FONT_MANAGER_WEIGHT_LIGHT:
#line 100 "../lib/vala/FontConfig.vala"
		case FONT_MANAGER_WEIGHT_BOOK:
#line 100 "../lib/vala/FontConfig.vala"
		case FONT_MANAGER_WEIGHT_REGULAR:
#line 100 "../lib/vala/FontConfig.vala"
		case FONT_MANAGER_WEIGHT_MEDIUM:
#line 100 "../lib/vala/FontConfig.vala"
		case FONT_MANAGER_WEIGHT_SEMIBOLD:
#line 100 "../lib/vala/FontConfig.vala"
		case FONT_MANAGER_WEIGHT_BOLD:
#line 100 "../lib/vala/FontConfig.vala"
		case FONT_MANAGER_WEIGHT_EXTRABOLD:
#line 100 "../lib/vala/FontConfig.vala"
		case FONT_MANAGER_WEIGHT_BLACK:
#line 100 "../lib/vala/FontConfig.vala"
		case FONT_MANAGER_WEIGHT_ULTRABLACK:
#line 837 "FontConfig.c"
		{
#line 112 "../lib/vala/FontConfig.vala"
			res = TRUE;
#line 113 "../lib/vala/FontConfig.vala"
			break;
#line 843 "FontConfig.c"
		}
		default:
		{
#line 115 "../lib/vala/FontConfig.vala"
			res = FALSE;
#line 116 "../lib/vala/FontConfig.vala"
			break;
#line 851 "FontConfig.c"
		}
	}
#line 118 "../lib/vala/FontConfig.vala"
	result = res;
#line 118 "../lib/vala/FontConfig.vala"
	return result;
#line 858 "FontConfig.c"
}

gchar*
font_manager_weight_to_string (FontManagerWeight self)
{
	gchar* result = NULL;
#line 122 "../lib/vala/FontConfig.vala"
	switch (self) {
#line 122 "../lib/vala/FontConfig.vala"
		case FONT_MANAGER_WEIGHT_THIN:
#line 869 "FontConfig.c"
		{
			gchar* _tmp0_;
#line 124 "../lib/vala/FontConfig.vala"
			_tmp0_ = g_strdup (_ ("Thin"));
#line 124 "../lib/vala/FontConfig.vala"
			result = _tmp0_;
#line 124 "../lib/vala/FontConfig.vala"
			return result;
#line 878 "FontConfig.c"
		}
#line 122 "../lib/vala/FontConfig.vala"
		case FONT_MANAGER_WEIGHT_ULTRALIGHT:
#line 882 "FontConfig.c"
		{
			gchar* _tmp1_;
#line 126 "../lib/vala/FontConfig.vala"
			_tmp1_ = g_strdup (_ ("Ultra-Light"));
#line 126 "../lib/vala/FontConfig.vala"
			result = _tmp1_;
#line 126 "../lib/vala/FontConfig.vala"
			return result;
#line 891 "FontConfig.c"
		}
#line 122 "../lib/vala/FontConfig.vala"
		case FONT_MANAGER_WEIGHT_LIGHT:
#line 895 "FontConfig.c"
		{
			gchar* _tmp2_;
#line 128 "../lib/vala/FontConfig.vala"
			_tmp2_ = g_strdup (_ ("Light"));
#line 128 "../lib/vala/FontConfig.vala"
			result = _tmp2_;
#line 128 "../lib/vala/FontConfig.vala"
			return result;
#line 904 "FontConfig.c"
		}
#line 122 "../lib/vala/FontConfig.vala"
		case FONT_MANAGER_WEIGHT_BOOK:
#line 908 "FontConfig.c"
		{
			gchar* _tmp3_;
#line 130 "../lib/vala/FontConfig.vala"
			_tmp3_ = g_strdup (_ ("Book"));
#line 130 "../lib/vala/FontConfig.vala"
			result = _tmp3_;
#line 130 "../lib/vala/FontConfig.vala"
			return result;
#line 917 "FontConfig.c"
		}
#line 122 "../lib/vala/FontConfig.vala"
		case FONT_MANAGER_WEIGHT_MEDIUM:
#line 921 "FontConfig.c"
		{
			gchar* _tmp4_;
#line 132 "../lib/vala/FontConfig.vala"
			_tmp4_ = g_strdup (_ ("Medium"));
#line 132 "../lib/vala/FontConfig.vala"
			result = _tmp4_;
#line 132 "../lib/vala/FontConfig.vala"
			return result;
#line 930 "FontConfig.c"
		}
#line 122 "../lib/vala/FontConfig.vala"
		case FONT_MANAGER_WEIGHT_SEMIBOLD:
#line 934 "FontConfig.c"
		{
			gchar* _tmp5_;
#line 134 "../lib/vala/FontConfig.vala"
			_tmp5_ = g_strdup (_ ("Semi-Bold"));
#line 134 "../lib/vala/FontConfig.vala"
			result = _tmp5_;
#line 134 "../lib/vala/FontConfig.vala"
			return result;
#line 943 "FontConfig.c"
		}
#line 122 "../lib/vala/FontConfig.vala"
		case FONT_MANAGER_WEIGHT_BOLD:
#line 947 "FontConfig.c"
		{
			gchar* _tmp6_;
#line 136 "../lib/vala/FontConfig.vala"
			_tmp6_ = g_strdup (_ ("Bold"));
#line 136 "../lib/vala/FontConfig.vala"
			result = _tmp6_;
#line 136 "../lib/vala/FontConfig.vala"
			return result;
#line 956 "FontConfig.c"
		}
#line 122 "../lib/vala/FontConfig.vala"
		case FONT_MANAGER_WEIGHT_EXTRABOLD:
#line 960 "FontConfig.c"
		{
			gchar* _tmp7_;
#line 138 "../lib/vala/FontConfig.vala"
			_tmp7_ = g_strdup (_ ("Ultra-Bold"));
#line 138 "../lib/vala/FontConfig.vala"
			result = _tmp7_;
#line 138 "../lib/vala/FontConfig.vala"
			return result;
#line 969 "FontConfig.c"
		}
#line 122 "../lib/vala/FontConfig.vala"
		case FONT_MANAGER_WEIGHT_HEAVY:
#line 973 "FontConfig.c"
		{
			gchar* _tmp8_;
#line 140 "../lib/vala/FontConfig.vala"
			_tmp8_ = g_strdup (_ ("Heavy"));
#line 140 "../lib/vala/FontConfig.vala"
			result = _tmp8_;
#line 140 "../lib/vala/FontConfig.vala"
			return result;
#line 982 "FontConfig.c"
		}
#line 122 "../lib/vala/FontConfig.vala"
		case FONT_MANAGER_WEIGHT_ULTRABLACK:
#line 986 "FontConfig.c"
		{
			gchar* _tmp9_;
#line 142 "../lib/vala/FontConfig.vala"
			_tmp9_ = g_strdup (_ ("Ultra-Heavy"));
#line 142 "../lib/vala/FontConfig.vala"
			result = _tmp9_;
#line 142 "../lib/vala/FontConfig.vala"
			return result;
#line 995 "FontConfig.c"
		}
		default:
		{
#line 144 "../lib/vala/FontConfig.vala"
			result = NULL;
#line 144 "../lib/vala/FontConfig.vala"
			return result;
#line 1003 "FontConfig.c"
		}
	}
}

GType
font_manager_weight_get_type (void)
{
	static volatile gsize font_manager_weight_type_id__volatile = 0;
	if (g_once_init_enter (&font_manager_weight_type_id__volatile)) {
		static const GEnumValue values[] = {{FONT_MANAGER_WEIGHT_THIN, "FONT_MANAGER_WEIGHT_THIN", "thin"}, {FONT_MANAGER_WEIGHT_EXTRALIGHT, "FONT_MANAGER_WEIGHT_EXTRALIGHT", "extralight"}, {FONT_MANAGER_WEIGHT_ULTRALIGHT, "FONT_MANAGER_WEIGHT_ULTRALIGHT", "ultralight"}, {FONT_MANAGER_WEIGHT_LIGHT, "FONT_MANAGER_WEIGHT_LIGHT", "light"}, {FONT_MANAGER_WEIGHT_BOOK, "FONT_MANAGER_WEIGHT_BOOK", "book"}, {FONT_MANAGER_WEIGHT_REGULAR, "FONT_MANAGER_WEIGHT_REGULAR", "regular"}, {FONT_MANAGER_WEIGHT_NORMAL, "FONT_MANAGER_WEIGHT_NORMAL", "normal"}, {FONT_MANAGER_WEIGHT_MEDIUM, "FONT_MANAGER_WEIGHT_MEDIUM", "medium"}, {FONT_MANAGER_WEIGHT_DEMIBOLD, "FONT_MANAGER_WEIGHT_DEMIBOLD", "demibold"}, {FONT_MANAGER_WEIGHT_SEMIBOLD, "FONT_MANAGER_WEIGHT_SEMIBOLD", "semibold"}, {FONT_MANAGER_WEIGHT_BOLD, "FONT_MANAGER_WEIGHT_BOLD", "bold"}, {FONT_MANAGER_WEIGHT_EXTRABOLD, "FONT_MANAGER_WEIGHT_EXTRABOLD", "extrabold"}, {FONT_MANAGER_WEIGHT_BLACK, "FONT_MANAGER_WEIGHT_BLACK", "black"}, {FONT_MANAGER_WEIGHT_HEAVY, "FONT_MANAGER_WEIGHT_HEAVY", "heavy"}, {FONT_MANAGER_WEIGHT_EXTRABLACK, "FONT_MANAGER_WEIGHT_EXTRABLACK", "extrablack"}, {FONT_MANAGER_WEIGHT_ULTRABLACK, "FONT_MANAGER_WEIGHT_ULTRABLACK", "ultrablack"}, {0, NULL, NULL}};
		GType font_manager_weight_type_id;
		font_manager_weight_type_id = g_enum_register_static ("FontManagerWeight", values);
		g_once_init_leave (&font_manager_weight_type_id__volatile, font_manager_weight_type_id);
	}
	return font_manager_weight_type_id__volatile;
}

gchar*
font_manager_spacing_to_string (FontManagerSpacing self)
{
	gchar* result = NULL;
#line 158 "../lib/vala/FontConfig.vala"
	switch (self) {
#line 158 "../lib/vala/FontConfig.vala"
		case FONT_MANAGER_SPACING_PROPORTIONAL:
#line 1029 "FontConfig.c"
		{
			gchar* _tmp0_;
#line 160 "../lib/vala/FontConfig.vala"
			_tmp0_ = g_strdup (_ ("Proportional"));
#line 160 "../lib/vala/FontConfig.vala"
			result = _tmp0_;
#line 160 "../lib/vala/FontConfig.vala"
			return result;
#line 1038 "FontConfig.c"
		}
#line 158 "../lib/vala/FontConfig.vala"
		case FONT_MANAGER_SPACING_DUAL:
#line 1042 "FontConfig.c"
		{
			gchar* _tmp1_;
#line 162 "../lib/vala/FontConfig.vala"
			_tmp1_ = g_strdup (_ ("Dual Width"));
#line 162 "../lib/vala/FontConfig.vala"
			result = _tmp1_;
#line 162 "../lib/vala/FontConfig.vala"
			return result;
#line 1051 "FontConfig.c"
		}
#line 158 "../lib/vala/FontConfig.vala"
		case FONT_MANAGER_SPACING_MONO:
#line 1055 "FontConfig.c"
		{
			gchar* _tmp2_;
#line 164 "../lib/vala/FontConfig.vala"
			_tmp2_ = g_strdup (_ ("Monospace"));
#line 164 "../lib/vala/FontConfig.vala"
			result = _tmp2_;
#line 164 "../lib/vala/FontConfig.vala"
			return result;
#line 1064 "FontConfig.c"
		}
#line 158 "../lib/vala/FontConfig.vala"
		case FONT_MANAGER_SPACING_CHARCELL:
#line 1068 "FontConfig.c"
		{
			gchar* _tmp3_;
#line 166 "../lib/vala/FontConfig.vala"
			_tmp3_ = g_strdup (_ ("Charcell"));
#line 166 "../lib/vala/FontConfig.vala"
			result = _tmp3_;
#line 166 "../lib/vala/FontConfig.vala"
			return result;
#line 1077 "FontConfig.c"
		}
		default:
		{
#line 168 "../lib/vala/FontConfig.vala"
			result = NULL;
#line 168 "../lib/vala/FontConfig.vala"
			return result;
#line 1085 "FontConfig.c"
		}
	}
}

GType
font_manager_spacing_get_type (void)
{
	static volatile gsize font_manager_spacing_type_id__volatile = 0;
	if (g_once_init_enter (&font_manager_spacing_type_id__volatile)) {
		static const GEnumValue values[] = {{FONT_MANAGER_SPACING_PROPORTIONAL, "FONT_MANAGER_SPACING_PROPORTIONAL", "proportional"}, {FONT_MANAGER_SPACING_DUAL, "FONT_MANAGER_SPACING_DUAL", "dual"}, {FONT_MANAGER_SPACING_MONO, "FONT_MANAGER_SPACING_MONO", "mono"}, {FONT_MANAGER_SPACING_CHARCELL, "FONT_MANAGER_SPACING_CHARCELL", "charcell"}, {0, NULL, NULL}};
		GType font_manager_spacing_type_id;
		font_manager_spacing_type_id = g_enum_register_static ("FontManagerSpacing", values);
		g_once_init_leave (&font_manager_spacing_type_id__volatile, font_manager_spacing_type_id);
	}
	return font_manager_spacing_type_id__volatile;
}

gchar*
font_manager_hint_style_to_string (FontManagerHintStyle self)
{
	gchar* result = NULL;
#line 182 "../lib/vala/FontConfig.vala"
	switch (self) {
#line 182 "../lib/vala/FontConfig.vala"
		case FONT_MANAGER_HINT_STYLE_SLIGHT:
#line 1111 "FontConfig.c"
		{
			gchar* _tmp0_;
#line 184 "../lib/vala/FontConfig.vala"
			_tmp0_ = g_strdup (_ ("Slight"));
#line 184 "../lib/vala/FontConfig.vala"
			result = _tmp0_;
#line 184 "../lib/vala/FontConfig.vala"
			return result;
#line 1120 "FontConfig.c"
		}
#line 182 "../lib/vala/FontConfig.vala"
		case FONT_MANAGER_HINT_STYLE_MEDIUM:
#line 1124 "FontConfig.c"
		{
			gchar* _tmp1_;
#line 186 "../lib/vala/FontConfig.vala"
			_tmp1_ = g_strdup (_ ("Medium"));
#line 186 "../lib/vala/FontConfig.vala"
			result = _tmp1_;
#line 186 "../lib/vala/FontConfig.vala"
			return result;
#line 1133 "FontConfig.c"
		}
#line 182 "../lib/vala/FontConfig.vala"
		case FONT_MANAGER_HINT_STYLE_FULL:
#line 1137 "FontConfig.c"
		{
			gchar* _tmp2_;
#line 188 "../lib/vala/FontConfig.vala"
			_tmp2_ = g_strdup (_ ("Full"));
#line 188 "../lib/vala/FontConfig.vala"
			result = _tmp2_;
#line 188 "../lib/vala/FontConfig.vala"
			return result;
#line 1146 "FontConfig.c"
		}
		default:
		{
			gchar* _tmp3_;
#line 190 "../lib/vala/FontConfig.vala"
			_tmp3_ = g_strdup (_ ("None"));
#line 190 "../lib/vala/FontConfig.vala"
			result = _tmp3_;
#line 190 "../lib/vala/FontConfig.vala"
			return result;
#line 1157 "FontConfig.c"
		}
	}
}

GType
font_manager_hint_style_get_type (void)
{
	static volatile gsize font_manager_hint_style_type_id__volatile = 0;
	if (g_once_init_enter (&font_manager_hint_style_type_id__volatile)) {
		static const GEnumValue values[] = {{FONT_MANAGER_HINT_STYLE_NONE, "FONT_MANAGER_HINT_STYLE_NONE", "none"}, {FONT_MANAGER_HINT_STYLE_SLIGHT, "FONT_MANAGER_HINT_STYLE_SLIGHT", "slight"}, {FONT_MANAGER_HINT_STYLE_MEDIUM, "FONT_MANAGER_HINT_STYLE_MEDIUM", "medium"}, {FONT_MANAGER_HINT_STYLE_FULL, "FONT_MANAGER_HINT_STYLE_FULL", "full"}, {0, NULL, NULL}};
		GType font_manager_hint_style_type_id;
		font_manager_hint_style_type_id = g_enum_register_static ("FontManagerHintStyle", values);
		g_once_init_leave (&font_manager_hint_style_type_id__volatile, font_manager_hint_style_type_id);
	}
	return font_manager_hint_style_type_id__volatile;
}

gchar*
font_manager_lcd_filter_to_string (FontManagerLCDFilter self)
{
	gchar* result = NULL;
#line 204 "../lib/vala/FontConfig.vala"
	switch (self) {
#line 204 "../lib/vala/FontConfig.vala"
		case FONT_MANAGER_LCD_FILTER_DEFAULT:
#line 1183 "FontConfig.c"
		{
			gchar* _tmp0_;
#line 206 "../lib/vala/FontConfig.vala"
			_tmp0_ = g_strdup (_ ("Default"));
#line 206 "../lib/vala/FontConfig.vala"
			result = _tmp0_;
#line 206 "../lib/vala/FontConfig.vala"
			return result;
#line 1192 "FontConfig.c"
		}
#line 204 "../lib/vala/FontConfig.vala"
		case FONT_MANAGER_LCD_FILTER_LIGHT:
#line 1196 "FontConfig.c"
		{
			gchar* _tmp1_;
#line 208 "../lib/vala/FontConfig.vala"
			_tmp1_ = g_strdup (_ ("Light"));
#line 208 "../lib/vala/FontConfig.vala"
			result = _tmp1_;
#line 208 "../lib/vala/FontConfig.vala"
			return result;
#line 1205 "FontConfig.c"
		}
#line 204 "../lib/vala/FontConfig.vala"
		case FONT_MANAGER_LCD_FILTER_LEGACY:
#line 1209 "FontConfig.c"
		{
			gchar* _tmp2_;
#line 210 "../lib/vala/FontConfig.vala"
			_tmp2_ = g_strdup (_ ("Legacy"));
#line 210 "../lib/vala/FontConfig.vala"
			result = _tmp2_;
#line 210 "../lib/vala/FontConfig.vala"
			return result;
#line 1218 "FontConfig.c"
		}
		default:
		{
			gchar* _tmp3_;
#line 212 "../lib/vala/FontConfig.vala"
			_tmp3_ = g_strdup (_ ("None"));
#line 212 "../lib/vala/FontConfig.vala"
			result = _tmp3_;
#line 212 "../lib/vala/FontConfig.vala"
			return result;
#line 1229 "FontConfig.c"
		}
	}
}

GType
font_manager_lcd_filter_get_type (void)
{
	static volatile gsize font_manager_lcd_filter_type_id__volatile = 0;
	if (g_once_init_enter (&font_manager_lcd_filter_type_id__volatile)) {
		static const GEnumValue values[] = {{FONT_MANAGER_LCD_FILTER_NONE, "FONT_MANAGER_LCD_FILTER_NONE", "none"}, {FONT_MANAGER_LCD_FILTER_DEFAULT, "FONT_MANAGER_LCD_FILTER_DEFAULT", "default"}, {FONT_MANAGER_LCD_FILTER_LIGHT, "FONT_MANAGER_LCD_FILTER_LIGHT", "light"}, {FONT_MANAGER_LCD_FILTER_LEGACY, "FONT_MANAGER_LCD_FILTER_LEGACY", "legacy"}, {0, NULL, NULL}};
		GType font_manager_lcd_filter_type_id;
		font_manager_lcd_filter_type_id = g_enum_register_static ("FontManagerLCDFilter", values);
		g_once_init_leave (&font_manager_lcd_filter_type_id__volatile, font_manager_lcd_filter_type_id);
	}
	return font_manager_lcd_filter_type_id__volatile;
}

gchar*
font_manager_subpixel_order_to_string (FontManagerSubpixelOrder self)
{
	gchar* result = NULL;
#line 228 "../lib/vala/FontConfig.vala"
	switch (self) {
#line 228 "../lib/vala/FontConfig.vala"
		case FONT_MANAGER_SUBPIXEL_ORDER_UNKNOWN:
#line 1255 "FontConfig.c"
		{
			gchar* _tmp0_;
#line 230 "../lib/vala/FontConfig.vala"
			_tmp0_ = g_strdup (_ ("Unknown"));
#line 230 "../lib/vala/FontConfig.vala"
			result = _tmp0_;
#line 230 "../lib/vala/FontConfig.vala"
			return result;
#line 1264 "FontConfig.c"
		}
#line 228 "../lib/vala/FontConfig.vala"
		case FONT_MANAGER_SUBPIXEL_ORDER_RGB:
#line 1268 "FontConfig.c"
		{
			gchar* _tmp1_;
#line 232 "../lib/vala/FontConfig.vala"
			_tmp1_ = g_strdup (_ ("RGB"));
#line 232 "../lib/vala/FontConfig.vala"
			result = _tmp1_;
#line 232 "../lib/vala/FontConfig.vala"
			return result;
#line 1277 "FontConfig.c"
		}
#line 228 "../lib/vala/FontConfig.vala"
		case FONT_MANAGER_SUBPIXEL_ORDER_BGR:
#line 1281 "FontConfig.c"
		{
			gchar* _tmp2_;
#line 234 "../lib/vala/FontConfig.vala"
			_tmp2_ = g_strdup (_ ("BGR"));
#line 234 "../lib/vala/FontConfig.vala"
			result = _tmp2_;
#line 234 "../lib/vala/FontConfig.vala"
			return result;
#line 1290 "FontConfig.c"
		}
#line 228 "../lib/vala/FontConfig.vala"
		case FONT_MANAGER_SUBPIXEL_ORDER_VRGB:
#line 1294 "FontConfig.c"
		{
			gchar* _tmp3_;
#line 236 "../lib/vala/FontConfig.vala"
			_tmp3_ = g_strdup (_ ("VRGB"));
#line 236 "../lib/vala/FontConfig.vala"
			result = _tmp3_;
#line 236 "../lib/vala/FontConfig.vala"
			return result;
#line 1303 "FontConfig.c"
		}
#line 228 "../lib/vala/FontConfig.vala"
		case FONT_MANAGER_SUBPIXEL_ORDER_VBGR:
#line 1307 "FontConfig.c"
		{
			gchar* _tmp4_;
#line 238 "../lib/vala/FontConfig.vala"
			_tmp4_ = g_strdup (_ ("VBGR"));
#line 238 "../lib/vala/FontConfig.vala"
			result = _tmp4_;
#line 238 "../lib/vala/FontConfig.vala"
			return result;
#line 1316 "FontConfig.c"
		}
		default:
		{
			gchar* _tmp5_;
#line 240 "../lib/vala/FontConfig.vala"
			_tmp5_ = g_strdup (_ ("None"));
#line 240 "../lib/vala/FontConfig.vala"
			result = _tmp5_;
#line 240 "../lib/vala/FontConfig.vala"
			return result;
#line 1327 "FontConfig.c"
		}
	}
}

GType
font_manager_subpixel_order_get_type (void)
{
	static volatile gsize font_manager_subpixel_order_type_id__volatile = 0;
	if (g_once_init_enter (&font_manager_subpixel_order_type_id__volatile)) {
		static const GEnumValue values[] = {{FONT_MANAGER_SUBPIXEL_ORDER_UNKNOWN, "FONT_MANAGER_SUBPIXEL_ORDER_UNKNOWN", "unknown"}, {FONT_MANAGER_SUBPIXEL_ORDER_RGB, "FONT_MANAGER_SUBPIXEL_ORDER_RGB", "rgb"}, {FONT_MANAGER_SUBPIXEL_ORDER_BGR, "FONT_MANAGER_SUBPIXEL_ORDER_BGR", "bgr"}, {FONT_MANAGER_SUBPIXEL_ORDER_VRGB, "FONT_MANAGER_SUBPIXEL_ORDER_VRGB", "vrgb"}, {FONT_MANAGER_SUBPIXEL_ORDER_VBGR, "FONT_MANAGER_SUBPIXEL_ORDER_VBGR", "vbgr"}, {FONT_MANAGER_SUBPIXEL_ORDER_NONE, "FONT_MANAGER_SUBPIXEL_ORDER_NONE", "none"}, {0, NULL, NULL}};
		GType font_manager_subpixel_order_type_id;
		font_manager_subpixel_order_type_id = g_enum_register_static ("FontManagerSubpixelOrder", values);
		g_once_init_leave (&font_manager_subpixel_order_type_id__volatile, font_manager_subpixel_order_type_id);
	}
	return font_manager_subpixel_order_type_id__volatile;
}

/**
     * load_user_font_resources:
     *
     * Adds user configured font sources (directories) and rejected fonts to our
     * FcConfig so that we can render fonts which are not actually "installed".
     */
static gpointer
_g_object_ref0 (gpointer self)
{
#line 259 "../lib/vala/FontConfig.vala"
	return self ? g_object_ref (self) : NULL;
#line 1356 "FontConfig.c"
}

gboolean
font_manager_load_user_font_resources (StringHashset* files,
                                       GList* sources)
{
	gboolean result = FALSE;
	gboolean res = FALSE;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gboolean _tmp2_;
#line 253 "../lib/vala/FontConfig.vala"
	clear_application_fonts ();
#line 254 "../lib/vala/FontConfig.vala"
	res = TRUE;
#line 255 "../lib/vala/FontConfig.vala"
	_tmp0_ = get_user_font_directory ();
#line 255 "../lib/vala/FontConfig.vala"
	_tmp1_ = _tmp0_;
#line 255 "../lib/vala/FontConfig.vala"
	_tmp2_ = !add_application_font_directory (_tmp1_);
#line 255 "../lib/vala/FontConfig.vala"
	_g_free0 (_tmp1_);
#line 255 "../lib/vala/FontConfig.vala"
	if (_tmp2_) {
#line 256 "../lib/vala/FontConfig.vala"
		res = FALSE;
#line 257 "../lib/vala/FontConfig.vala"
		g_critical ("FontConfig.vala:257: Failed to add default user font directory to conf" \
"iguration!");
#line 1386 "FontConfig.c"
	}
	{
		GList* source_collection = NULL;
		GList* source_it = NULL;
#line 259 "../lib/vala/FontConfig.vala"
		source_collection = sources;
#line 259 "../lib/vala/FontConfig.vala"
		for (source_it = source_collection; source_it != NULL; source_it = source_it->next) {
#line 1395 "FontConfig.c"
			FontManagerSource* _tmp3_;
			FontManagerSource* source = NULL;
#line 259 "../lib/vala/FontConfig.vala"
			_tmp3_ = _g_object_ref0 ((FontManagerSource*) source_it->data);
#line 259 "../lib/vala/FontConfig.vala"
			source = _tmp3_;
#line 1402 "FontConfig.c"
			{
				gboolean _tmp4_ = FALSE;
				FontManagerSource* _tmp5_;
				gboolean _tmp6_;
				gboolean _tmp7_;
#line 260 "../lib/vala/FontConfig.vala"
				_tmp5_ = source;
#line 260 "../lib/vala/FontConfig.vala"
				g_object_get (_tmp5_, "available", &_tmp6_, NULL);
#line 260 "../lib/vala/FontConfig.vala"
				_tmp7_ = _tmp6_;
#line 260 "../lib/vala/FontConfig.vala"
				if (_tmp7_) {
#line 1416 "FontConfig.c"
					FontManagerSource* _tmp8_;
					gchar* _tmp9_;
					gchar* _tmp10_;
					gchar* _tmp11_;
#line 260 "../lib/vala/FontConfig.vala"
					_tmp8_ = source;
#line 260 "../lib/vala/FontConfig.vala"
					g_object_get (_tmp8_, "path", &_tmp9_, NULL);
#line 260 "../lib/vala/FontConfig.vala"
					_tmp10_ = _tmp9_;
#line 260 "../lib/vala/FontConfig.vala"
					_tmp11_ = _tmp10_;
#line 260 "../lib/vala/FontConfig.vala"
					_tmp4_ = !add_application_font_directory (_tmp11_);
#line 260 "../lib/vala/FontConfig.vala"
					_g_free0 (_tmp11_);
#line 1433 "FontConfig.c"
				} else {
#line 260 "../lib/vala/FontConfig.vala"
					_tmp4_ = FALSE;
#line 1437 "FontConfig.c"
				}
#line 260 "../lib/vala/FontConfig.vala"
				if (_tmp4_) {
#line 1441 "FontConfig.c"
					FontManagerSource* _tmp12_;
					gchar* _tmp13_;
					gchar* _tmp14_;
					gchar* _tmp15_;
#line 261 "../lib/vala/FontConfig.vala"
					res = FALSE;
#line 262 "../lib/vala/FontConfig.vala"
					_tmp12_ = source;
#line 262 "../lib/vala/FontConfig.vala"
					g_object_get (_tmp12_, "path", &_tmp13_, NULL);
#line 262 "../lib/vala/FontConfig.vala"
					_tmp14_ = _tmp13_;
#line 262 "../lib/vala/FontConfig.vala"
					_tmp15_ = _tmp14_;
#line 262 "../lib/vala/FontConfig.vala"
					g_warning ("FontConfig.vala:262: Failed to register user font source! : %s", _tmp15_);
#line 262 "../lib/vala/FontConfig.vala"
					_g_free0 (_tmp15_);
#line 1460 "FontConfig.c"
				}
#line 259 "../lib/vala/FontConfig.vala"
				_g_object_unref0 (source);
#line 1464 "FontConfig.c"
			}
		}
	}
#line 265 "../lib/vala/FontConfig.vala"
	if (files != NULL) {
#line 1470 "FontConfig.c"
		{
			StringHashset* _path_list = NULL;
			StringHashset* _tmp16_;
			guint _path_size = 0U;
			StringHashset* _tmp17_;
			guint _tmp18_;
			guint _tmp19_;
			gint _path_index = 0;
#line 266 "../lib/vala/FontConfig.vala"
			_tmp16_ = _g_object_ref0 (files);
#line 266 "../lib/vala/FontConfig.vala"
			_path_list = _tmp16_;
#line 266 "../lib/vala/FontConfig.vala"
			_tmp17_ = _path_list;
#line 266 "../lib/vala/FontConfig.vala"
			g_object_get (_tmp17_, "size", &_tmp18_, NULL);
#line 266 "../lib/vala/FontConfig.vala"
			_tmp19_ = _tmp18_;
#line 266 "../lib/vala/FontConfig.vala"
			_path_size = _tmp19_;
#line 266 "../lib/vala/FontConfig.vala"
			_path_index = -1;
#line 266 "../lib/vala/FontConfig.vala"
			while (TRUE) {
#line 1495 "FontConfig.c"
				gchar* path = NULL;
				StringHashset* _tmp20_;
				const gchar* _tmp21_;
				gchar* _tmp22_;
				const gchar* _tmp23_;
#line 266 "../lib/vala/FontConfig.vala"
				_path_index = _path_index + 1;
#line 266 "../lib/vala/FontConfig.vala"
				if (!(((guint) _path_index) < _path_size)) {
#line 266 "../lib/vala/FontConfig.vala"
					break;
#line 1507 "FontConfig.c"
				}
#line 266 "../lib/vala/FontConfig.vala"
				_tmp20_ = _path_list;
#line 266 "../lib/vala/FontConfig.vala"
				_tmp21_ = string_hashset_get (_tmp20_, (guint) _path_index);
#line 266 "../lib/vala/FontConfig.vala"
				_tmp22_ = g_strdup (_tmp21_);
#line 266 "../lib/vala/FontConfig.vala"
				path = _tmp22_;
#line 267 "../lib/vala/FontConfig.vala"
				_tmp23_ = path;
#line 267 "../lib/vala/FontConfig.vala"
				add_application_font (_tmp23_);
#line 266 "../lib/vala/FontConfig.vala"
				_g_free0 (path);
#line 1523 "FontConfig.c"
			}
#line 266 "../lib/vala/FontConfig.vala"
			_g_object_unref0 (_path_list);
#line 1527 "FontConfig.c"
		}
	}
#line 268 "../lib/vala/FontConfig.vala"
	result = res;
#line 268 "../lib/vala/FontConfig.vala"
	return result;
#line 1534 "FontConfig.c"
}

FontManagerDefaultProperties*
font_manager_default_properties_construct (GType object_type)
{
	FontManagerDefaultProperties * self = NULL;
#line 276 "../lib/vala/FontConfig.vala"
	self = (FontManagerDefaultProperties*) g_object_new (object_type, NULL);
#line 277 "../lib/vala/FontConfig.vala"
	g_object_set ((FontManagerProperties*) self, "type", (gint) FONT_MANAGER_PROPERTIES_TYPE_DEFAULT, NULL);
#line 278 "../lib/vala/FontConfig.vala"
	g_object_set ((FontManagerProperties*) self, "target-file", "19-DefaultProperties.conf", NULL);
#line 279 "../lib/vala/FontConfig.vala"
	font_manager_properties_load ((FontManagerProperties*) self);
#line 276 "../lib/vala/FontConfig.vala"
	return self;
#line 1551 "FontConfig.c"
}

FontManagerDefaultProperties*
font_manager_default_properties_new (void)
{
#line 276 "../lib/vala/FontConfig.vala"
	return font_manager_default_properties_construct (FONT_MANAGER_TYPE_DEFAULT_PROPERTIES);
#line 1559 "FontConfig.c"
}

static void
font_manager_default_properties_class_init (FontManagerDefaultPropertiesClass * klass,
                                            gpointer klass_data)
{
#line 274 "../lib/vala/FontConfig.vala"
	font_manager_default_properties_parent_class = g_type_class_peek_parent (klass);
#line 1568 "FontConfig.c"
}

static void
font_manager_default_properties_instance_init (FontManagerDefaultProperties * self,
                                               gpointer klass)
{
}

/**
     * {@inheritDoc}
     */
GType
font_manager_default_properties_get_type (void)
{
	static volatile gsize font_manager_default_properties_type_id__volatile = 0;
	if (g_once_init_enter (&font_manager_default_properties_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (FontManagerDefaultPropertiesClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) font_manager_default_properties_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (FontManagerDefaultProperties), 0, (GInstanceInitFunc) font_manager_default_properties_instance_init, NULL };
		GType font_manager_default_properties_type_id;
		font_manager_default_properties_type_id = g_type_register_static (font_manager_properties_get_type (), "FontManagerDefaultProperties", &g_define_type_info, 0);
		g_once_init_leave (&font_manager_default_properties_type_id__volatile, font_manager_default_properties_type_id);
	}
	return font_manager_default_properties_type_id__volatile;
}

FontManagerDisplayProperties*
font_manager_display_properties_construct (GType object_type)
{
	FontManagerDisplayProperties * self = NULL;
#line 289 "../lib/vala/FontConfig.vala"
	self = (FontManagerDisplayProperties*) g_object_new (object_type, NULL);
#line 290 "../lib/vala/FontConfig.vala"
	g_object_set ((FontManagerProperties*) self, "type", (gint) FONT_MANAGER_PROPERTIES_TYPE_DISPLAY, NULL);
#line 291 "../lib/vala/FontConfig.vala"
	g_object_set ((FontManagerProperties*) self, "target-file", "19-DisplayProperties.conf", NULL);
#line 292 "../lib/vala/FontConfig.vala"
	font_manager_properties_load ((FontManagerProperties*) self);
#line 289 "../lib/vala/FontConfig.vala"
	return self;
#line 1607 "FontConfig.c"
}

FontManagerDisplayProperties*
font_manager_display_properties_new (void)
{
#line 289 "../lib/vala/FontConfig.vala"
	return font_manager_display_properties_construct (FONT_MANAGER_TYPE_DISPLAY_PROPERTIES);
#line 1615 "FontConfig.c"
}

static void
font_manager_display_properties_class_init (FontManagerDisplayPropertiesClass * klass,
                                            gpointer klass_data)
{
#line 287 "../lib/vala/FontConfig.vala"
	font_manager_display_properties_parent_class = g_type_class_peek_parent (klass);
#line 1624 "FontConfig.c"
}

static void
font_manager_display_properties_instance_init (FontManagerDisplayProperties * self,
                                               gpointer klass)
{
}

/**
     * {@inheritDoc}
     */
GType
font_manager_display_properties_get_type (void)
{
	static volatile gsize font_manager_display_properties_type_id__volatile = 0;
	if (g_once_init_enter (&font_manager_display_properties_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (FontManagerDisplayPropertiesClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) font_manager_display_properties_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (FontManagerDisplayProperties), 0, (GInstanceInitFunc) font_manager_display_properties_instance_init, NULL };
		GType font_manager_display_properties_type_id;
		font_manager_display_properties_type_id = g_type_register_static (font_manager_properties_get_type (), "FontManagerDisplayProperties", &g_define_type_info, 0);
		g_once_init_leave (&font_manager_display_properties_type_id__volatile, font_manager_display_properties_type_id);
	}
	return font_manager_display_properties_type_id__volatile;
}

static inline gpointer
font_manager_font_properties_get_instance_private (FontManagerFontProperties* self)
{
	return G_STRUCT_MEMBER_P (self, FontManagerFontProperties_private_offset);
}

static void
__lambda22_ (FontManagerFontProperties* self,
             GObject* source,
             GParamSpec* pspec)
{
#line 328 "../lib/vala/FontConfig.vala"
	g_return_if_fail (source != NULL);
#line 328 "../lib/vala/FontConfig.vala"
	g_return_if_fail (pspec != NULL);
#line 329 "../lib/vala/FontConfig.vala"
	font_manager_properties_load ((FontManagerProperties*) self);
#line 330 "../lib/vala/FontConfig.vala"
	g_signal_emit (self, font_manager_font_properties_signals[FONT_MANAGER_FONT_PROPERTIES_CHANGED_SIGNAL], 0);
#line 1668 "FontConfig.c"
}

static void
___lambda22__g_object_notify (GObject* _sender,
                              GParamSpec* pspec,
                              gpointer self)
{
#line 328 "../lib/vala/FontConfig.vala"
	__lambda22_ ((FontManagerFontProperties*) self, _sender, pspec);
#line 1678 "FontConfig.c"
}

static void
__lambda23_ (FontManagerFontProperties* self,
             GObject* s,
             GParamSpec* p)
{
	gchar* _tmp0_ = NULL;
	FontManagerFont* _tmp1_;
#line 332 "../lib/vala/FontConfig.vala"
	g_return_if_fail (s != NULL);
#line 332 "../lib/vala/FontConfig.vala"
	g_return_if_fail (p != NULL);
#line 333 "../lib/vala/FontConfig.vala"
	_tmp1_ = self->priv->_font;
#line 333 "../lib/vala/FontConfig.vala"
	if (font_manager_is_valid_source ((FontManagerJsonProxy*) _tmp1_)) {
#line 1696 "FontConfig.c"
		FontManagerFont* _tmp2_;
		gchar* _tmp3_;
		gchar* _tmp4_;
#line 333 "../lib/vala/FontConfig.vala"
		_tmp2_ = self->priv->_font;
#line 333 "../lib/vala/FontConfig.vala"
		g_object_get (_tmp2_, "family", &_tmp3_, NULL);
#line 333 "../lib/vala/FontConfig.vala"
		_tmp4_ = _tmp3_;
#line 333 "../lib/vala/FontConfig.vala"
		_g_free0 (_tmp0_);
#line 333 "../lib/vala/FontConfig.vala"
		_tmp0_ = _tmp4_;
#line 1710 "FontConfig.c"
	} else {
#line 333 "../lib/vala/FontConfig.vala"
		_g_free0 (_tmp0_);
#line 333 "../lib/vala/FontConfig.vala"
		_tmp0_ = NULL;
#line 1716 "FontConfig.c"
	}
#line 333 "../lib/vala/FontConfig.vala"
	font_manager_font_properties_set_family (self, _tmp0_);
#line 332 "../lib/vala/FontConfig.vala"
	_g_free0 (_tmp0_);
#line 1722 "FontConfig.c"
}

static void
___lambda23__g_object_notify (GObject* _sender,
                              GParamSpec* pspec,
                              gpointer self)
{
#line 332 "../lib/vala/FontConfig.vala"
	__lambda23_ ((FontManagerFontProperties*) self, _sender, pspec);
#line 1732 "FontConfig.c"
}

FontManagerFontProperties*
font_manager_font_properties_construct (GType object_type)
{
	FontManagerFontProperties * self = NULL;
#line 325 "../lib/vala/FontConfig.vala"
	self = (FontManagerFontProperties*) font_manager_default_properties_construct (object_type);
#line 326 "../lib/vala/FontConfig.vala"
	g_object_set ((FontManagerProperties*) self, "type", (gint) FONT_MANAGER_PROPERTIES_TYPE_DEFAULT, NULL);
#line 327 "../lib/vala/FontConfig.vala"
	g_object_set ((FontManagerProperties*) self, "target-file", "19-DefaultProperties.conf", NULL);
#line 328 "../lib/vala/FontConfig.vala"
	g_signal_connect_object ((GObject*) self, "notify::family", (GCallback) ___lambda22__g_object_notify, self, 0);
#line 332 "../lib/vala/FontConfig.vala"
	g_signal_connect_object ((GObject*) self, "notify::font", (GCallback) ___lambda23__g_object_notify, self, 0);
#line 335 "../lib/vala/FontConfig.vala"
	font_manager_properties_load ((FontManagerProperties*) self);
#line 325 "../lib/vala/FontConfig.vala"
	return self;
#line 1753 "FontConfig.c"
}

FontManagerFontProperties*
font_manager_font_properties_new (void)
{
#line 325 "../lib/vala/FontConfig.vala"
	return font_manager_font_properties_construct (FONT_MANAGER_TYPE_FONT_PROPERTIES);
#line 1761 "FontConfig.c"
}

/**
         * {@inheritDoc}
         */
static gboolean
font_manager_font_properties_real_load (FontManagerProperties* base)
{
	FontManagerFontProperties * self;
	gboolean result = FALSE;
	const gchar* _tmp0_;
	FontManagerFont* _tmp4_;
#line 341 "../lib/vala/FontConfig.vala"
	self = (FontManagerFontProperties*) base;
#line 343 "../lib/vala/FontConfig.vala"
	g_object_set ((FontManagerProperties*) self, "target-file", "19-DefaultProperties.conf", NULL);
#line 344 "../lib/vala/FontConfig.vala"
	FONT_MANAGER_PROPERTIES_CLASS (font_manager_font_properties_parent_class)->load ((FontManagerProperties*) G_TYPE_CHECK_INSTANCE_CAST (self, FONT_MANAGER_TYPE_DEFAULT_PROPERTIES, FontManagerDefaultProperties));
#line 346 "../lib/vala/FontConfig.vala"
	_tmp0_ = self->priv->_family;
#line 346 "../lib/vala/FontConfig.vala"
	if (_tmp0_ != NULL) {
#line 1784 "FontConfig.c"
		const gchar* _tmp1_;
		gchar* _tmp2_;
		gchar* _tmp3_;
#line 347 "../lib/vala/FontConfig.vala"
		_tmp1_ = self->priv->_family;
#line 347 "../lib/vala/FontConfig.vala"
		_tmp2_ = g_strdup_printf ("29-%s.conf", _tmp1_);
#line 347 "../lib/vala/FontConfig.vala"
		_tmp3_ = _tmp2_;
#line 347 "../lib/vala/FontConfig.vala"
		g_object_set ((FontManagerProperties*) self, "target-file", _tmp3_, NULL);
#line 347 "../lib/vala/FontConfig.vala"
		_g_free0 (_tmp3_);
#line 348 "../lib/vala/FontConfig.vala"
		FONT_MANAGER_PROPERTIES_CLASS (font_manager_font_properties_parent_class)->load ((FontManagerProperties*) G_TYPE_CHECK_INSTANCE_CAST (self, FONT_MANAGER_TYPE_DEFAULT_PROPERTIES, FontManagerDefaultProperties));
#line 1800 "FontConfig.c"
	}
#line 351 "../lib/vala/FontConfig.vala"
	_tmp4_ = self->priv->_font;
#line 351 "../lib/vala/FontConfig.vala"
	if (font_manager_is_valid_source ((FontManagerJsonProxy*) _tmp4_)) {
#line 1806 "FontConfig.c"
		FontManagerFont* _tmp5_;
		gchar* _tmp6_;
		gchar* _tmp7_;
		gchar* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
		gchar* _tmp11_;
		gchar* _tmp12_;
#line 352 "../lib/vala/FontConfig.vala"
		_tmp5_ = self->priv->_font;
#line 352 "../lib/vala/FontConfig.vala"
		g_object_get (_tmp5_, "description", &_tmp6_, NULL);
#line 352 "../lib/vala/FontConfig.vala"
		_tmp7_ = _tmp6_;
#line 352 "../lib/vala/FontConfig.vala"
		_tmp8_ = _tmp7_;
#line 352 "../lib/vala/FontConfig.vala"
		_tmp9_ = to_filename (_tmp8_);
#line 352 "../lib/vala/FontConfig.vala"
		_tmp10_ = _tmp9_;
#line 352 "../lib/vala/FontConfig.vala"
		_tmp11_ = g_strdup_printf ("29-%s.conf", _tmp10_);
#line 352 "../lib/vala/FontConfig.vala"
		_tmp12_ = _tmp11_;
#line 352 "../lib/vala/FontConfig.vala"
		g_object_set ((FontManagerProperties*) self, "target-file", _tmp12_, NULL);
#line 352 "../lib/vala/FontConfig.vala"
		_g_free0 (_tmp12_);
#line 352 "../lib/vala/FontConfig.vala"
		_g_free0 (_tmp10_);
#line 352 "../lib/vala/FontConfig.vala"
		_g_free0 (_tmp8_);
#line 353 "../lib/vala/FontConfig.vala"
		FONT_MANAGER_PROPERTIES_CLASS (font_manager_font_properties_parent_class)->load ((FontManagerProperties*) G_TYPE_CHECK_INSTANCE_CAST (self, FONT_MANAGER_TYPE_DEFAULT_PROPERTIES, FontManagerDefaultProperties));
#line 1841 "FontConfig.c"
	}
#line 355 "../lib/vala/FontConfig.vala"
	result = TRUE;
#line 355 "../lib/vala/FontConfig.vala"
	return result;
#line 1847 "FontConfig.c"
}

/**
         * {@inheritDoc}
         */
static void
font_manager_font_properties_real_add_match_criteria (FontManagerProperties* base,
                                                      FontManagerXmlWriter* writer)
{
	FontManagerFontProperties * self;
	const gchar* _tmp0_;
	FontManagerFont* _tmp2_;
#line 361 "../lib/vala/FontConfig.vala"
	self = (FontManagerFontProperties*) base;
#line 361 "../lib/vala/FontConfig.vala"
	g_return_if_fail (writer != NULL);
#line 362 "../lib/vala/FontConfig.vala"
	_tmp0_ = self->priv->_family;
#line 362 "../lib/vala/FontConfig.vala"
	if (_tmp0_ != NULL) {
#line 1868 "FontConfig.c"
		const gchar* _tmp1_;
#line 363 "../lib/vala/FontConfig.vala"
		_tmp1_ = self->priv->_family;
#line 363 "../lib/vala/FontConfig.vala"
		font_manager_xml_writer_add_test_element (writer, "family", "contains", "string", _tmp1_);
#line 1874 "FontConfig.c"
	}
#line 364 "../lib/vala/FontConfig.vala"
	_tmp2_ = self->priv->_font;
#line 364 "../lib/vala/FontConfig.vala"
	if (font_manager_is_valid_source ((FontManagerJsonProxy*) _tmp2_)) {
#line 1880 "FontConfig.c"
		FontManagerFont* _tmp3_;
		gint _tmp4_;
		gint _tmp5_;
		gchar* _tmp6_;
		gchar* _tmp7_;
		FontManagerFont* _tmp8_;
		gint _tmp9_;
		gint _tmp10_;
		gchar* _tmp11_;
		gchar* _tmp12_;
		FontManagerFont* _tmp13_;
		gint _tmp14_;
		gint _tmp15_;
		gchar* _tmp16_;
		gchar* _tmp17_;
#line 365 "../lib/vala/FontConfig.vala"
		_tmp3_ = self->priv->_font;
#line 365 "../lib/vala/FontConfig.vala"
		g_object_get (_tmp3_, "slant", &_tmp4_, NULL);
#line 365 "../lib/vala/FontConfig.vala"
		_tmp5_ = _tmp4_;
#line 365 "../lib/vala/FontConfig.vala"
		_tmp6_ = g_strdup_printf ("%i", _tmp5_);
#line 365 "../lib/vala/FontConfig.vala"
		_tmp7_ = _tmp6_;
#line 365 "../lib/vala/FontConfig.vala"
		font_manager_xml_writer_add_test_element (writer, "slant", "eq", "int", _tmp7_);
#line 365 "../lib/vala/FontConfig.vala"
		_g_free0 (_tmp7_);
#line 366 "../lib/vala/FontConfig.vala"
		_tmp8_ = self->priv->_font;
#line 366 "../lib/vala/FontConfig.vala"
		g_object_get (_tmp8_, "weight", &_tmp9_, NULL);
#line 366 "../lib/vala/FontConfig.vala"
		_tmp10_ = _tmp9_;
#line 366 "../lib/vala/FontConfig.vala"
		_tmp11_ = g_strdup_printf ("%i", _tmp10_);
#line 366 "../lib/vala/FontConfig.vala"
		_tmp12_ = _tmp11_;
#line 366 "../lib/vala/FontConfig.vala"
		font_manager_xml_writer_add_test_element (writer, "weight", "eq", "int", _tmp12_);
#line 366 "../lib/vala/FontConfig.vala"
		_g_free0 (_tmp12_);
#line 367 "../lib/vala/FontConfig.vala"
		_tmp13_ = self->priv->_font;
#line 367 "../lib/vala/FontConfig.vala"
		g_object_get (_tmp13_, "width", &_tmp14_, NULL);
#line 367 "../lib/vala/FontConfig.vala"
		_tmp15_ = _tmp14_;
#line 367 "../lib/vala/FontConfig.vala"
		_tmp16_ = g_strdup_printf ("%i", _tmp15_);
#line 367 "../lib/vala/FontConfig.vala"
		_tmp17_ = _tmp16_;
#line 367 "../lib/vala/FontConfig.vala"
		font_manager_xml_writer_add_test_element (writer, "width", "eq", "int", _tmp17_);
#line 367 "../lib/vala/FontConfig.vala"
		_g_free0 (_tmp17_);
#line 1938 "FontConfig.c"
	}
#line 369 "../lib/vala/FontConfig.vala"
	FONT_MANAGER_PROPERTIES_CLASS (font_manager_font_properties_parent_class)->add_match_criteria ((FontManagerProperties*) G_TYPE_CHECK_INSTANCE_CAST (self, FONT_MANAGER_TYPE_DEFAULT_PROPERTIES, FontManagerDefaultProperties), writer);
#line 370 "../lib/vala/FontConfig.vala"
	return;
#line 1944 "FontConfig.c"
}

const gchar*
font_manager_font_properties_get_family (FontManagerFontProperties* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 315 "../lib/vala/FontConfig.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 315 "../lib/vala/FontConfig.vala"
	_tmp0_ = self->priv->_family;
#line 315 "../lib/vala/FontConfig.vala"
	result = _tmp0_;
#line 315 "../lib/vala/FontConfig.vala"
	return result;
#line 1960 "FontConfig.c"
}

void
font_manager_font_properties_set_family (FontManagerFontProperties* self,
                                         const gchar* value)
{
#line 315 "../lib/vala/FontConfig.vala"
	g_return_if_fail (self != NULL);
#line 315 "../lib/vala/FontConfig.vala"
	if (g_strcmp0 (value, font_manager_font_properties_get_family (self)) != 0) {
#line 1971 "FontConfig.c"
		gchar* _tmp0_;
#line 315 "../lib/vala/FontConfig.vala"
		_tmp0_ = g_strdup (value);
#line 315 "../lib/vala/FontConfig.vala"
		_g_free0 (self->priv->_family);
#line 315 "../lib/vala/FontConfig.vala"
		self->priv->_family = _tmp0_;
#line 315 "../lib/vala/FontConfig.vala"
		g_object_notify_by_pspec ((GObject *) self, font_manager_font_properties_properties[FONT_MANAGER_FONT_PROPERTIES_FAMILY_PROPERTY]);
#line 1981 "FontConfig.c"
	}
}

FontManagerFont*
font_manager_font_properties_get_font (FontManagerFontProperties* self)
{
	FontManagerFont* result;
	FontManagerFont* _tmp0_;
#line 323 "../lib/vala/FontConfig.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 323 "../lib/vala/FontConfig.vala"
	_tmp0_ = self->priv->_font;
#line 323 "../lib/vala/FontConfig.vala"
	result = _tmp0_;
#line 323 "../lib/vala/FontConfig.vala"
	return result;
#line 1998 "FontConfig.c"
}

void
font_manager_font_properties_set_font (FontManagerFontProperties* self,
                                       FontManagerFont* value)
{
#line 323 "../lib/vala/FontConfig.vala"
	g_return_if_fail (self != NULL);
#line 323 "../lib/vala/FontConfig.vala"
	if (font_manager_font_properties_get_font (self) != value) {
#line 2009 "FontConfig.c"
		FontManagerFont* _tmp0_;
#line 323 "../lib/vala/FontConfig.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 323 "../lib/vala/FontConfig.vala"
		_g_object_unref0 (self->priv->_font);
#line 323 "../lib/vala/FontConfig.vala"
		self->priv->_font = _tmp0_;
#line 323 "../lib/vala/FontConfig.vala"
		g_object_notify_by_pspec ((GObject *) self, font_manager_font_properties_properties[FONT_MANAGER_FONT_PROPERTIES_FONT_PROPERTY]);
#line 2019 "FontConfig.c"
	}
}

static void
font_manager_font_properties_class_init (FontManagerFontPropertiesClass * klass,
                                         gpointer klass_data)
{
#line 300 "../lib/vala/FontConfig.vala"
	font_manager_font_properties_parent_class = g_type_class_peek_parent (klass);
#line 300 "../lib/vala/FontConfig.vala"
	g_type_class_adjust_private_offset (klass, &FontManagerFontProperties_private_offset);
#line 300 "../lib/vala/FontConfig.vala"
	((FontManagerPropertiesClass *) klass)->load = (gboolean (*) (FontManagerProperties*)) font_manager_font_properties_real_load;
#line 300 "../lib/vala/FontConfig.vala"
	((FontManagerPropertiesClass *) klass)->add_match_criteria = (void (*) (FontManagerProperties*, FontManagerXmlWriter*)) font_manager_font_properties_real_add_match_criteria;
#line 300 "../lib/vala/FontConfig.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_font_manager_font_properties_get_property;
#line 300 "../lib/vala/FontConfig.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_font_manager_font_properties_set_property;
#line 300 "../lib/vala/FontConfig.vala"
	G_OBJECT_CLASS (klass)->finalize = font_manager_font_properties_finalize;
#line 2041 "FontConfig.c"
	/**
	         * FontProperties:family:
	         *
	         * Name of font family this configuration will apply to.
	         * If only family is set, configuration will apply to all variations.
	         */
#line 300 "../lib/vala/FontConfig.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), FONT_MANAGER_FONT_PROPERTIES_FAMILY_PROPERTY, font_manager_font_properties_properties[FONT_MANAGER_FONT_PROPERTIES_FAMILY_PROPERTY] = g_param_spec_string ("family", "family", "family", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 2050 "FontConfig.c"
	/**
	         * FontProperties:font:
	         *
	         * #Font this configuration will apply to.
	         * If font is set, configuration will apply only to that specific variation.
	         */
#line 300 "../lib/vala/FontConfig.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), FONT_MANAGER_FONT_PROPERTIES_FONT_PROPERTY, font_manager_font_properties_properties[FONT_MANAGER_FONT_PROPERTIES_FONT_PROPERTY] = g_param_spec_object ("font", "font", "font", font_manager_font_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 2059 "FontConfig.c"
	/**
	         * FontProperties:changed:
	         *
	         * Emitted whenever family or font changes.
	         */
#line 300 "../lib/vala/FontConfig.vala"
	font_manager_font_properties_signals[FONT_MANAGER_FONT_PROPERTIES_CHANGED_SIGNAL] = g_signal_new ("changed", FONT_MANAGER_TYPE_FONT_PROPERTIES, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 2067 "FontConfig.c"
}

static void
font_manager_font_properties_instance_init (FontManagerFontProperties * self,
                                            gpointer klass)
{
#line 300 "../lib/vala/FontConfig.vala"
	self->priv = font_manager_font_properties_get_instance_private (self);
#line 315 "../lib/vala/FontConfig.vala"
	self->priv->_family = NULL;
#line 323 "../lib/vala/FontConfig.vala"
	self->priv->_font = NULL;
#line 2080 "FontConfig.c"
}

static void
font_manager_font_properties_finalize (GObject * obj)
{
	FontManagerFontProperties * self;
#line 300 "../lib/vala/FontConfig.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, FONT_MANAGER_TYPE_FONT_PROPERTIES, FontManagerFontProperties);
#line 315 "../lib/vala/FontConfig.vala"
	_g_free0 (self->priv->_family);
#line 323 "../lib/vala/FontConfig.vala"
	_g_object_unref0 (self->priv->_font);
#line 300 "../lib/vala/FontConfig.vala"
	G_OBJECT_CLASS (font_manager_font_properties_parent_class)->finalize (obj);
#line 2095 "FontConfig.c"
}

/**
     * {@inheritDoc}
     */
GType
font_manager_font_properties_get_type (void)
{
	static volatile gsize font_manager_font_properties_type_id__volatile = 0;
	if (g_once_init_enter (&font_manager_font_properties_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (FontManagerFontPropertiesClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) font_manager_font_properties_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (FontManagerFontProperties), 0, (GInstanceInitFunc) font_manager_font_properties_instance_init, NULL };
		GType font_manager_font_properties_type_id;
		font_manager_font_properties_type_id = g_type_register_static (FONT_MANAGER_TYPE_DEFAULT_PROPERTIES, "FontManagerFontProperties", &g_define_type_info, 0);
		FontManagerFontProperties_private_offset = g_type_add_instance_private (font_manager_font_properties_type_id, sizeof (FontManagerFontPropertiesPrivate));
		g_once_init_leave (&font_manager_font_properties_type_id__volatile, font_manager_font_properties_type_id);
	}
	return font_manager_font_properties_type_id__volatile;
}

static void
_vala_font_manager_font_properties_get_property (GObject * object,
                                                 guint property_id,
                                                 GValue * value,
                                                 GParamSpec * pspec)
{
	FontManagerFontProperties * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, FONT_MANAGER_TYPE_FONT_PROPERTIES, FontManagerFontProperties);
#line 300 "../lib/vala/FontConfig.vala"
	switch (property_id) {
#line 300 "../lib/vala/FontConfig.vala"
		case FONT_MANAGER_FONT_PROPERTIES_FAMILY_PROPERTY:
#line 300 "../lib/vala/FontConfig.vala"
		g_value_set_string (value, font_manager_font_properties_get_family (self));
#line 300 "../lib/vala/FontConfig.vala"
		break;
#line 300 "../lib/vala/FontConfig.vala"
		case FONT_MANAGER_FONT_PROPERTIES_FONT_PROPERTY:
#line 300 "../lib/vala/FontConfig.vala"
		g_value_set_object (value, font_manager_font_properties_get_font (self));
#line 300 "../lib/vala/FontConfig.vala"
		break;
#line 2137 "FontConfig.c"
		default:
#line 300 "../lib/vala/FontConfig.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 300 "../lib/vala/FontConfig.vala"
		break;
#line 2143 "FontConfig.c"
	}
}

static void
_vala_font_manager_font_properties_set_property (GObject * object,
                                                 guint property_id,
                                                 const GValue * value,
                                                 GParamSpec * pspec)
{
	FontManagerFontProperties * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, FONT_MANAGER_TYPE_FONT_PROPERTIES, FontManagerFontProperties);
#line 300 "../lib/vala/FontConfig.vala"
	switch (property_id) {
#line 300 "../lib/vala/FontConfig.vala"
		case FONT_MANAGER_FONT_PROPERTIES_FAMILY_PROPERTY:
#line 300 "../lib/vala/FontConfig.vala"
		font_manager_font_properties_set_family (self, g_value_get_string (value));
#line 300 "../lib/vala/FontConfig.vala"
		break;
#line 300 "../lib/vala/FontConfig.vala"
		case FONT_MANAGER_FONT_PROPERTIES_FONT_PROPERTY:
#line 300 "../lib/vala/FontConfig.vala"
		font_manager_font_properties_set_font (self, g_value_get_object (value));
#line 300 "../lib/vala/FontConfig.vala"
		break;
#line 2169 "FontConfig.c"
		default:
#line 300 "../lib/vala/FontConfig.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 300 "../lib/vala/FontConfig.vala"
		break;
#line 2175 "FontConfig.c"
	}
}

FontManagerAccept*
font_manager_accept_construct (GType object_type)
{
	FontManagerAccept * self = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
#line 380 "../lib/vala/FontConfig.vala"
	self = (FontManagerAccept*) g_object_new (object_type, NULL);
#line 381 "../lib/vala/FontConfig.vala"
	_tmp0_ = get_user_fontconfig_directory ();
#line 381 "../lib/vala/FontConfig.vala"
	_tmp1_ = _tmp0_;
#line 381 "../lib/vala/FontConfig.vala"
	g_object_set ((FontManagerSelections*) self, "config-dir", _tmp1_, NULL);
#line 381 "../lib/vala/FontConfig.vala"
	_g_free0 (_tmp1_);
#line 382 "../lib/vala/FontConfig.vala"
	g_object_set ((FontManagerSelections*) self, "target-element", "acceptfont", NULL);
#line 383 "../lib/vala/FontConfig.vala"
	g_object_set ((FontManagerSelections*) self, "target-file", "79-Accept.conf", NULL);
#line 380 "../lib/vala/FontConfig.vala"
	return self;
#line 2201 "FontConfig.c"
}

FontManagerAccept*
font_manager_accept_new (void)
{
#line 380 "../lib/vala/FontConfig.vala"
	return font_manager_accept_construct (FONT_MANAGER_TYPE_ACCEPT);
#line 2209 "FontConfig.c"
}

static void
font_manager_accept_class_init (FontManagerAcceptClass * klass,
                                gpointer klass_data)
{
#line 378 "../lib/vala/FontConfig.vala"
	font_manager_accept_parent_class = g_type_class_peek_parent (klass);
#line 2218 "FontConfig.c"
}

static void
font_manager_accept_instance_init (FontManagerAccept * self,
                                   gpointer klass)
{
}

/**
     * {@inheritDoc}
     */
GType
font_manager_accept_get_type (void)
{
	static volatile gsize font_manager_accept_type_id__volatile = 0;
	if (g_once_init_enter (&font_manager_accept_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (FontManagerAcceptClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) font_manager_accept_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (FontManagerAccept), 0, (GInstanceInitFunc) font_manager_accept_instance_init, NULL };
		GType font_manager_accept_type_id;
		font_manager_accept_type_id = g_type_register_static (font_manager_selections_get_type (), "FontManagerAccept", &g_define_type_info, 0);
		g_once_init_leave (&font_manager_accept_type_id__volatile, font_manager_accept_type_id);
	}
	return font_manager_accept_type_id__volatile;
}

FontManagerDirectories*
font_manager_directories_construct (GType object_type)
{
	FontManagerDirectories * self = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
#line 396 "../lib/vala/FontConfig.vala"
	self = (FontManagerDirectories*) g_object_new (object_type, NULL);
#line 397 "../lib/vala/FontConfig.vala"
	_tmp0_ = get_user_fontconfig_directory ();
#line 397 "../lib/vala/FontConfig.vala"
	_tmp1_ = _tmp0_;
#line 397 "../lib/vala/FontConfig.vala"
	g_object_set ((FontManagerSelections*) self, "config-dir", _tmp1_, NULL);
#line 397 "../lib/vala/FontConfig.vala"
	_g_free0 (_tmp1_);
#line 398 "../lib/vala/FontConfig.vala"
	g_object_set ((FontManagerSelections*) self, "target-element", "dir", NULL);
#line 399 "../lib/vala/FontConfig.vala"
	g_object_set ((FontManagerSelections*) self, "target-file", "09-Directories.conf", NULL);
#line 396 "../lib/vala/FontConfig.vala"
	return self;
#line 2265 "FontConfig.c"
}

FontManagerDirectories*
font_manager_directories_new (void)
{
#line 396 "../lib/vala/FontConfig.vala"
	return font_manager_directories_construct (FONT_MANAGER_TYPE_DIRECTORIES);
#line 2273 "FontConfig.c"
}

/**
         * {@inheritDoc}
         */
static xmlNode*
font_manager_directories_real_get_selections (FontManagerSelections* base,
                                              xmlDoc* doc)
{
	FontManagerDirectories * self;
	xmlNode* result = NULL;
	xmlNode* root = NULL;
	xmlNode* _tmp0_;
	xmlNode* _tmp1_ = NULL;
	xmlNode* _tmp2_;
#line 405 "../lib/vala/FontConfig.vala"
	self = (FontManagerDirectories*) base;
#line 406 "../lib/vala/FontConfig.vala"
	_tmp0_ = xmlDocGetRootElement (doc);
#line 406 "../lib/vala/FontConfig.vala"
	root = _tmp0_;
#line 407 "../lib/vala/FontConfig.vala"
	_tmp2_ = root;
#line 407 "../lib/vala/FontConfig.vala"
	if (_tmp2_ != NULL) {
#line 2299 "FontConfig.c"
		xmlNode* _tmp3_;
		xmlNode* _tmp4_;
#line 407 "../lib/vala/FontConfig.vala"
		_tmp3_ = root;
#line 407 "../lib/vala/FontConfig.vala"
		_tmp4_ = _tmp3_->children;
#line 407 "../lib/vala/FontConfig.vala"
		_tmp1_ = _tmp4_;
#line 2308 "FontConfig.c"
	} else {
#line 407 "../lib/vala/FontConfig.vala"
		_tmp1_ = NULL;
#line 2312 "FontConfig.c"
	}
#line 407 "../lib/vala/FontConfig.vala"
	result = _tmp1_;
#line 407 "../lib/vala/FontConfig.vala"
	return result;
#line 2318 "FontConfig.c"
}

/**
         * {@inheritDoc}
         */
static void
_g_free0_ (gpointer var)
{
#line 414 "../lib/vala/FontConfig.vala"
	var = (g_free (var), NULL);
#line 2329 "FontConfig.c"
}

static inline void
_g_list_free__g_free0_ (GList* self)
{
#line 414 "../lib/vala/FontConfig.vala"
	g_list_free_full (self, (GDestroyNotify) _g_free0_);
#line 2337 "FontConfig.c"
}

static void
font_manager_directories_real_write_selections (FontManagerSelections* base,
                                                FontManagerXmlWriter* writer)
{
	FontManagerDirectories * self;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	GList* _tmp3_;
	GList* _tmp4_;
#line 413 "../lib/vala/FontConfig.vala"
	self = (FontManagerDirectories*) base;
#line 413 "../lib/vala/FontConfig.vala"
	g_return_if_fail (writer != NULL);
#line 414 "../lib/vala/FontConfig.vala"
	g_object_get ((FontManagerSelections*) self, "target-element", &_tmp0_, NULL);
#line 414 "../lib/vala/FontConfig.vala"
	_tmp1_ = _tmp0_;
#line 414 "../lib/vala/FontConfig.vala"
	_tmp2_ = _tmp1_;
#line 414 "../lib/vala/FontConfig.vala"
	_tmp3_ = string_hashset_list ((StringHashset*) self);
#line 414 "../lib/vala/FontConfig.vala"
	_tmp4_ = _tmp3_;
#line 414 "../lib/vala/FontConfig.vala"
	font_manager_xml_writer_add_elements (writer, _tmp2_, _tmp4_);
#line 414 "../lib/vala/FontConfig.vala"
	(_tmp4_ == NULL) ? NULL : (_tmp4_ = (_g_list_free__g_free0_ (_tmp4_), NULL));
#line 414 "../lib/vala/FontConfig.vala"
	_g_free0 (_tmp2_);
#line 415 "../lib/vala/FontConfig.vala"
	return;
#line 2372 "FontConfig.c"
}

static void
font_manager_directories_class_init (FontManagerDirectoriesClass * klass,
                                     gpointer klass_data)
{
#line 394 "../lib/vala/FontConfig.vala"
	font_manager_directories_parent_class = g_type_class_peek_parent (klass);
#line 394 "../lib/vala/FontConfig.vala"
	((FontManagerSelectionsClass *) klass)->get_selections = (xmlNode* (*) (FontManagerSelections*, xmlDoc*)) font_manager_directories_real_get_selections;
#line 394 "../lib/vala/FontConfig.vala"
	((FontManagerSelectionsClass *) klass)->write_selections = (void (*) (FontManagerSelections*, FontManagerXmlWriter*)) font_manager_directories_real_write_selections;
#line 2385 "FontConfig.c"
}

static void
font_manager_directories_instance_init (FontManagerDirectories * self,
                                        gpointer klass)
{
}

/**
     * Directories - Represents a Fontconfig configuration file
     *
     * <dir> elements contain a directory path which will be scanned
     * for font files to include in the set of available fonts.
     */
GType
font_manager_directories_get_type (void)
{
	static volatile gsize font_manager_directories_type_id__volatile = 0;
	if (g_once_init_enter (&font_manager_directories_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (FontManagerDirectoriesClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) font_manager_directories_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (FontManagerDirectories), 0, (GInstanceInitFunc) font_manager_directories_instance_init, NULL };
		GType font_manager_directories_type_id;
		font_manager_directories_type_id = g_type_register_static (font_manager_selections_get_type (), "FontManagerDirectories", &g_define_type_info, 0);
		g_once_init_leave (&font_manager_directories_type_id__volatile, font_manager_directories_type_id);
	}
	return font_manager_directories_type_id__volatile;
}

static gboolean
__lambda25_ (FontManagerReject* self)
{
	gboolean result = FALSE;
#line 431 "../lib/vala/FontConfig.vala"
	font_manager_selections_load ((FontManagerSelections*) self);
#line 432 "../lib/vala/FontConfig.vala"
	result = FALSE;
#line 432 "../lib/vala/FontConfig.vala"
	return result;
#line 2423 "FontConfig.c"
}

static gboolean
___lambda25__gsource_func (gpointer self)
{
	gboolean result;
	result = __lambda25_ ((FontManagerReject*) self);
#line 430 "../lib/vala/FontConfig.vala"
	return result;
#line 2433 "FontConfig.c"
}

static void
__lambda24_ (FontManagerReject* self)
{
#line 430 "../lib/vala/FontConfig.vala"
	g_timeout_add_seconds_full (G_PRIORITY_DEFAULT, (guint) 3, ___lambda25__gsource_func, g_object_ref (self), g_object_unref);
#line 2441 "FontConfig.c"
}

static void
___lambda24__font_manager_selections_changed (FontManagerSelections* _sender,
                                              gpointer self)
{
#line 429 "../lib/vala/FontConfig.vala"
	__lambda24_ ((FontManagerReject*) self);
#line 2450 "FontConfig.c"
}

FontManagerReject*
font_manager_reject_construct (GType object_type)
{
	FontManagerReject * self = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
#line 425 "../lib/vala/FontConfig.vala"
	self = (FontManagerReject*) g_object_new (object_type, NULL);
#line 426 "../lib/vala/FontConfig.vala"
	_tmp0_ = get_user_fontconfig_directory ();
#line 426 "../lib/vala/FontConfig.vala"
	_tmp1_ = _tmp0_;
#line 426 "../lib/vala/FontConfig.vala"
	g_object_set ((FontManagerSelections*) self, "config-dir", _tmp1_, NULL);
#line 426 "../lib/vala/FontConfig.vala"
	_g_free0 (_tmp1_);
#line 427 "../lib/vala/FontConfig.vala"
	g_object_set ((FontManagerSelections*) self, "target-element", "rejectfont", NULL);
#line 428 "../lib/vala/FontConfig.vala"
	g_object_set ((FontManagerSelections*) self, "target-file", "78-Reject.conf", NULL);
#line 429 "../lib/vala/FontConfig.vala"
	g_signal_connect_object ((FontManagerSelections*) self, "changed", (GCallback) ___lambda24__font_manager_selections_changed, self, 0);
#line 425 "../lib/vala/FontConfig.vala"
	return self;
#line 2477 "FontConfig.c"
}

FontManagerReject*
font_manager_reject_new (void)
{
#line 425 "../lib/vala/FontConfig.vala"
	return font_manager_reject_construct (FONT_MANAGER_TYPE_REJECT);
#line 2485 "FontConfig.c"
}

StringHashset*
font_manager_reject_get_rejected_files (FontManagerReject* self)
{
	StringHashset* result = NULL;
	StringHashset* results = NULL;
	StringHashset* _tmp0_;
	GError* _inner_error0_ = NULL;
#line 437 "../lib/vala/FontConfig.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 438 "../lib/vala/FontConfig.vala"
	_tmp0_ = string_hashset_new ();
#line 438 "../lib/vala/FontConfig.vala"
	results = _tmp0_;
#line 2501 "FontConfig.c"
	{
		FontManagerDatabase* db = NULL;
		FontManagerDatabase* _tmp1_;
#line 440 "../lib/vala/FontConfig.vala"
		_tmp1_ = font_manager_get_database (FONT_MANAGER_DATABASE_TYPE_FONT, &_inner_error0_);
#line 440 "../lib/vala/FontConfig.vala"
		db = _tmp1_;
#line 440 "../lib/vala/FontConfig.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 2511 "FontConfig.c"
			goto __catch6_g_error;
		}
		{
			FontManagerReject* _family_list = NULL;
			FontManagerReject* _tmp2_;
			guint _family_size = 0U;
			FontManagerReject* _tmp3_;
			guint _tmp4_;
			guint _tmp5_;
			gint _family_index = 0;
#line 441 "../lib/vala/FontConfig.vala"
			_tmp2_ = _g_object_ref0 (self);
#line 441 "../lib/vala/FontConfig.vala"
			_family_list = _tmp2_;
#line 441 "../lib/vala/FontConfig.vala"
			_tmp3_ = _family_list;
#line 441 "../lib/vala/FontConfig.vala"
			g_object_get ((StringHashset*) _tmp3_, "size", &_tmp4_, NULL);
#line 441 "../lib/vala/FontConfig.vala"
			_tmp5_ = _tmp4_;
#line 441 "../lib/vala/FontConfig.vala"
			_family_size = _tmp5_;
#line 441 "../lib/vala/FontConfig.vala"
			_family_index = -1;
#line 441 "../lib/vala/FontConfig.vala"
			while (TRUE) {
#line 2538 "FontConfig.c"
				gchar* family = NULL;
				FontManagerReject* _tmp6_;
				const gchar* _tmp7_;
				gchar* _tmp8_;
				gchar* sql = NULL;
				const gchar* _tmp9_;
				gchar* _tmp10_;
				FontManagerDatabase* _tmp11_;
				const gchar* _tmp12_;
#line 441 "../lib/vala/FontConfig.vala"
				_family_index = _family_index + 1;
#line 441 "../lib/vala/FontConfig.vala"
				if (!(((guint) _family_index) < _family_size)) {
#line 441 "../lib/vala/FontConfig.vala"
					break;
#line 2554 "FontConfig.c"
				}
#line 441 "../lib/vala/FontConfig.vala"
				_tmp6_ = _family_list;
#line 441 "../lib/vala/FontConfig.vala"
				_tmp7_ = string_hashset_get ((StringHashset*) _tmp6_, (guint) _family_index);
#line 441 "../lib/vala/FontConfig.vala"
				_tmp8_ = g_strdup (_tmp7_);
#line 441 "../lib/vala/FontConfig.vala"
				family = _tmp8_;
#line 442 "../lib/vala/FontConfig.vala"
				_tmp9_ = family;
#line 442 "../lib/vala/FontConfig.vala"
				_tmp10_ = g_strdup_printf ("SELECT DISTINCT filepath FROM Fonts WHERE family = '%s'", _tmp9_);
#line 442 "../lib/vala/FontConfig.vala"
				sql = _tmp10_;
#line 443 "../lib/vala/FontConfig.vala"
				_tmp11_ = db;
#line 443 "../lib/vala/FontConfig.vala"
				_tmp12_ = sql;
#line 443 "../lib/vala/FontConfig.vala"
				font_manager_database_execute_query (_tmp11_, _tmp12_, &_inner_error0_);
#line 443 "../lib/vala/FontConfig.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 443 "../lib/vala/FontConfig.vala"
					_g_free0 (sql);
#line 443 "../lib/vala/FontConfig.vala"
					_g_free0 (family);
#line 443 "../lib/vala/FontConfig.vala"
					_g_object_unref0 (_family_list);
#line 443 "../lib/vala/FontConfig.vala"
					_g_object_unref0 (db);
#line 2586 "FontConfig.c"
					goto __catch6_g_error;
				}
				{
					FontManagerDatabaseIterator* _stmt_it = NULL;
					FontManagerDatabase* _tmp13_;
					FontManagerDatabaseIterator* _tmp14_;
#line 444 "../lib/vala/FontConfig.vala"
					_tmp13_ = db;
#line 444 "../lib/vala/FontConfig.vala"
					_tmp14_ = font_manager_database_iterator (_tmp13_);
#line 444 "../lib/vala/FontConfig.vala"
					_stmt_it = _tmp14_;
#line 444 "../lib/vala/FontConfig.vala"
					while (TRUE) {
#line 2601 "FontConfig.c"
						FontManagerDatabaseIterator* _tmp15_;
						sqlite3_stmt* stmt = NULL;
						FontManagerDatabaseIterator* _tmp16_;
						sqlite3_stmt* _tmp17_;
						gchar* path = NULL;
						sqlite3_stmt* _tmp18_;
						const gchar* _tmp19_;
						gchar* _tmp20_;
						const gchar* _tmp21_;
						GFile* _tmp22_;
						GFile* _tmp23_;
						gboolean _tmp24_;
#line 444 "../lib/vala/FontConfig.vala"
						_tmp15_ = _stmt_it;
#line 444 "../lib/vala/FontConfig.vala"
						if (!font_manager_database_iterator_next (_tmp15_)) {
#line 444 "../lib/vala/FontConfig.vala"
							break;
#line 2620 "FontConfig.c"
						}
#line 444 "../lib/vala/FontConfig.vala"
						_tmp16_ = _stmt_it;
#line 444 "../lib/vala/FontConfig.vala"
						_tmp17_ = font_manager_database_iterator_get (_tmp16_);
#line 444 "../lib/vala/FontConfig.vala"
						stmt = _tmp17_;
#line 445 "../lib/vala/FontConfig.vala"
						_tmp18_ = stmt;
#line 445 "../lib/vala/FontConfig.vala"
						_tmp19_ = (const gchar*) sqlite3_column_text (_tmp18_, 0);
#line 445 "../lib/vala/FontConfig.vala"
						_tmp20_ = g_strdup (_tmp19_);
#line 445 "../lib/vala/FontConfig.vala"
						path = _tmp20_;
#line 446 "../lib/vala/FontConfig.vala"
						_tmp21_ = path;
#line 446 "../lib/vala/FontConfig.vala"
						_tmp22_ = g_file_new_for_path (_tmp21_);
#line 446 "../lib/vala/FontConfig.vala"
						_tmp23_ = _tmp22_;
#line 446 "../lib/vala/FontConfig.vala"
						_tmp24_ = g_file_query_exists (_tmp23_, NULL);
#line 446 "../lib/vala/FontConfig.vala"
						_g_object_unref0 (_tmp23_);
#line 446 "../lib/vala/FontConfig.vala"
						if (_tmp24_) {
#line 2648 "FontConfig.c"
							StringHashset* _tmp25_;
							const gchar* _tmp26_;
#line 447 "../lib/vala/FontConfig.vala"
							_tmp25_ = results;
#line 447 "../lib/vala/FontConfig.vala"
							_tmp26_ = path;
#line 447 "../lib/vala/FontConfig.vala"
							string_hashset_add (_tmp25_, _tmp26_);
#line 2657 "FontConfig.c"
						}
#line 444 "../lib/vala/FontConfig.vala"
						_g_free0 (path);
#line 2661 "FontConfig.c"
					}
#line 444 "../lib/vala/FontConfig.vala"
					_g_object_unref0 (_stmt_it);
#line 2665 "FontConfig.c"
				}
#line 441 "../lib/vala/FontConfig.vala"
				_g_free0 (sql);
#line 441 "../lib/vala/FontConfig.vala"
				_g_free0 (family);
#line 2671 "FontConfig.c"
			}
#line 441 "../lib/vala/FontConfig.vala"
			_g_object_unref0 (_family_list);
#line 2675 "FontConfig.c"
		}
#line 439 "../lib/vala/FontConfig.vala"
		_g_object_unref0 (db);
#line 2679 "FontConfig.c"
	}
	goto __finally6;
	__catch6_g_error:
	{
		GError* e = NULL;
		GError* _tmp27_;
		const gchar* _tmp28_;
#line 439 "../lib/vala/FontConfig.vala"
		e = _inner_error0_;
#line 439 "../lib/vala/FontConfig.vala"
		_inner_error0_ = NULL;
#line 451 "../lib/vala/FontConfig.vala"
		_tmp27_ = e;
#line 451 "../lib/vala/FontConfig.vala"
		_tmp28_ = _tmp27_->message;
#line 451 "../lib/vala/FontConfig.vala"
		g_warning ("FontConfig.vala:451: %s", _tmp28_);
#line 439 "../lib/vala/FontConfig.vala"
		_g_error_free0 (e);
#line 2699 "FontConfig.c"
	}
	__finally6:
#line 439 "../lib/vala/FontConfig.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 439 "../lib/vala/FontConfig.vala"
		_g_object_unref0 (results);
#line 439 "../lib/vala/FontConfig.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 439 "../lib/vala/FontConfig.vala"
		g_clear_error (&_inner_error0_);
#line 439 "../lib/vala/FontConfig.vala"
		return NULL;
#line 2712 "FontConfig.c"
	}
#line 453 "../lib/vala/FontConfig.vala"
	result = results;
#line 453 "../lib/vala/FontConfig.vala"
	return result;
#line 2718 "FontConfig.c"
}

static void
font_manager_reject_class_init (FontManagerRejectClass * klass,
                                gpointer klass_data)
{
#line 423 "../lib/vala/FontConfig.vala"
	font_manager_reject_parent_class = g_type_class_peek_parent (klass);
#line 2727 "FontConfig.c"
}

static void
font_manager_reject_instance_init (FontManagerReject * self,
                                   gpointer klass)
{
}

/**
     * {@inheritDoc}
     */
GType
font_manager_reject_get_type (void)
{
	static volatile gsize font_manager_reject_type_id__volatile = 0;
	if (g_once_init_enter (&font_manager_reject_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (FontManagerRejectClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) font_manager_reject_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (FontManagerReject), 0, (GInstanceInitFunc) font_manager_reject_instance_init, NULL };
		GType font_manager_reject_type_id;
		font_manager_reject_type_id = g_type_register_static (font_manager_selections_get_type (), "FontManagerReject", &g_define_type_info, 0);
		g_once_init_leave (&font_manager_reject_type_id__volatile, font_manager_reject_type_id);
	}
	return font_manager_reject_type_id__volatile;
}

static inline gpointer
font_manager_sources_get_instance_private (FontManagerSources* self)
{
	return G_STRUCT_MEMBER_P (self, FontManagerSources_private_offset);
}

static void
_g_object_unref0_ (gpointer var)
{
#line 486 "../lib/vala/FontConfig.vala"
	(var == NULL) ? NULL : (var = (g_object_unref (var), NULL));
#line 2763 "FontConfig.c"
}

static void
__lambda30_ (FontManagerSources* self,
             GFile* f,
             GFile* of,
             GFileMonitorEvent ev)
{
#line 487 "../lib/vala/FontConfig.vala"
	g_return_if_fail (f != NULL);
#line 487 "../lib/vala/FontConfig.vala"
	font_manager_sources_update (self);
#line 2776 "FontConfig.c"
}

static void
___lambda30__font_manager_sources_file_monitors_changed (FontManagerSourcesFileMonitors* _sender,
                                                         GFile* file,
                                                         GFile* other_file,
                                                         GFileMonitorEvent event_type,
                                                         gpointer self)
{
#line 487 "../lib/vala/FontConfig.vala"
	__lambda30_ ((FontManagerSources*) self, file, other_file, event_type);
#line 2788 "FontConfig.c"
}

FontManagerSources*
font_manager_sources_construct (GType object_type)
{
	FontManagerSources * self = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	FontManagerDirectories* _tmp2_;
	FontManagerDirectories* _tmp3_;
	FontManagerSourcesFileMonitors* _tmp4_;
	GHashFunc _tmp5_;
	GEqualFunc _tmp6_;
	GHashTable* _tmp7_;
	FontManagerSourcesFileMonitors* _tmp8_;
#line 480 "../lib/vala/FontConfig.vala"
	self = (FontManagerSources*) font_manager_directories_construct (object_type);
#line 481 "../lib/vala/FontConfig.vala"
	_tmp0_ = get_package_config_directory ();
#line 481 "../lib/vala/FontConfig.vala"
	_tmp1_ = _tmp0_;
#line 481 "../lib/vala/FontConfig.vala"
	g_object_set ((FontManagerSelections*) self, "config-dir", _tmp1_, NULL);
#line 481 "../lib/vala/FontConfig.vala"
	_g_free0 (_tmp1_);
#line 482 "../lib/vala/FontConfig.vala"
	g_object_set ((FontManagerSelections*) self, "target-element", "source", NULL);
#line 483 "../lib/vala/FontConfig.vala"
	g_object_set ((FontManagerSelections*) self, "target-file", "Sources.xml", NULL);
#line 484 "../lib/vala/FontConfig.vala"
	_tmp2_ = font_manager_directories_new ();
#line 484 "../lib/vala/FontConfig.vala"
	_tmp3_ = _tmp2_;
#line 484 "../lib/vala/FontConfig.vala"
	font_manager_sources_set_active (self, _tmp3_);
#line 484 "../lib/vala/FontConfig.vala"
	_g_object_unref0 (_tmp3_);
#line 485 "../lib/vala/FontConfig.vala"
	_tmp4_ = font_manager_sources_file_monitors_new ();
#line 485 "../lib/vala/FontConfig.vala"
	_g_object_unref0 (self->priv->monitors);
#line 485 "../lib/vala/FontConfig.vala"
	self->priv->monitors = _tmp4_;
#line 486 "../lib/vala/FontConfig.vala"
	_tmp5_ = g_str_hash;
#line 486 "../lib/vala/FontConfig.vala"
	_tmp6_ = g_str_equal;
#line 486 "../lib/vala/FontConfig.vala"
	_tmp7_ = g_hash_table_new_full (_tmp5_, _tmp6_, _g_free0_, _g_object_unref0_);
#line 486 "../lib/vala/FontConfig.vala"
	_g_hash_table_unref0 (self->priv->sources);
#line 486 "../lib/vala/FontConfig.vala"
	self->priv->sources = _tmp7_;
#line 487 "../lib/vala/FontConfig.vala"
	_tmp8_ = self->priv->monitors;
#line 487 "../lib/vala/FontConfig.vala"
	g_signal_connect_object (_tmp8_, "changed", (GCallback) ___lambda30__font_manager_sources_file_monitors_changed, self, 0);
#line 480 "../lib/vala/FontConfig.vala"
	return self;
#line 2848 "FontConfig.c"
}

FontManagerSources*
font_manager_sources_new (void)
{
#line 480 "../lib/vala/FontConfig.vala"
	return font_manager_sources_construct (FONT_MANAGER_TYPE_SOURCES);
#line 2856 "FontConfig.c"
}

GList*
font_manager_sources_list_objects (FontManagerSources* self)
{
	GList* result = NULL;
	GHashTable* _tmp0_;
	GList* _tmp1_;
#line 490 "../lib/vala/FontConfig.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 491 "../lib/vala/FontConfig.vala"
	_tmp0_ = self->priv->sources;
#line 491 "../lib/vala/FontConfig.vala"
	_tmp1_ = g_hash_table_get_values (_tmp0_);
#line 491 "../lib/vala/FontConfig.vala"
	result = _tmp1_;
#line 491 "../lib/vala/FontConfig.vala"
	return result;
#line 2875 "FontConfig.c"
}

void
font_manager_sources_update (FontManagerSources* self)
{
	GHashTable* _tmp0_;
	GList* _tmp1_;
#line 494 "../lib/vala/FontConfig.vala"
	g_return_if_fail (self != NULL);
#line 495 "../lib/vala/FontConfig.vala"
	_tmp0_ = self->priv->sources;
#line 495 "../lib/vala/FontConfig.vala"
	_tmp1_ = g_hash_table_get_values (_tmp0_);
#line 2889 "FontConfig.c"
	{
		GList* source_collection = NULL;
		GList* source_it = NULL;
#line 495 "../lib/vala/FontConfig.vala"
		source_collection = _tmp1_;
#line 495 "../lib/vala/FontConfig.vala"
		for (source_it = source_collection; source_it != NULL; source_it = source_it->next) {
#line 2897 "FontConfig.c"
			FontManagerSource* _tmp2_;
			FontManagerSource* source = NULL;
#line 495 "../lib/vala/FontConfig.vala"
			_tmp2_ = _g_object_ref0 ((FontManagerSource*) source_it->data);
#line 495 "../lib/vala/FontConfig.vala"
			source = _tmp2_;
#line 2904 "FontConfig.c"
			{
				FontManagerSource* _tmp3_;
				FontManagerSource* _tmp4_;
				FontManagerDirectories* _tmp5_;
				FontManagerSource* _tmp6_;
				gchar* _tmp7_;
				gchar* _tmp8_;
				gchar* _tmp9_;
#line 496 "../lib/vala/FontConfig.vala"
				_tmp3_ = source;
#line 496 "../lib/vala/FontConfig.vala"
				font_manager_source_update (_tmp3_);
#line 497 "../lib/vala/FontConfig.vala"
				_tmp4_ = source;
#line 497 "../lib/vala/FontConfig.vala"
				_tmp5_ = self->priv->_active;
#line 497 "../lib/vala/FontConfig.vala"
				_tmp6_ = source;
#line 497 "../lib/vala/FontConfig.vala"
				g_object_get (_tmp6_, "path", &_tmp7_, NULL);
#line 497 "../lib/vala/FontConfig.vala"
				_tmp8_ = _tmp7_;
#line 497 "../lib/vala/FontConfig.vala"
				_tmp9_ = _tmp8_;
#line 497 "../lib/vala/FontConfig.vala"
				g_object_set (_tmp4_, "active", string_hashset_contains ((StringHashset*) _tmp5_, _tmp9_), NULL);
#line 497 "../lib/vala/FontConfig.vala"
				_g_free0 (_tmp9_);
#line 495 "../lib/vala/FontConfig.vala"
				_g_object_unref0 (source);
#line 2935 "FontConfig.c"
			}
		}
#line 495 "../lib/vala/FontConfig.vala"
		(source_collection == NULL) ? NULL : (source_collection = (g_list_free (source_collection), NULL));
#line 2940 "FontConfig.c"
	}
#line 499 "../lib/vala/FontConfig.vala"
	return;
#line 2944 "FontConfig.c"
}

gboolean
font_manager_sources_add_from_path (FontManagerSources* self,
                                    const gchar* dirpath)
{
	gboolean result = FALSE;
	GFile* _tmp0_;
	GFile* _tmp1_;
	FontManagerSource* _tmp2_;
	FontManagerSource* _tmp3_;
	gboolean _tmp4_;
#line 502 "../lib/vala/FontConfig.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 502 "../lib/vala/FontConfig.vala"
	g_return_val_if_fail (dirpath != NULL, FALSE);
#line 503 "../lib/vala/FontConfig.vala"
	_tmp0_ = g_file_new_for_path (dirpath);
#line 503 "../lib/vala/FontConfig.vala"
	_tmp1_ = _tmp0_;
#line 503 "../lib/vala/FontConfig.vala"
	_tmp2_ = font_manager_source_new (_tmp1_);
#line 503 "../lib/vala/FontConfig.vala"
	_tmp3_ = _tmp2_;
#line 503 "../lib/vala/FontConfig.vala"
	_tmp4_ = font_manager_sources_add (self, _tmp3_);
#line 503 "../lib/vala/FontConfig.vala"
	_g_object_unref0 (_tmp3_);
#line 503 "../lib/vala/FontConfig.vala"
	_g_object_unref0 (_tmp1_);
#line 503 "../lib/vala/FontConfig.vala"
	result = _tmp4_;
#line 503 "../lib/vala/FontConfig.vala"
	return result;
#line 2979 "FontConfig.c"
}

static Block3Data*
block3_data_ref (Block3Data* _data3_)
{
#line 506 "../lib/vala/FontConfig.vala"
	g_atomic_int_inc (&_data3_->_ref_count_);
#line 506 "../lib/vala/FontConfig.vala"
	return _data3_;
#line 2989 "FontConfig.c"
}

static void
block3_data_unref (void * _userdata_)
{
	Block3Data* _data3_;
	_data3_ = (Block3Data*) _userdata_;
#line 506 "../lib/vala/FontConfig.vala"
	if (g_atomic_int_dec_and_test (&_data3_->_ref_count_)) {
#line 2999 "FontConfig.c"
		FontManagerSources* self;
#line 506 "../lib/vala/FontConfig.vala"
		self = _data3_->self;
#line 506 "../lib/vala/FontConfig.vala"
		_g_object_unref0 (_data3_->source);
#line 506 "../lib/vala/FontConfig.vala"
		_g_object_unref0 (self);
#line 506 "../lib/vala/FontConfig.vala"
		g_slice_free (Block3Data, _data3_);
#line 3009 "FontConfig.c"
	}
}

static void
__lambda31_ (Block3Data* _data3_)
{
	FontManagerSources* self;
#line 514 "../lib/vala/FontConfig.vala"
	self = _data3_->self;
#line 514 "../lib/vala/FontConfig.vala"
	font_manager_sources_source_activated (self, _data3_->source);
#line 3021 "FontConfig.c"
}

static void
___lambda31__g_object_notify (GObject* _sender,
                              GParamSpec* pspec,
                              gpointer self)
{
#line 514 "../lib/vala/FontConfig.vala"
	__lambda31_ (self);
#line 3031 "FontConfig.c"
}

gboolean
font_manager_sources_add (FontManagerSources* self,
                          FontManagerSource* source)
{
	gboolean result = FALSE;
	Block3Data* _data3_;
	FontManagerSource* _tmp0_;
	GHashTable* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gconstpointer _tmp5_;
	gboolean _tmp6_;
	GHashTable* _tmp7_;
	gchar* _tmp8_;
	gchar* _tmp9_;
	FontManagerSource* _tmp10_;
	GHashTable* _tmp11_;
	gchar* _tmp12_;
	gchar* _tmp13_;
	gchar* _tmp14_;
	gconstpointer _tmp15_;
	gboolean _tmp16_;
	FontManagerDirectories* _tmp17_;
	gchar* _tmp18_;
	gchar* _tmp19_;
	gchar* _tmp20_;
	gboolean _tmp21_;
	FontManagerSourcesFileMonitors* _tmp22_;
	gchar* _tmp23_;
	gchar* _tmp24_;
	gchar* _tmp25_;
	gchar* _tmp26_;
	gchar* _tmp27_;
	gchar* _tmp28_;
	gboolean _tmp29_;
#line 506 "../lib/vala/FontConfig.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 506 "../lib/vala/FontConfig.vala"
	g_return_val_if_fail (source != NULL, FALSE);
#line 506 "../lib/vala/FontConfig.vala"
	_data3_ = g_slice_new0 (Block3Data);
#line 506 "../lib/vala/FontConfig.vala"
	_data3_->_ref_count_ = 1;
#line 506 "../lib/vala/FontConfig.vala"
	_data3_->self = g_object_ref (self);
#line 506 "../lib/vala/FontConfig.vala"
	_tmp0_ = _g_object_ref0 (source);
#line 506 "../lib/vala/FontConfig.vala"
	_g_object_unref0 (_data3_->source);
#line 506 "../lib/vala/FontConfig.vala"
	_data3_->source = _tmp0_;
#line 507 "../lib/vala/FontConfig.vala"
	_tmp1_ = self->priv->sources;
#line 507 "../lib/vala/FontConfig.vala"
	g_object_get (_data3_->source, "path", &_tmp2_, NULL);
#line 507 "../lib/vala/FontConfig.vala"
	_tmp3_ = _tmp2_;
#line 507 "../lib/vala/FontConfig.vala"
	_tmp4_ = _tmp3_;
#line 507 "../lib/vala/FontConfig.vala"
	_tmp5_ = g_hash_table_lookup (_tmp1_, _tmp4_);
#line 507 "../lib/vala/FontConfig.vala"
	_tmp6_ = ((FontManagerSource*) _tmp5_) != NULL;
#line 507 "../lib/vala/FontConfig.vala"
	_g_free0 (_tmp4_);
#line 507 "../lib/vala/FontConfig.vala"
	if (_tmp6_) {
#line 508 "../lib/vala/FontConfig.vala"
		result = TRUE;
#line 508 "../lib/vala/FontConfig.vala"
		block3_data_unref (_data3_);
#line 508 "../lib/vala/FontConfig.vala"
		_data3_ = NULL;
#line 508 "../lib/vala/FontConfig.vala"
		return result;
#line 3110 "FontConfig.c"
	}
#line 509 "../lib/vala/FontConfig.vala"
	_tmp7_ = self->priv->sources;
#line 509 "../lib/vala/FontConfig.vala"
	g_object_get (_data3_->source, "path", &_tmp8_, NULL);
#line 509 "../lib/vala/FontConfig.vala"
	_tmp9_ = _tmp8_;
#line 509 "../lib/vala/FontConfig.vala"
	_tmp10_ = _g_object_ref0 (_data3_->source);
#line 509 "../lib/vala/FontConfig.vala"
	g_hash_table_insert (_tmp7_, _tmp9_, _tmp10_);
#line 510 "../lib/vala/FontConfig.vala"
	_tmp11_ = self->priv->sources;
#line 510 "../lib/vala/FontConfig.vala"
	g_object_get (_data3_->source, "path", &_tmp12_, NULL);
#line 510 "../lib/vala/FontConfig.vala"
	_tmp13_ = _tmp12_;
#line 510 "../lib/vala/FontConfig.vala"
	_tmp14_ = _tmp13_;
#line 510 "../lib/vala/FontConfig.vala"
	_tmp15_ = g_hash_table_lookup (_tmp11_, _tmp14_);
#line 510 "../lib/vala/FontConfig.vala"
	_tmp16_ = ((FontManagerSource*) _tmp15_) == NULL;
#line 510 "../lib/vala/FontConfig.vala"
	_g_free0 (_tmp14_);
#line 510 "../lib/vala/FontConfig.vala"
	if (_tmp16_) {
#line 511 "../lib/vala/FontConfig.vala"
		result = FALSE;
#line 511 "../lib/vala/FontConfig.vala"
		block3_data_unref (_data3_);
#line 511 "../lib/vala/FontConfig.vala"
		_data3_ = NULL;
#line 511 "../lib/vala/FontConfig.vala"
		return result;
#line 3146 "FontConfig.c"
	}
#line 512 "../lib/vala/FontConfig.vala"
	_tmp17_ = self->priv->_active;
#line 512 "../lib/vala/FontConfig.vala"
	g_object_get (_data3_->source, "path", &_tmp18_, NULL);
#line 512 "../lib/vala/FontConfig.vala"
	_tmp19_ = _tmp18_;
#line 512 "../lib/vala/FontConfig.vala"
	_tmp20_ = _tmp19_;
#line 512 "../lib/vala/FontConfig.vala"
	_tmp21_ = string_hashset_contains ((StringHashset*) _tmp17_, _tmp20_);
#line 512 "../lib/vala/FontConfig.vala"
	_g_free0 (_tmp20_);
#line 512 "../lib/vala/FontConfig.vala"
	if (_tmp21_) {
#line 513 "../lib/vala/FontConfig.vala"
		g_object_set (_data3_->source, "active", TRUE, NULL);
#line 3164 "FontConfig.c"
	}
#line 514 "../lib/vala/FontConfig.vala"
	g_signal_connect_data ((GObject*) _data3_->source, "notify::active", (GCallback) ___lambda31__g_object_notify, block3_data_ref (_data3_), (GClosureNotify) block3_data_unref, 0);
#line 515 "../lib/vala/FontConfig.vala"
	_tmp22_ = self->priv->monitors;
#line 515 "../lib/vala/FontConfig.vala"
	g_object_get (_data3_->source, "path", &_tmp23_, NULL);
#line 515 "../lib/vala/FontConfig.vala"
	_tmp24_ = _tmp23_;
#line 515 "../lib/vala/FontConfig.vala"
	_tmp25_ = _tmp24_;
#line 515 "../lib/vala/FontConfig.vala"
	font_manager_sources_file_monitors_add (_tmp22_, _tmp25_);
#line 515 "../lib/vala/FontConfig.vala"
	_g_free0 (_tmp25_);
#line 516 "../lib/vala/FontConfig.vala"
	g_object_get (_data3_->source, "path", &_tmp26_, NULL);
#line 516 "../lib/vala/FontConfig.vala"
	_tmp27_ = _tmp26_;
#line 516 "../lib/vala/FontConfig.vala"
	_tmp28_ = _tmp27_;
#line 516 "../lib/vala/FontConfig.vala"
	_tmp29_ = string_hashset_add ((StringHashset*) G_TYPE_CHECK_INSTANCE_CAST (self, FONT_MANAGER_TYPE_DIRECTORIES, FontManagerDirectories), _tmp28_);
#line 516 "../lib/vala/FontConfig.vala"
	_g_free0 (_tmp28_);
#line 516 "../lib/vala/FontConfig.vala"
	result = _tmp29_;
#line 516 "../lib/vala/FontConfig.vala"
	block3_data_unref (_data3_);
#line 516 "../lib/vala/FontConfig.vala"
	_data3_ = NULL;
#line 516 "../lib/vala/FontConfig.vala"
	return result;
#line 3198 "FontConfig.c"
}

static void
font_manager_sources_purge_entries_data_free (gpointer _data)
{
	FontManagerSourcesPurgeEntriesData* _data_;
	_data_ = _data;
#line 467 "../lib/vala/FontConfig.vala"
	_g_free0 (_data_->path);
#line 467 "../lib/vala/FontConfig.vala"
	_g_object_unref0 (_data_->self);
#line 467 "../lib/vala/FontConfig.vala"
	g_slice_free (FontManagerSourcesPurgeEntriesData, _data_);
#line 3212 "FontConfig.c"
}

static void
font_manager_sources_purge_entries_async_ready_wrapper (GObject *source_object,
                                                        GAsyncResult *res,
                                                        void *user_data)
{
	FontManagerSourcesPurgeEntriesData* _task_data_;
#line 467 "../lib/vala/FontConfig.vala"
	_task_data_ = g_task_get_task_data (G_TASK (res));
#line 467 "../lib/vala/FontConfig.vala"
	if (_task_data_->_callback_ != NULL) {
#line 467 "../lib/vala/FontConfig.vala"
		_task_data_->_callback_ (source_object, res, user_data);
#line 3227 "FontConfig.c"
	}
#line 467 "../lib/vala/FontConfig.vala"
	_task_data_->_task_complete_ = TRUE;
#line 3231 "FontConfig.c"
}

void
font_manager_sources_purge_entries (FontManagerSources* self,
                                    const gchar* path,
                                    GAsyncReadyCallback _callback_,
                                    gpointer _user_data_)
{
	FontManagerSourcesPurgeEntriesData* _data_;
	FontManagerSources* _tmp0_;
	gchar* _tmp1_;
#line 467 "../lib/vala/FontConfig.vala"
	_data_ = g_slice_new0 (FontManagerSourcesPurgeEntriesData);
#line 467 "../lib/vala/FontConfig.vala"
	_data_->_callback_ = _callback_;
#line 467 "../lib/vala/FontConfig.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, font_manager_sources_purge_entries_async_ready_wrapper, _user_data_);
#line 467 "../lib/vala/FontConfig.vala"
	if (_callback_ == NULL) {
#line 467 "../lib/vala/FontConfig.vala"
		_data_->_task_complete_ = TRUE;
#line 3253 "FontConfig.c"
	}
#line 467 "../lib/vala/FontConfig.vala"
	g_task_set_task_data (_data_->_async_result, _data_, font_manager_sources_purge_entries_data_free);
#line 467 "../lib/vala/FontConfig.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 467 "../lib/vala/FontConfig.vala"
	_data_->self = _tmp0_;
#line 467 "../lib/vala/FontConfig.vala"
	_tmp1_ = g_strdup (path);
#line 467 "../lib/vala/FontConfig.vala"
	_g_free0 (_data_->path);
#line 467 "../lib/vala/FontConfig.vala"
	_data_->path = _tmp1_;
#line 467 "../lib/vala/FontConfig.vala"
	font_manager_sources_purge_entries_co (_data_);
#line 3269 "FontConfig.c"
}

void
font_manager_sources_purge_entries_finish (FontManagerSources* self,
                                           GAsyncResult* _res_)
{
	FontManagerSourcesPurgeEntriesData* _data_;
#line 467 "../lib/vala/FontConfig.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 3279 "FontConfig.c"
}

static gboolean
_font_manager_sources_purge_entries_co_gsource_func (gpointer self)
{
	gboolean result;
	result = font_manager_sources_purge_entries_co (self);
#line 533 "../lib/vala/FontConfig.vala"
	return result;
#line 3289 "FontConfig.c"
}

static gboolean
font_manager_sources_purge_entries_co (FontManagerSourcesPurgeEntriesData* _data_)
{
#line 519 "../lib/vala/FontConfig.vala"
	switch (_data_->_state_) {
#line 519 "../lib/vala/FontConfig.vala"
		case 0:
#line 3299 "FontConfig.c"
		goto _state_0;
#line 519 "../lib/vala/FontConfig.vala"
		case 1:
#line 3303 "FontConfig.c"
		goto _state_1;
		default:
#line 519 "../lib/vala/FontConfig.vala"
		g_assert_not_reached ();
#line 3308 "FontConfig.c"
	}
	_state_0:
#line 520 "../lib/vala/FontConfig.vala"
	_data_->_tmp0_ = g_new0 (FontManagerDatabaseType, 3);
#line 520 "../lib/vala/FontConfig.vala"
	_data_->_tmp0_[0] = FONT_MANAGER_DATABASE_TYPE_FONT;
#line 520 "../lib/vala/FontConfig.vala"
	_data_->_tmp0_[1] = FONT_MANAGER_DATABASE_TYPE_METADATA;
#line 520 "../lib/vala/FontConfig.vala"
	_data_->_tmp0_[2] = FONT_MANAGER_DATABASE_TYPE_ORTHOGRAPHY;
#line 520 "../lib/vala/FontConfig.vala"
	_data_->types = _data_->_tmp0_;
#line 520 "../lib/vala/FontConfig.vala"
	_data_->types_length1 = 3;
#line 520 "../lib/vala/FontConfig.vala"
	_data_->_types_size_ = _data_->types_length1;
#line 3325 "FontConfig.c"
	{
#line 522 "../lib/vala/FontConfig.vala"
		_data_->_tmp1_ = font_manager_get_database (FONT_MANAGER_DATABASE_TYPE_BASE, &_data_->_inner_error0_);
#line 522 "../lib/vala/FontConfig.vala"
		_data_->db = _data_->_tmp1_;
#line 522 "../lib/vala/FontConfig.vala"
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 522 "../lib/vala/FontConfig.vala"
			if (_data_->_inner_error0_->domain == FONT_MANAGER_DATABASE_ERROR) {
#line 3335 "FontConfig.c"
				goto __catch7_font_manager_database_error;
			}
#line 522 "../lib/vala/FontConfig.vala"
			_data_->types = (g_free (_data_->types), NULL);
#line 522 "../lib/vala/FontConfig.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
#line 522 "../lib/vala/FontConfig.vala"
			g_clear_error (&_data_->_inner_error0_);
#line 522 "../lib/vala/FontConfig.vala"
			g_object_unref (_data_->_async_result);
#line 522 "../lib/vala/FontConfig.vala"
			return FALSE;
#line 3348 "FontConfig.c"
		}
#line 523 "../lib/vala/FontConfig.vala"
		_data_->_tmp2_ = _data_->types;
#line 523 "../lib/vala/FontConfig.vala"
		_data_->_tmp2__length1 = _data_->types_length1;
#line 3354 "FontConfig.c"
		{
#line 523 "../lib/vala/FontConfig.vala"
			_data_->type_collection_length1 = 0;
#line 523 "../lib/vala/FontConfig.vala"
			_data_->_type_collection_size_ = 0;
#line 523 "../lib/vala/FontConfig.vala"
			_data_->type_collection = _data_->_tmp2_;
#line 523 "../lib/vala/FontConfig.vala"
			_data_->type_collection_length1 = _data_->_tmp2__length1;
#line 523 "../lib/vala/FontConfig.vala"
			for (_data_->type_it = 0; _data_->type_it < _data_->_tmp2__length1; _data_->type_it = _data_->type_it + 1) {
#line 523 "../lib/vala/FontConfig.vala"
				_data_->type = _data_->type_collection[_data_->type_it];
#line 3368 "FontConfig.c"
				{
#line 524 "../lib/vala/FontConfig.vala"
					_data_->_tmp3_ = _data_->type;
#line 524 "../lib/vala/FontConfig.vala"
					_data_->_tmp4_ = font_manager_database_get_type_name (_data_->_tmp3_);
#line 524 "../lib/vala/FontConfig.vala"
					_data_->_tmp5_ = g_strdup (_data_->_tmp4_);
#line 524 "../lib/vala/FontConfig.vala"
					_data_->name = _data_->_tmp5_;
#line 525 "../lib/vala/FontConfig.vala"
					_data_->_tmp6_ = _data_->db;
#line 525 "../lib/vala/FontConfig.vala"
					_data_->_tmp7_ = _data_->name;
#line 525 "../lib/vala/FontConfig.vala"
					_data_->_tmp8_ = g_strdup_printf ("DELETE FROM %s WHERE filepath LIKE \"%%s%\"", _data_->_tmp7_, _data_->path);
#line 525 "../lib/vala/FontConfig.vala"
					_data_->_tmp9_ = _data_->_tmp8_;
#line 525 "../lib/vala/FontConfig.vala"
					font_manager_database_execute_query (_data_->_tmp6_, _data_->_tmp9_, &_data_->_inner_error0_);
#line 525 "../lib/vala/FontConfig.vala"
					_g_free0 (_data_->_tmp9_);
#line 525 "../lib/vala/FontConfig.vala"
					if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 525 "../lib/vala/FontConfig.vala"
						_g_free0 (_data_->name);
#line 525 "../lib/vala/FontConfig.vala"
						_g_object_unref0 (_data_->db);
#line 525 "../lib/vala/FontConfig.vala"
						if (_data_->_inner_error0_->domain == FONT_MANAGER_DATABASE_ERROR) {
#line 3398 "FontConfig.c"
							goto __catch7_font_manager_database_error;
						}
#line 525 "../lib/vala/FontConfig.vala"
						_g_free0 (_data_->name);
#line 525 "../lib/vala/FontConfig.vala"
						_g_object_unref0 (_data_->db);
#line 525 "../lib/vala/FontConfig.vala"
						_data_->types = (g_free (_data_->types), NULL);
#line 525 "../lib/vala/FontConfig.vala"
						g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
#line 525 "../lib/vala/FontConfig.vala"
						g_clear_error (&_data_->_inner_error0_);
#line 525 "../lib/vala/FontConfig.vala"
						g_object_unref (_data_->_async_result);
#line 525 "../lib/vala/FontConfig.vala"
						return FALSE;
#line 3415 "FontConfig.c"
					}
#line 526 "../lib/vala/FontConfig.vala"
					_data_->_tmp10_ = _data_->db;
#line 526 "../lib/vala/FontConfig.vala"
					_data_->_tmp11_ = _data_->_tmp10_->stmt;
#line 526 "../lib/vala/FontConfig.vala"
					sqlite3_step (_data_->_tmp11_);
#line 523 "../lib/vala/FontConfig.vala"
					_g_free0 (_data_->name);
#line 3425 "FontConfig.c"
				}
			}
		}
#line 528 "../lib/vala/FontConfig.vala"
		_g_object_unref0 (_data_->db);
#line 528 "../lib/vala/FontConfig.vala"
		_data_->db = NULL;
#line 529 "../lib/vala/FontConfig.vala"
		_data_->_tmp12_ = _data_->types;
#line 529 "../lib/vala/FontConfig.vala"
		_data_->_tmp12__length1 = _data_->types_length1;
#line 3437 "FontConfig.c"
		{
#line 529 "../lib/vala/FontConfig.vala"
			_data_->_vala1_type_collection_length1 = 0;
#line 529 "../lib/vala/FontConfig.vala"
			_data_->__vala1_type_collection_size_ = 0;
#line 529 "../lib/vala/FontConfig.vala"
			_data_->_vala1_type_collection = _data_->_tmp12_;
#line 529 "../lib/vala/FontConfig.vala"
			_data_->_vala1_type_collection_length1 = _data_->_tmp12__length1;
#line 529 "../lib/vala/FontConfig.vala"
			for (_data_->_vala1_type_it = 0; _data_->_vala1_type_it < _data_->_tmp12__length1; _data_->_vala1_type_it = _data_->_vala1_type_it + 1) {
#line 529 "../lib/vala/FontConfig.vala"
				_data_->_vala1_type = _data_->_vala1_type_collection[_data_->_vala1_type_it];
#line 3451 "FontConfig.c"
				{
#line 530 "../lib/vala/FontConfig.vala"
					_data_->_tmp14_ = _data_->_vala1_type;
#line 530 "../lib/vala/FontConfig.vala"
					_data_->_tmp15_ = font_manager_get_database (_data_->_tmp14_, &_data_->_inner_error0_);
#line 530 "../lib/vala/FontConfig.vala"
					_data_->_tmp13_ = _data_->_tmp15_;
#line 530 "../lib/vala/FontConfig.vala"
					if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 530 "../lib/vala/FontConfig.vala"
						_g_object_unref0 (_data_->db);
#line 530 "../lib/vala/FontConfig.vala"
						if (_data_->_inner_error0_->domain == FONT_MANAGER_DATABASE_ERROR) {
#line 3465 "FontConfig.c"
							goto __catch7_font_manager_database_error;
						}
#line 530 "../lib/vala/FontConfig.vala"
						_g_object_unref0 (_data_->db);
#line 530 "../lib/vala/FontConfig.vala"
						_data_->types = (g_free (_data_->types), NULL);
#line 530 "../lib/vala/FontConfig.vala"
						g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
#line 530 "../lib/vala/FontConfig.vala"
						g_clear_error (&_data_->_inner_error0_);
#line 530 "../lib/vala/FontConfig.vala"
						g_object_unref (_data_->_async_result);
#line 530 "../lib/vala/FontConfig.vala"
						return FALSE;
#line 3480 "FontConfig.c"
					}
#line 530 "../lib/vala/FontConfig.vala"
					_data_->_tmp16_ = _data_->_tmp13_;
#line 530 "../lib/vala/FontConfig.vala"
					_data_->_tmp13_ = NULL;
#line 530 "../lib/vala/FontConfig.vala"
					_g_object_unref0 (_data_->db);
#line 530 "../lib/vala/FontConfig.vala"
					_data_->db = _data_->_tmp16_;
#line 531 "../lib/vala/FontConfig.vala"
					_data_->_tmp17_ = _data_->db;
#line 531 "../lib/vala/FontConfig.vala"
					font_manager_database_execute_query (_data_->_tmp17_, "VACUUM", &_data_->_inner_error0_);
#line 531 "../lib/vala/FontConfig.vala"
					if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 531 "../lib/vala/FontConfig.vala"
						_g_object_unref0 (_data_->_tmp13_);
#line 531 "../lib/vala/FontConfig.vala"
						_g_object_unref0 (_data_->db);
#line 531 "../lib/vala/FontConfig.vala"
						if (_data_->_inner_error0_->domain == FONT_MANAGER_DATABASE_ERROR) {
#line 3502 "FontConfig.c"
							goto __catch7_font_manager_database_error;
						}
#line 531 "../lib/vala/FontConfig.vala"
						_g_object_unref0 (_data_->_tmp13_);
#line 531 "../lib/vala/FontConfig.vala"
						_g_object_unref0 (_data_->db);
#line 531 "../lib/vala/FontConfig.vala"
						_data_->types = (g_free (_data_->types), NULL);
#line 531 "../lib/vala/FontConfig.vala"
						g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
#line 531 "../lib/vala/FontConfig.vala"
						g_clear_error (&_data_->_inner_error0_);
#line 531 "../lib/vala/FontConfig.vala"
						g_object_unref (_data_->_async_result);
#line 531 "../lib/vala/FontConfig.vala"
						return FALSE;
#line 3519 "FontConfig.c"
					}
#line 532 "../lib/vala/FontConfig.vala"
					_data_->_tmp18_ = _data_->db;
#line 532 "../lib/vala/FontConfig.vala"
					_data_->_tmp19_ = _data_->_tmp18_->stmt;
#line 532 "../lib/vala/FontConfig.vala"
					sqlite3_step (_data_->_tmp19_);
#line 533 "../lib/vala/FontConfig.vala"
					g_idle_add_full (G_PRIORITY_DEFAULT_IDLE, _font_manager_sources_purge_entries_co_gsource_func, _data_, NULL);
#line 534 "../lib/vala/FontConfig.vala"
					_data_->_state_ = 1;
#line 534 "../lib/vala/FontConfig.vala"
					return FALSE;
#line 3533 "FontConfig.c"
					_state_1:
					;
#line 529 "../lib/vala/FontConfig.vala"
					_g_object_unref0 (_data_->_tmp13_);
#line 3538 "FontConfig.c"
				}
			}
		}
#line 521 "../lib/vala/FontConfig.vala"
		_g_object_unref0 (_data_->db);
#line 3544 "FontConfig.c"
	}
	goto __finally7;
	__catch7_font_manager_database_error:
	{
#line 521 "../lib/vala/FontConfig.vala"
		_data_->e = _data_->_inner_error0_;
#line 521 "../lib/vala/FontConfig.vala"
		_data_->_inner_error0_ = NULL;
#line 537 "../lib/vala/FontConfig.vala"
		_data_->_tmp20_ = _data_->e;
#line 537 "../lib/vala/FontConfig.vala"
		if (_data_->_tmp20_->code != 1) {
#line 538 "../lib/vala/FontConfig.vala"
			_data_->_tmp21_ = _data_->e;
#line 538 "../lib/vala/FontConfig.vala"
			_data_->_tmp22_ = _data_->_tmp21_->message;
#line 538 "../lib/vala/FontConfig.vala"
			g_warning ("FontConfig.vala:538: %s", _data_->_tmp22_);
#line 3563 "FontConfig.c"
		}
#line 521 "../lib/vala/FontConfig.vala"
		_g_error_free0 (_data_->e);
#line 3567 "FontConfig.c"
	}
	__finally7:
#line 521 "../lib/vala/FontConfig.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 521 "../lib/vala/FontConfig.vala"
		_data_->types = (g_free (_data_->types), NULL);
#line 521 "../lib/vala/FontConfig.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
#line 521 "../lib/vala/FontConfig.vala"
		g_clear_error (&_data_->_inner_error0_);
#line 521 "../lib/vala/FontConfig.vala"
		g_object_unref (_data_->_async_result);
#line 521 "../lib/vala/FontConfig.vala"
		return FALSE;
#line 3582 "FontConfig.c"
	}
#line 540 "../lib/vala/FontConfig.vala"
	_data_->types = (g_free (_data_->types), NULL);
#line 540 "../lib/vala/FontConfig.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 540 "../lib/vala/FontConfig.vala"
	if (_data_->_state_ != 0) {
#line 540 "../lib/vala/FontConfig.vala"
		while (!_data_->_task_complete_) {
#line 540 "../lib/vala/FontConfig.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 3594 "FontConfig.c"
		}
	}
#line 540 "../lib/vala/FontConfig.vala"
	g_object_unref (_data_->_async_result);
#line 540 "../lib/vala/FontConfig.vala"
	return FALSE;
#line 519 "../lib/vala/FontConfig.vala"
	_data_->types = (g_free (_data_->types), NULL);
#line 519 "../lib/vala/FontConfig.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 519 "../lib/vala/FontConfig.vala"
	if (_data_->_state_ != 0) {
#line 519 "../lib/vala/FontConfig.vala"
		while (!_data_->_task_complete_) {
#line 519 "../lib/vala/FontConfig.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 3611 "FontConfig.c"
		}
	}
#line 519 "../lib/vala/FontConfig.vala"
	g_object_unref (_data_->_async_result);
#line 519 "../lib/vala/FontConfig.vala"
	return FALSE;
#line 3618 "FontConfig.c"
}

static void
__lambda32_ (FontManagerSources* self,
             GObject* obj,
             GAsyncResult* res)
{
#line 553 "../lib/vala/FontConfig.vala"
	g_return_if_fail (res != NULL);
#line 553 "../lib/vala/FontConfig.vala"
	font_manager_sources_purge_entries_finish (self, res);
#line 3630 "FontConfig.c"
}

static void
___lambda32__gasync_ready_callback (GObject* source_object,
                                    GAsyncResult* res,
                                    gpointer self)
{
#line 553 "../lib/vala/FontConfig.vala"
	__lambda32_ ((FontManagerSources*) self, source_object, res);
#line 553 "../lib/vala/FontConfig.vala"
	g_object_unref (self);
#line 3642 "FontConfig.c"
}

gboolean
font_manager_sources_remove (FontManagerSources* self,
                             FontManagerSource* source)
{
	gboolean result = FALSE;
	GHashTable* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	GHashTable* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	gconstpointer _tmp8_;
	gboolean _tmp9_;
	FontManagerDirectories* _tmp10_;
	gchar* _tmp11_;
	gchar* _tmp12_;
	gchar* _tmp13_;
	gboolean _tmp14_;
	FontManagerSourcesFileMonitors* _tmp20_;
	gchar* _tmp21_;
	gchar* _tmp22_;
	gchar* _tmp23_;
	gchar* _tmp24_;
	gchar* _tmp25_;
	gchar* _tmp26_;
	gchar* _tmp27_;
	gchar* _tmp28_;
	gchar* _tmp29_;
#line 543 "../lib/vala/FontConfig.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 543 "../lib/vala/FontConfig.vala"
	g_return_val_if_fail (source != NULL, FALSE);
#line 544 "../lib/vala/FontConfig.vala"
	_tmp0_ = self->priv->sources;
#line 544 "../lib/vala/FontConfig.vala"
	g_object_get (source, "path", &_tmp1_, NULL);
#line 544 "../lib/vala/FontConfig.vala"
	_tmp2_ = _tmp1_;
#line 544 "../lib/vala/FontConfig.vala"
	_tmp3_ = _tmp2_;
#line 544 "../lib/vala/FontConfig.vala"
	g_hash_table_remove (_tmp0_, _tmp3_);
#line 544 "../lib/vala/FontConfig.vala"
	_g_free0 (_tmp3_);
#line 545 "../lib/vala/FontConfig.vala"
	_tmp4_ = self->priv->sources;
#line 545 "../lib/vala/FontConfig.vala"
	g_object_get (source, "path", &_tmp5_, NULL);
#line 545 "../lib/vala/FontConfig.vala"
	_tmp6_ = _tmp5_;
#line 545 "../lib/vala/FontConfig.vala"
	_tmp7_ = _tmp6_;
#line 545 "../lib/vala/FontConfig.vala"
	_tmp8_ = g_hash_table_lookup (_tmp4_, _tmp7_);
#line 545 "../lib/vala/FontConfig.vala"
	_tmp9_ = ((FontManagerSource*) _tmp8_) != NULL;
#line 545 "../lib/vala/FontConfig.vala"
	_g_free0 (_tmp7_);
#line 545 "../lib/vala/FontConfig.vala"
	if (_tmp9_) {
#line 546 "../lib/vala/FontConfig.vala"
		result = FALSE;
#line 546 "../lib/vala/FontConfig.vala"
		return result;
#line 3711 "FontConfig.c"
	}
#line 547 "../lib/vala/FontConfig.vala"
	_tmp10_ = self->priv->_active;
#line 547 "../lib/vala/FontConfig.vala"
	g_object_get (source, "path", &_tmp11_, NULL);
#line 547 "../lib/vala/FontConfig.vala"
	_tmp12_ = _tmp11_;
#line 547 "../lib/vala/FontConfig.vala"
	_tmp13_ = _tmp12_;
#line 547 "../lib/vala/FontConfig.vala"
	_tmp14_ = string_hashset_contains ((StringHashset*) _tmp10_, _tmp13_);
#line 547 "../lib/vala/FontConfig.vala"
	_g_free0 (_tmp13_);
#line 547 "../lib/vala/FontConfig.vala"
	if (_tmp14_) {
#line 3727 "FontConfig.c"
		FontManagerDirectories* _tmp15_;
		gchar* _tmp16_;
		gchar* _tmp17_;
		gchar* _tmp18_;
		FontManagerDirectories* _tmp19_;
#line 548 "../lib/vala/FontConfig.vala"
		_tmp15_ = self->priv->_active;
#line 548 "../lib/vala/FontConfig.vala"
		g_object_get (source, "path", &_tmp16_, NULL);
#line 548 "../lib/vala/FontConfig.vala"
		_tmp17_ = _tmp16_;
#line 548 "../lib/vala/FontConfig.vala"
		_tmp18_ = _tmp17_;
#line 548 "../lib/vala/FontConfig.vala"
		string_hashset_remove ((StringHashset*) _tmp15_, _tmp18_);
#line 548 "../lib/vala/FontConfig.vala"
		_g_free0 (_tmp18_);
#line 549 "../lib/vala/FontConfig.vala"
		_tmp19_ = self->priv->_active;
#line 549 "../lib/vala/FontConfig.vala"
		font_manager_selections_save ((FontManagerSelections*) _tmp19_);
#line 3749 "FontConfig.c"
	}
#line 551 "../lib/vala/FontConfig.vala"
	_tmp20_ = self->priv->monitors;
#line 551 "../lib/vala/FontConfig.vala"
	g_object_get (source, "path", &_tmp21_, NULL);
#line 551 "../lib/vala/FontConfig.vala"
	_tmp22_ = _tmp21_;
#line 551 "../lib/vala/FontConfig.vala"
	_tmp23_ = _tmp22_;
#line 551 "../lib/vala/FontConfig.vala"
	font_manager_sources_file_monitors_remove (_tmp20_, _tmp23_);
#line 551 "../lib/vala/FontConfig.vala"
	_g_free0 (_tmp23_);
#line 552 "../lib/vala/FontConfig.vala"
	g_object_get (source, "path", &_tmp24_, NULL);
#line 552 "../lib/vala/FontConfig.vala"
	_tmp25_ = _tmp24_;
#line 552 "../lib/vala/FontConfig.vala"
	_tmp26_ = _tmp25_;
#line 552 "../lib/vala/FontConfig.vala"
	string_hashset_remove ((StringHashset*) G_TYPE_CHECK_INSTANCE_CAST (self, FONT_MANAGER_TYPE_DIRECTORIES, FontManagerDirectories), _tmp26_);
#line 552 "../lib/vala/FontConfig.vala"
	_g_free0 (_tmp26_);
#line 553 "../lib/vala/FontConfig.vala"
	g_object_get (source, "path", &_tmp27_, NULL);
#line 553 "../lib/vala/FontConfig.vala"
	_tmp28_ = _tmp27_;
#line 553 "../lib/vala/FontConfig.vala"
	_tmp29_ = _tmp28_;
#line 553 "../lib/vala/FontConfig.vala"
	font_manager_sources_purge_entries (self, _tmp29_, ___lambda32__gasync_ready_callback, g_object_ref (self));
#line 553 "../lib/vala/FontConfig.vala"
	_g_free0 (_tmp29_);
#line 554 "../lib/vala/FontConfig.vala"
	result = TRUE;
#line 554 "../lib/vala/FontConfig.vala"
	return result;
#line 3787 "FontConfig.c"
}

static void
font_manager_sources_source_activated (FontManagerSources* self,
                                       FontManagerSource* source)
{
	gboolean _tmp0_;
	gboolean _tmp1_;
	FontManagerDirectories* _tmp15_;
#line 557 "../lib/vala/FontConfig.vala"
	g_return_if_fail (self != NULL);
#line 557 "../lib/vala/FontConfig.vala"
	g_return_if_fail (source != NULL);
#line 558 "../lib/vala/FontConfig.vala"
	g_object_get (source, "active", &_tmp0_, NULL);
#line 558 "../lib/vala/FontConfig.vala"
	_tmp1_ = _tmp0_;
#line 558 "../lib/vala/FontConfig.vala"
	if (_tmp1_) {
#line 3807 "FontConfig.c"
		FontManagerDirectories* _tmp2_;
		gchar* _tmp3_;
		gchar* _tmp4_;
		gchar* _tmp5_;
#line 559 "../lib/vala/FontConfig.vala"
		_tmp2_ = self->priv->_active;
#line 559 "../lib/vala/FontConfig.vala"
		g_object_get (source, "path", &_tmp3_, NULL);
#line 559 "../lib/vala/FontConfig.vala"
		_tmp4_ = _tmp3_;
#line 559 "../lib/vala/FontConfig.vala"
		_tmp5_ = _tmp4_;
#line 559 "../lib/vala/FontConfig.vala"
		string_hashset_add ((StringHashset*) _tmp2_, _tmp5_);
#line 559 "../lib/vala/FontConfig.vala"
		_g_free0 (_tmp5_);
#line 3824 "FontConfig.c"
	} else {
		FontManagerDirectories* _tmp6_;
		gchar* _tmp7_;
		gchar* _tmp8_;
		gchar* _tmp9_;
		gboolean _tmp10_;
#line 560 "../lib/vala/FontConfig.vala"
		_tmp6_ = self->priv->_active;
#line 560 "../lib/vala/FontConfig.vala"
		g_object_get (source, "path", &_tmp7_, NULL);
#line 560 "../lib/vala/FontConfig.vala"
		_tmp8_ = _tmp7_;
#line 560 "../lib/vala/FontConfig.vala"
		_tmp9_ = _tmp8_;
#line 560 "../lib/vala/FontConfig.vala"
		_tmp10_ = string_hashset_contains ((StringHashset*) _tmp6_, _tmp9_);
#line 560 "../lib/vala/FontConfig.vala"
		_g_free0 (_tmp9_);
#line 560 "../lib/vala/FontConfig.vala"
		if (_tmp10_) {
#line 3845 "FontConfig.c"
			FontManagerDirectories* _tmp11_;
			gchar* _tmp12_;
			gchar* _tmp13_;
			gchar* _tmp14_;
#line 561 "../lib/vala/FontConfig.vala"
			_tmp11_ = self->priv->_active;
#line 561 "../lib/vala/FontConfig.vala"
			g_object_get (source, "path", &_tmp12_, NULL);
#line 561 "../lib/vala/FontConfig.vala"
			_tmp13_ = _tmp12_;
#line 561 "../lib/vala/FontConfig.vala"
			_tmp14_ = _tmp13_;
#line 561 "../lib/vala/FontConfig.vala"
			string_hashset_remove ((StringHashset*) _tmp11_, _tmp14_);
#line 561 "../lib/vala/FontConfig.vala"
			_g_free0 (_tmp14_);
#line 3862 "FontConfig.c"
		}
	}
#line 562 "../lib/vala/FontConfig.vala"
	_tmp15_ = self->priv->_active;
#line 562 "../lib/vala/FontConfig.vala"
	font_manager_selections_save ((FontManagerSelections*) _tmp15_);
#line 563 "../lib/vala/FontConfig.vala"
	return;
#line 3871 "FontConfig.c"
}

/**
         * {@inheritDoc}
         */
gboolean
font_manager_sources_load (FontManagerSources* self)
{
	gboolean result = FALSE;
	FontManagerDirectories* _tmp0_;
	GList* _tmp1_;
	FontManagerDirectories* _tmp4_;
	GList* _tmp5_;
#line 569 "../lib/vala/FontConfig.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 570 "../lib/vala/FontConfig.vala"
	FONT_MANAGER_SELECTIONS_CLASS (font_manager_sources_parent_class)->load ((FontManagerSelections*) G_TYPE_CHECK_INSTANCE_CAST (self, FONT_MANAGER_TYPE_DIRECTORIES, FontManagerDirectories));
#line 571 "../lib/vala/FontConfig.vala"
	_tmp0_ = self->priv->_active;
#line 571 "../lib/vala/FontConfig.vala"
	font_manager_selections_load ((FontManagerSelections*) _tmp0_);
#line 572 "../lib/vala/FontConfig.vala"
	_tmp1_ = string_hashset_list ((StringHashset*) self);
#line 3895 "FontConfig.c"
	{
		GList* path_collection = NULL;
		GList* path_it = NULL;
#line 572 "../lib/vala/FontConfig.vala"
		path_collection = _tmp1_;
#line 572 "../lib/vala/FontConfig.vala"
		for (path_it = path_collection; path_it != NULL; path_it = path_it->next) {
#line 3903 "FontConfig.c"
			gchar* _tmp2_;
			gchar* path = NULL;
#line 572 "../lib/vala/FontConfig.vala"
			_tmp2_ = g_strdup ((const gchar*) path_it->data);
#line 572 "../lib/vala/FontConfig.vala"
			path = _tmp2_;
#line 3910 "FontConfig.c"
			{
				const gchar* _tmp3_;
#line 573 "../lib/vala/FontConfig.vala"
				_tmp3_ = path;
#line 573 "../lib/vala/FontConfig.vala"
				font_manager_sources_add_from_path (self, _tmp3_);
#line 572 "../lib/vala/FontConfig.vala"
				_g_free0 (path);
#line 3919 "FontConfig.c"
			}
		}
#line 572 "../lib/vala/FontConfig.vala"
		(path_collection == NULL) ? NULL : (path_collection = (_g_list_free__g_free0_ (path_collection), NULL));
#line 3924 "FontConfig.c"
	}
#line 574 "../lib/vala/FontConfig.vala"
	_tmp4_ = self->priv->_active;
#line 574 "../lib/vala/FontConfig.vala"
	_tmp5_ = string_hashset_list ((StringHashset*) _tmp4_);
#line 3930 "FontConfig.c"
	{
		GList* path_collection = NULL;
		GList* path_it = NULL;
#line 574 "../lib/vala/FontConfig.vala"
		path_collection = _tmp5_;
#line 574 "../lib/vala/FontConfig.vala"
		for (path_it = path_collection; path_it != NULL; path_it = path_it->next) {
#line 3938 "FontConfig.c"
			gchar* _tmp6_;
			gchar* path = NULL;
#line 574 "../lib/vala/FontConfig.vala"
			_tmp6_ = g_strdup ((const gchar*) path_it->data);
#line 574 "../lib/vala/FontConfig.vala"
			path = _tmp6_;
#line 3945 "FontConfig.c"
			{
				const gchar* _tmp7_;
#line 575 "../lib/vala/FontConfig.vala"
				_tmp7_ = path;
#line 575 "../lib/vala/FontConfig.vala"
				font_manager_sources_add_from_path (self, _tmp7_);
#line 574 "../lib/vala/FontConfig.vala"
				_g_free0 (path);
#line 3954 "FontConfig.c"
			}
		}
#line 574 "../lib/vala/FontConfig.vala"
		(path_collection == NULL) ? NULL : (path_collection = (_g_list_free__g_free0_ (path_collection), NULL));
#line 3959 "FontConfig.c"
	}
#line 576 "../lib/vala/FontConfig.vala"
	result = TRUE;
#line 576 "../lib/vala/FontConfig.vala"
	return result;
#line 3965 "FontConfig.c"
}

FontManagerDirectories*
font_manager_sources_get_active (FontManagerSources* self)
{
	FontManagerDirectories* result;
	FontManagerDirectories* _tmp0_;
#line 475 "../lib/vala/FontConfig.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 475 "../lib/vala/FontConfig.vala"
	_tmp0_ = self->priv->_active;
#line 475 "../lib/vala/FontConfig.vala"
	result = _tmp0_;
#line 475 "../lib/vala/FontConfig.vala"
	return result;
#line 3981 "FontConfig.c"
}

static void
font_manager_sources_set_active (FontManagerSources* self,
                                 FontManagerDirectories* value)
{
#line 475 "../lib/vala/FontConfig.vala"
	g_return_if_fail (self != NULL);
#line 475 "../lib/vala/FontConfig.vala"
	if (font_manager_sources_get_active (self) != value) {
#line 3992 "FontConfig.c"
		FontManagerDirectories* _tmp0_;
#line 475 "../lib/vala/FontConfig.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 475 "../lib/vala/FontConfig.vala"
		_g_object_unref0 (self->priv->_active);
#line 475 "../lib/vala/FontConfig.vala"
		self->priv->_active = _tmp0_;
#line 475 "../lib/vala/FontConfig.vala"
		g_object_notify_by_pspec ((GObject *) self, font_manager_sources_properties[FONT_MANAGER_SOURCES_ACTIVE_PROPERTY]);
#line 4002 "FontConfig.c"
	}
}

static inline gpointer
font_manager_sources_file_monitors_get_instance_private (FontManagerSourcesFileMonitors* self)
{
	return G_STRUCT_MEMBER_P (self, FontManagerSourcesFileMonitors_private_offset);
}

static gboolean
string_contains (const gchar* self,
                 const gchar* needle)
{
	gboolean result = FALSE;
	gchar* _tmp0_;
#line 1476 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1476 "glib-2.0.vapi"
	g_return_val_if_fail (needle != NULL, FALSE);
#line 1477 "glib-2.0.vapi"
	_tmp0_ = strstr ((gchar*) self, (gchar*) needle);
#line 1477 "glib-2.0.vapi"
	result = _tmp0_ != NULL;
#line 1477 "glib-2.0.vapi"
	return result;
#line 4028 "FontConfig.c"
}

static void
font_manager_sources_file_monitors_notify_on_mount_event (FontManagerSourcesFileMonitors* self,
                                                          GMount* mount)
{
	gchar* path = NULL;
	GFile* _tmp0_;
	GFile* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gboolean _tmp4_ = FALSE;
	const gchar* _tmp5_;
	GHashTable* _tmp8_;
	GList* _tmp9_;
#line 594 "../lib/vala/FontConfig.vala"
	g_return_if_fail (self != NULL);
#line 594 "../lib/vala/FontConfig.vala"
	g_return_if_fail (mount != NULL);
#line 595 "../lib/vala/FontConfig.vala"
	_tmp0_ = g_mount_get_default_location (mount);
#line 595 "../lib/vala/FontConfig.vala"
	_tmp1_ = _tmp0_;
#line 595 "../lib/vala/FontConfig.vala"
	_tmp2_ = g_file_get_path (_tmp1_);
#line 595 "../lib/vala/FontConfig.vala"
	_tmp3_ = _tmp2_;
#line 595 "../lib/vala/FontConfig.vala"
	_g_object_unref0 (_tmp1_);
#line 595 "../lib/vala/FontConfig.vala"
	path = _tmp3_;
#line 596 "../lib/vala/FontConfig.vala"
	_tmp5_ = path;
#line 596 "../lib/vala/FontConfig.vala"
	if (_tmp5_ == NULL) {
#line 596 "../lib/vala/FontConfig.vala"
		_tmp4_ = TRUE;
#line 4066 "FontConfig.c"
	} else {
		guint _tmp6_;
		guint _tmp7_;
#line 596 "../lib/vala/FontConfig.vala"
		_tmp6_ = font_manager_sources_file_monitors_get_size (self);
#line 596 "../lib/vala/FontConfig.vala"
		_tmp7_ = _tmp6_;
#line 596 "../lib/vala/FontConfig.vala"
		_tmp4_ = _tmp7_ < ((guint) 1);
#line 4076 "FontConfig.c"
	}
#line 596 "../lib/vala/FontConfig.vala"
	if (_tmp4_) {
#line 597 "../lib/vala/FontConfig.vala"
		_g_free0 (path);
#line 597 "../lib/vala/FontConfig.vala"
		return;
#line 4084 "FontConfig.c"
	}
#line 598 "../lib/vala/FontConfig.vala"
	_tmp8_ = self->priv->monitors;
#line 598 "../lib/vala/FontConfig.vala"
	_tmp9_ = g_hash_table_get_keys (_tmp8_);
#line 4090 "FontConfig.c"
	{
		GList* s_collection = NULL;
		GList* s_it = NULL;
#line 598 "../lib/vala/FontConfig.vala"
		s_collection = _tmp9_;
#line 598 "../lib/vala/FontConfig.vala"
		for (s_it = s_collection; s_it != NULL; s_it = s_it->next) {
#line 4098 "FontConfig.c"
			const gchar* s = NULL;
#line 598 "../lib/vala/FontConfig.vala"
			s = (const gchar*) s_it->data;
#line 4102 "FontConfig.c"
			{
				const gchar* _tmp10_;
				const gchar* _tmp11_;
#line 599 "../lib/vala/FontConfig.vala"
				_tmp10_ = s;
#line 599 "../lib/vala/FontConfig.vala"
				_tmp11_ = path;
#line 599 "../lib/vala/FontConfig.vala"
				if (string_contains (_tmp10_, _tmp11_)) {
#line 4112 "FontConfig.c"
					GFile* _tmp12_;
					GFile* _tmp13_;
#line 600 "../lib/vala/FontConfig.vala"
					_tmp12_ = g_mount_get_root (mount);
#line 600 "../lib/vala/FontConfig.vala"
					_tmp13_ = _tmp12_;
#line 600 "../lib/vala/FontConfig.vala"
					g_signal_emit (self, font_manager_sources_file_monitors_signals[FONT_MANAGER_SOURCES_FILE_MONITORS_CHANGED_SIGNAL], 0, _tmp13_, NULL, G_FILE_MONITOR_EVENT_CHANGED);
#line 600 "../lib/vala/FontConfig.vala"
					_g_object_unref0 (_tmp13_);
#line 4123 "FontConfig.c"
				}
			}
		}
#line 598 "../lib/vala/FontConfig.vala"
		(s_collection == NULL) ? NULL : (s_collection = (g_list_free (s_collection), NULL));
#line 4129 "FontConfig.c"
	}
#line 603 "../lib/vala/FontConfig.vala"
	_g_free0 (path);
#line 603 "../lib/vala/FontConfig.vala"
	return;
#line 4135 "FontConfig.c"
}

static void
___lambda26_ (FontManagerSourcesFileMonitors* self,
              GFile* f,
              GFile* of,
              GFileMonitorEvent ev)
{
#line 629 "../lib/vala/FontConfig.vala"
	g_return_if_fail (f != NULL);
#line 629 "../lib/vala/FontConfig.vala"
	g_signal_emit (self, font_manager_sources_file_monitors_signals[FONT_MANAGER_SOURCES_FILE_MONITORS_CHANGED_SIGNAL], 0, f, of, ev);
#line 4148 "FontConfig.c"
}

static void
____lambda26__g_file_monitor_changed (GFileMonitor* _sender,
                                      GFile* file,
                                      GFile* other_file,
                                      GFileMonitorEvent event_type,
                                      gpointer self)
{
#line 629 "../lib/vala/FontConfig.vala"
	___lambda26_ ((FontManagerSourcesFileMonitors*) self, file, other_file, event_type);
#line 4160 "FontConfig.c"
}

gboolean
font_manager_sources_file_monitors_add (FontManagerSourcesFileMonitors* self,
                                        const gchar* path)
{
	gboolean result = FALSE;
	GHashTable* _tmp0_;
	GHashTable* _tmp16_;
	GError* _inner_error0_ = NULL;
#line 620 "../lib/vala/FontConfig.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 620 "../lib/vala/FontConfig.vala"
	g_return_val_if_fail (path != NULL, FALSE);
#line 621 "../lib/vala/FontConfig.vala"
	_tmp0_ = self->priv->monitors;
#line 621 "../lib/vala/FontConfig.vala"
	if (g_hash_table_contains (_tmp0_, path)) {
#line 622 "../lib/vala/FontConfig.vala"
		result = TRUE;
#line 622 "../lib/vala/FontConfig.vala"
		return result;
#line 4183 "FontConfig.c"
	}
	{
		GFile* file = NULL;
		GFile* _tmp1_;
		GFileMonitor* monitor = NULL;
		GFile* _tmp2_;
		GFileMonitor* _tmp3_;
		GFileMonitor* _tmp4_;
		GHashTable* _tmp5_;
		gchar* _tmp6_;
		GFileMonitor* _tmp7_;
		GFileMonitor* _tmp8_;
		GHashTable* _tmp9_;
		gconstpointer _tmp10_;
		GFileMonitor* _tmp11_;
		GFileMonitor* _tmp12_;
#line 624 "../lib/vala/FontConfig.vala"
		_tmp1_ = g_file_new_for_path (path);
#line 624 "../lib/vala/FontConfig.vala"
		file = _tmp1_;
#line 625 "../lib/vala/FontConfig.vala"
		_tmp2_ = file;
#line 625 "../lib/vala/FontConfig.vala"
		_tmp3_ = g_file_monitor (_tmp2_, G_FILE_MONITOR_WATCH_MOUNTS, NULL, &_inner_error0_);
#line 625 "../lib/vala/FontConfig.vala"
		monitor = _tmp3_;
#line 625 "../lib/vala/FontConfig.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 625 "../lib/vala/FontConfig.vala"
			_g_object_unref0 (file);
#line 4214 "FontConfig.c"
			goto __catch8_g_error;
		}
#line 626 "../lib/vala/FontConfig.vala"
		_tmp4_ = monitor;
#line 626 "../lib/vala/FontConfig.vala"
		_vala_assert (_tmp4_ != NULL, "monitor != null");
#line 627 "../lib/vala/FontConfig.vala"
		_tmp5_ = self->priv->monitors;
#line 627 "../lib/vala/FontConfig.vala"
		_tmp6_ = g_strdup (path);
#line 627 "../lib/vala/FontConfig.vala"
		_tmp7_ = monitor;
#line 627 "../lib/vala/FontConfig.vala"
		_tmp8_ = _g_object_ref0 (_tmp7_);
#line 627 "../lib/vala/FontConfig.vala"
		g_hash_table_insert (_tmp5_, _tmp6_, _tmp8_);
#line 628 "../lib/vala/FontConfig.vala"
		_tmp9_ = self->priv->monitors;
#line 628 "../lib/vala/FontConfig.vala"
		_tmp10_ = g_hash_table_lookup (_tmp9_, path);
#line 628 "../lib/vala/FontConfig.vala"
		_vala_assert (((GFileMonitor*) _tmp10_) != NULL, "monitors.lookup(path) != null");
#line 629 "../lib/vala/FontConfig.vala"
		_tmp11_ = monitor;
#line 629 "../lib/vala/FontConfig.vala"
		g_signal_connect_object (_tmp11_, "changed", (GCallback) ____lambda26__g_file_monitor_changed, self, 0);
#line 630 "../lib/vala/FontConfig.vala"
		_tmp12_ = monitor;
#line 630 "../lib/vala/FontConfig.vala"
		g_file_monitor_set_rate_limit (_tmp12_, 3000);
#line 623 "../lib/vala/FontConfig.vala"
		_g_object_unref0 (monitor);
#line 623 "../lib/vala/FontConfig.vala"
		_g_object_unref0 (file);
#line 4249 "FontConfig.c"
	}
	goto __finally8;
	__catch8_g_error:
	{
		GError* e = NULL;
		GError* _tmp13_;
		const gchar* _tmp14_;
#line 623 "../lib/vala/FontConfig.vala"
		e = _inner_error0_;
#line 623 "../lib/vala/FontConfig.vala"
		_inner_error0_ = NULL;
#line 632 "../lib/vala/FontConfig.vala"
		_tmp13_ = e;
#line 632 "../lib/vala/FontConfig.vala"
		_tmp14_ = _tmp13_->message;
#line 632 "../lib/vala/FontConfig.vala"
		g_warning ("FontConfig.vala:632: Failed to create FileMonitor for %s : %s", path, _tmp14_);
#line 633 "../lib/vala/FontConfig.vala"
		result = FALSE;
#line 633 "../lib/vala/FontConfig.vala"
		_g_error_free0 (e);
#line 633 "../lib/vala/FontConfig.vala"
		return result;
#line 4273 "FontConfig.c"
	}
	__finally8:
#line 623 "../lib/vala/FontConfig.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 4278 "FontConfig.c"
		gboolean _tmp15_ = FALSE;
#line 623 "../lib/vala/FontConfig.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 623 "../lib/vala/FontConfig.vala"
		g_clear_error (&_inner_error0_);
#line 623 "../lib/vala/FontConfig.vala"
		return _tmp15_;
#line 4286 "FontConfig.c"
	}
#line 635 "../lib/vala/FontConfig.vala"
	_tmp16_ = self->priv->monitors;
#line 635 "../lib/vala/FontConfig.vala"
	if (!g_hash_table_contains (_tmp16_, path)) {
#line 636 "../lib/vala/FontConfig.vala"
		result = FALSE;
#line 636 "../lib/vala/FontConfig.vala"
		return result;
#line 4296 "FontConfig.c"
	}
#line 637 "../lib/vala/FontConfig.vala"
	result = TRUE;
#line 637 "../lib/vala/FontConfig.vala"
	return result;
#line 4302 "FontConfig.c"
}

gboolean
font_manager_sources_file_monitors_remove (FontManagerSourcesFileMonitors* self,
                                           const gchar* path)
{
	gboolean result = FALSE;
	GFileMonitor* monitor = NULL;
	GHashTable* _tmp0_;
	gconstpointer _tmp1_;
	GFileMonitor* _tmp2_;
	GFileMonitor* _tmp3_;
	GHashTable* _tmp5_;
#line 640 "../lib/vala/FontConfig.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 640 "../lib/vala/FontConfig.vala"
	g_return_val_if_fail (path != NULL, FALSE);
#line 641 "../lib/vala/FontConfig.vala"
	_tmp0_ = self->priv->monitors;
#line 641 "../lib/vala/FontConfig.vala"
	_tmp1_ = g_hash_table_lookup (_tmp0_, path);
#line 641 "../lib/vala/FontConfig.vala"
	_tmp2_ = _g_object_ref0 ((GFileMonitor*) _tmp1_);
#line 641 "../lib/vala/FontConfig.vala"
	monitor = _tmp2_;
#line 642 "../lib/vala/FontConfig.vala"
	_tmp3_ = monitor;
#line 642 "../lib/vala/FontConfig.vala"
	if (_tmp3_ != NULL) {
#line 4332 "FontConfig.c"
		GFileMonitor* _tmp4_;
#line 643 "../lib/vala/FontConfig.vala"
		_tmp4_ = monitor;
#line 643 "../lib/vala/FontConfig.vala"
		g_file_monitor_cancel (_tmp4_);
#line 4338 "FontConfig.c"
	}
#line 644 "../lib/vala/FontConfig.vala"
	_tmp5_ = self->priv->monitors;
#line 644 "../lib/vala/FontConfig.vala"
	result = g_hash_table_remove (_tmp5_, path);
#line 644 "../lib/vala/FontConfig.vala"
	_g_object_unref0 (monitor);
#line 644 "../lib/vala/FontConfig.vala"
	return result;
#line 4348 "FontConfig.c"
}

FontManagerSourcesFileMonitors*
font_manager_sources_file_monitors_construct (GType object_type)
{
	FontManagerSourcesFileMonitors * self = NULL;
#line 579 "../lib/vala/FontConfig.vala"
	self = (FontManagerSourcesFileMonitors*) g_object_new (object_type, NULL);
#line 579 "../lib/vala/FontConfig.vala"
	return self;
#line 4359 "FontConfig.c"
}

FontManagerSourcesFileMonitors*
font_manager_sources_file_monitors_new (void)
{
#line 579 "../lib/vala/FontConfig.vala"
	return font_manager_sources_file_monitors_construct (FONT_MANAGER_SOURCES_TYPE_FILE_MONITORS);
#line 4367 "FontConfig.c"
}

guint
font_manager_sources_file_monitors_get_size (FontManagerSourcesFileMonitors* self)
{
	guint result;
	GHashTable* _tmp0_;
#line 585 "../lib/vala/FontConfig.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 586 "../lib/vala/FontConfig.vala"
	_tmp0_ = self->priv->monitors;
#line 586 "../lib/vala/FontConfig.vala"
	result = g_hash_table_size (_tmp0_);
#line 586 "../lib/vala/FontConfig.vala"
	return result;
#line 4383 "FontConfig.c"
}

static void
g_cclosure_user_marshal_VOID__OBJECT_OBJECT_ENUM (GClosure * closure,
                                                  GValue * return_value,
                                                  guint n_param_values,
                                                  const GValue * param_values,
                                                  gpointer invocation_hint,
                                                  gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__OBJECT_OBJECT_ENUM) (gpointer data1, gpointer arg_1, gpointer arg_2, gint arg_3, gpointer data2);
	register GMarshalFunc_VOID__OBJECT_OBJECT_ENUM callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
#line 579 "../lib/vala/FontConfig.vala"
	g_return_if_fail (n_param_values == 4);
#line 579 "../lib/vala/FontConfig.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 579 "../lib/vala/FontConfig.vala"
		data1 = closure->data;
#line 579 "../lib/vala/FontConfig.vala"
		data2 = param_values->data[0].v_pointer;
#line 4408 "FontConfig.c"
	} else {
#line 579 "../lib/vala/FontConfig.vala"
		data1 = param_values->data[0].v_pointer;
#line 579 "../lib/vala/FontConfig.vala"
		data2 = closure->data;
#line 4414 "FontConfig.c"
	}
#line 579 "../lib/vala/FontConfig.vala"
	callback = (GMarshalFunc_VOID__OBJECT_OBJECT_ENUM) (marshal_data ? marshal_data : cc->callback);
#line 579 "../lib/vala/FontConfig.vala"
	callback (data1, g_value_get_object (param_values + 1), g_value_get_object (param_values + 2), g_value_get_enum (param_values + 3), data2);
#line 4420 "FontConfig.c"
}

static void
_font_manager_sources_file_monitors___lambda27_ (FontManagerSourcesFileMonitors* self,
                                                 GMount* m)
{
#line 609 "../lib/vala/FontConfig.vala"
	g_return_if_fail (m != NULL);
#line 610 "../lib/vala/FontConfig.vala"
	font_manager_sources_file_monitors_notify_on_mount_event (self, m);
#line 4431 "FontConfig.c"
}

static void
__font_manager_sources_file_monitors___lambda27__g_volume_monitor_mount_added (GVolumeMonitor* _sender,
                                                                               GMount* mount,
                                                                               gpointer self)
{
#line 609 "../lib/vala/FontConfig.vala"
	_font_manager_sources_file_monitors___lambda27_ ((FontManagerSourcesFileMonitors*) self, mount);
#line 4441 "FontConfig.c"
}

static void
_font_manager_sources_file_monitors___lambda28_ (FontManagerSourcesFileMonitors* self,
                                                 GMount* m)
{
#line 612 "../lib/vala/FontConfig.vala"
	g_return_if_fail (m != NULL);
#line 613 "../lib/vala/FontConfig.vala"
	font_manager_sources_file_monitors_notify_on_mount_event (self, m);
#line 4452 "FontConfig.c"
}

static void
__font_manager_sources_file_monitors___lambda28__g_volume_monitor_mount_changed (GVolumeMonitor* _sender,
                                                                                 GMount* mount,
                                                                                 gpointer self)
{
#line 612 "../lib/vala/FontConfig.vala"
	_font_manager_sources_file_monitors___lambda28_ ((FontManagerSourcesFileMonitors*) self, mount);
#line 4462 "FontConfig.c"
}

static void
_font_manager_sources_file_monitors___lambda29_ (FontManagerSourcesFileMonitors* self,
                                                 GMount* m)
{
#line 615 "../lib/vala/FontConfig.vala"
	g_return_if_fail (m != NULL);
#line 616 "../lib/vala/FontConfig.vala"
	font_manager_sources_file_monitors_notify_on_mount_event (self, m);
#line 4473 "FontConfig.c"
}

static void
__font_manager_sources_file_monitors___lambda29__g_volume_monitor_mount_removed (GVolumeMonitor* _sender,
                                                                                 GMount* mount,
                                                                                 gpointer self)
{
#line 615 "../lib/vala/FontConfig.vala"
	_font_manager_sources_file_monitors___lambda29_ ((FontManagerSourcesFileMonitors*) self, mount);
#line 4483 "FontConfig.c"
}

static GObject *
font_manager_sources_file_monitors_constructor (GType type,
                                                guint n_construct_properties,
                                                GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	FontManagerSourcesFileMonitors * self;
	GHashFunc _tmp0_;
	GEqualFunc _tmp1_;
	GHashTable* _tmp2_;
	GVolumeMonitor* _tmp3_;
	GVolumeMonitor* _tmp4_;
	GVolumeMonitor* _tmp5_;
	GVolumeMonitor* _tmp6_;
#line 606 "../lib/vala/FontConfig.vala"
	parent_class = G_OBJECT_CLASS (font_manager_sources_file_monitors_parent_class);
#line 606 "../lib/vala/FontConfig.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 606 "../lib/vala/FontConfig.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, FONT_MANAGER_SOURCES_TYPE_FILE_MONITORS, FontManagerSourcesFileMonitors);
#line 607 "../lib/vala/FontConfig.vala"
	_tmp0_ = g_str_hash;
#line 607 "../lib/vala/FontConfig.vala"
	_tmp1_ = g_str_equal;
#line 607 "../lib/vala/FontConfig.vala"
	_tmp2_ = g_hash_table_new_full (_tmp0_, _tmp1_, _g_free0_, _g_object_unref0_);
#line 607 "../lib/vala/FontConfig.vala"
	_g_hash_table_unref0 (self->priv->monitors);
#line 607 "../lib/vala/FontConfig.vala"
	self->priv->monitors = _tmp2_;
#line 608 "../lib/vala/FontConfig.vala"
	_tmp3_ = g_volume_monitor_get ();
#line 608 "../lib/vala/FontConfig.vala"
	_g_object_unref0 (self->priv->volume_monitor);
#line 608 "../lib/vala/FontConfig.vala"
	self->priv->volume_monitor = _tmp3_;
#line 609 "../lib/vala/FontConfig.vala"
	_tmp4_ = self->priv->volume_monitor;
#line 609 "../lib/vala/FontConfig.vala"
	g_signal_connect_object (_tmp4_, "mount-added", (GCallback) __font_manager_sources_file_monitors___lambda27__g_volume_monitor_mount_added, self, 0);
#line 612 "../lib/vala/FontConfig.vala"
	_tmp5_ = self->priv->volume_monitor;
#line 612 "../lib/vala/FontConfig.vala"
	g_signal_connect_object (_tmp5_, "mount-changed", (GCallback) __font_manager_sources_file_monitors___lambda28__g_volume_monitor_mount_changed, self, 0);
#line 615 "../lib/vala/FontConfig.vala"
	_tmp6_ = self->priv->volume_monitor;
#line 615 "../lib/vala/FontConfig.vala"
	g_signal_connect_object (_tmp6_, "mount-removed", (GCallback) __font_manager_sources_file_monitors___lambda29__g_volume_monitor_mount_removed, self, 0);
#line 606 "../lib/vala/FontConfig.vala"
	return obj;
#line 4537 "FontConfig.c"
}

static void
font_manager_sources_file_monitors_class_init (FontManagerSourcesFileMonitorsClass * klass,
                                               gpointer klass_data)
{
#line 579 "../lib/vala/FontConfig.vala"
	font_manager_sources_file_monitors_parent_class = g_type_class_peek_parent (klass);
#line 579 "../lib/vala/FontConfig.vala"
	g_type_class_adjust_private_offset (klass, &FontManagerSourcesFileMonitors_private_offset);
#line 579 "../lib/vala/FontConfig.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_font_manager_sources_file_monitors_get_property;
#line 579 "../lib/vala/FontConfig.vala"
	G_OBJECT_CLASS (klass)->constructor = font_manager_sources_file_monitors_constructor;
#line 579 "../lib/vala/FontConfig.vala"
	G_OBJECT_CLASS (klass)->finalize = font_manager_sources_file_monitors_finalize;
#line 579 "../lib/vala/FontConfig.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), FONT_MANAGER_SOURCES_FILE_MONITORS_SIZE_PROPERTY, font_manager_sources_file_monitors_properties[FONT_MANAGER_SOURCES_FILE_MONITORS_SIZE_PROPERTY] = g_param_spec_uint ("size", "size", "size", 0, G_MAXUINT, 0U, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 579 "../lib/vala/FontConfig.vala"
	font_manager_sources_file_monitors_signals[FONT_MANAGER_SOURCES_FILE_MONITORS_CHANGED_SIGNAL] = g_signal_new ("changed", FONT_MANAGER_SOURCES_TYPE_FILE_MONITORS, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__OBJECT_OBJECT_ENUM, G_TYPE_NONE, 3, g_file_get_type (), g_file_get_type (), g_file_monitor_event_get_type ());
#line 4558 "FontConfig.c"
}

static void
font_manager_sources_file_monitors_instance_init (FontManagerSourcesFileMonitors * self,
                                                  gpointer klass)
{
#line 579 "../lib/vala/FontConfig.vala"
	self->priv = font_manager_sources_file_monitors_get_instance_private (self);
#line 4567 "FontConfig.c"
}

static void
font_manager_sources_file_monitors_finalize (GObject * obj)
{
	FontManagerSourcesFileMonitors * self;
#line 579 "../lib/vala/FontConfig.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, FONT_MANAGER_SOURCES_TYPE_FILE_MONITORS, FontManagerSourcesFileMonitors);
#line 590 "../lib/vala/FontConfig.vala"
	_g_object_unref0 (self->priv->volume_monitor);
#line 591 "../lib/vala/FontConfig.vala"
	_g_hash_table_unref0 (self->priv->monitors);
#line 579 "../lib/vala/FontConfig.vala"
	G_OBJECT_CLASS (font_manager_sources_file_monitors_parent_class)->finalize (obj);
#line 4582 "FontConfig.c"
}

GType
font_manager_sources_file_monitors_get_type (void)
{
	static volatile gsize font_manager_sources_file_monitors_type_id__volatile = 0;
	if (g_once_init_enter (&font_manager_sources_file_monitors_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (FontManagerSourcesFileMonitorsClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) font_manager_sources_file_monitors_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (FontManagerSourcesFileMonitors), 0, (GInstanceInitFunc) font_manager_sources_file_monitors_instance_init, NULL };
		GType font_manager_sources_file_monitors_type_id;
		font_manager_sources_file_monitors_type_id = g_type_register_static (G_TYPE_OBJECT, "FontManagerSourcesFileMonitors", &g_define_type_info, 0);
		FontManagerSourcesFileMonitors_private_offset = g_type_add_instance_private (font_manager_sources_file_monitors_type_id, sizeof (FontManagerSourcesFileMonitorsPrivate));
		g_once_init_leave (&font_manager_sources_file_monitors_type_id__volatile, font_manager_sources_file_monitors_type_id);
	}
	return font_manager_sources_file_monitors_type_id__volatile;
}

static void
_vala_font_manager_sources_file_monitors_get_property (GObject * object,
                                                       guint property_id,
                                                       GValue * value,
                                                       GParamSpec * pspec)
{
	FontManagerSourcesFileMonitors * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, FONT_MANAGER_SOURCES_TYPE_FILE_MONITORS, FontManagerSourcesFileMonitors);
#line 579 "../lib/vala/FontConfig.vala"
	switch (property_id) {
#line 579 "../lib/vala/FontConfig.vala"
		case FONT_MANAGER_SOURCES_FILE_MONITORS_SIZE_PROPERTY:
#line 579 "../lib/vala/FontConfig.vala"
		g_value_set_uint (value, font_manager_sources_file_monitors_get_size (self));
#line 579 "../lib/vala/FontConfig.vala"
		break;
#line 4615 "FontConfig.c"
		default:
#line 579 "../lib/vala/FontConfig.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 579 "../lib/vala/FontConfig.vala"
		break;
#line 4621 "FontConfig.c"
	}
}

static void
font_manager_sources_class_init (FontManagerSourcesClass * klass,
                                 gpointer klass_data)
{
#line 467 "../lib/vala/FontConfig.vala"
	font_manager_sources_parent_class = g_type_class_peek_parent (klass);
#line 467 "../lib/vala/FontConfig.vala"
	g_type_class_adjust_private_offset (klass, &FontManagerSources_private_offset);
#line 467 "../lib/vala/FontConfig.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_font_manager_sources_get_property;
#line 467 "../lib/vala/FontConfig.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_font_manager_sources_set_property;
#line 467 "../lib/vala/FontConfig.vala"
	G_OBJECT_CLASS (klass)->finalize = font_manager_sources_finalize;
#line 4639 "FontConfig.c"
	/**
	         * Sources:active:
	         *
	         * #Directories instance, required in order to update FontConfig
	         * directory configuration whenever a #Source is activated/deactivated.
	         */
#line 467 "../lib/vala/FontConfig.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), FONT_MANAGER_SOURCES_ACTIVE_PROPERTY, font_manager_sources_properties[FONT_MANAGER_SOURCES_ACTIVE_PROPERTY] = g_param_spec_object ("active", "active", "active", FONT_MANAGER_TYPE_DIRECTORIES, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 4648 "FontConfig.c"
}

static void
font_manager_sources_instance_init (FontManagerSources * self,
                                    gpointer klass)
{
#line 467 "../lib/vala/FontConfig.vala"
	self->priv = font_manager_sources_get_instance_private (self);
#line 4657 "FontConfig.c"
}

static void
font_manager_sources_finalize (GObject * obj)
{
	FontManagerSources * self;
#line 467 "../lib/vala/FontConfig.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, FONT_MANAGER_TYPE_SOURCES, FontManagerSources);
#line 475 "../lib/vala/FontConfig.vala"
	_g_object_unref0 (self->priv->_active);
#line 477 "../lib/vala/FontConfig.vala"
	_g_object_unref0 (self->priv->monitors);
#line 478 "../lib/vala/FontConfig.vala"
	_g_hash_table_unref0 (self->priv->sources);
#line 467 "../lib/vala/FontConfig.vala"
	G_OBJECT_CLASS (font_manager_sources_parent_class)->finalize (obj);
#line 4674 "FontConfig.c"
}

/**
     * Sources - Represents an application specific configuration file
     *
     * <source> elements contain the full path to a directory containing
     * font files which should be available for preview within the application
     * and easily enabled for others.
     *
     * @seealso     load_user_font_sources ()
     */
GType
font_manager_sources_get_type (void)
{
	static volatile gsize font_manager_sources_type_id__volatile = 0;
	if (g_once_init_enter (&font_manager_sources_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (FontManagerSourcesClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) font_manager_sources_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (FontManagerSources), 0, (GInstanceInitFunc) font_manager_sources_instance_init, NULL };
		GType font_manager_sources_type_id;
		font_manager_sources_type_id = g_type_register_static (FONT_MANAGER_TYPE_DIRECTORIES, "FontManagerSources", &g_define_type_info, 0);
		FontManagerSources_private_offset = g_type_add_instance_private (font_manager_sources_type_id, sizeof (FontManagerSourcesPrivate));
		g_once_init_leave (&font_manager_sources_type_id__volatile, font_manager_sources_type_id);
	}
	return font_manager_sources_type_id__volatile;
}

static void
_vala_font_manager_sources_get_property (GObject * object,
                                         guint property_id,
                                         GValue * value,
                                         GParamSpec * pspec)
{
	FontManagerSources * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, FONT_MANAGER_TYPE_SOURCES, FontManagerSources);
#line 467 "../lib/vala/FontConfig.vala"
	switch (property_id) {
#line 467 "../lib/vala/FontConfig.vala"
		case FONT_MANAGER_SOURCES_ACTIVE_PROPERTY:
#line 467 "../lib/vala/FontConfig.vala"
		g_value_set_object (value, font_manager_sources_get_active (self));
#line 467 "../lib/vala/FontConfig.vala"
		break;
#line 4716 "FontConfig.c"
		default:
#line 467 "../lib/vala/FontConfig.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 467 "../lib/vala/FontConfig.vala"
		break;
#line 4722 "FontConfig.c"
	}
}

static void
_vala_font_manager_sources_set_property (GObject * object,
                                         guint property_id,
                                         const GValue * value,
                                         GParamSpec * pspec)
{
	FontManagerSources * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, FONT_MANAGER_TYPE_SOURCES, FontManagerSources);
#line 467 "../lib/vala/FontConfig.vala"
	switch (property_id) {
#line 467 "../lib/vala/FontConfig.vala"
		case FONT_MANAGER_SOURCES_ACTIVE_PROPERTY:
#line 467 "../lib/vala/FontConfig.vala"
		font_manager_sources_set_active (self, g_value_get_object (value));
#line 467 "../lib/vala/FontConfig.vala"
		break;
#line 4742 "FontConfig.c"
		default:
#line 467 "../lib/vala/FontConfig.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 467 "../lib/vala/FontConfig.vala"
		break;
#line 4748 "FontConfig.c"
	}
}

